package dnibuilder;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import com.google.common.io.CharStreams;
import dnibuilder.CaseStudy;
import dnibuilder.Generator;
import dnibuilder.IPPair;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;

@SuppressWarnings("all")
public class CaseStudies {
  private List<CaseStudy> caseStudyObjects = new ArrayList<CaseStudy>();
  
  public List<CaseStudy> getCaseStudies() {
    return this.caseStudyObjects;
  }
  
  public void read(final List<String> list) {
    final Function1<String, String> _function = new Function1<String, String>() {
      @Override
      public String apply(final String fn) {
        String[] _split = fn.split("_data");
        return _split[0];
      }
    };
    List<String> _map = ListExtensions.<String, String>map(list, _function);
    final Set<String> caseStudyNames = IterableExtensions.<String>toSet(_map);
    final Function1<String, CaseStudy> _function_1 = new Function1<String, CaseStudy>() {
      @Override
      public CaseStudy apply(final String csn) {
        final Function1<String, Boolean> _function = new Function1<String, Boolean>() {
          @Override
          public Boolean apply(final String fn) {
            return Boolean.valueOf(fn.startsWith(csn));
          }
        };
        Iterable<String> _filter = IterableExtensions.<String>filter(list, _function);
        List<String> _list = IterableExtensions.<String>toList(_filter);
        ArrayList<IPPair> _arrayList = new ArrayList<IPPair>();
        return new CaseStudy(csn, _list, _arrayList);
      }
    };
    Iterable<CaseStudy> _map_1 = IterableExtensions.<String, CaseStudy>map(caseStudyNames, _function_1);
    Iterables.<CaseStudy>addAll(this.caseStudyObjects, _map_1);
    this.extractFlows();
  }
  
  public void extractFlows() {
    for (final CaseStudy cso : this.caseStudyObjects) {
      List<String> _orgPcapngFileNames = cso.getOrgPcapngFileNames();
      for (final String pcapngName : _orgPcapngFileNames) {
        List<IPPair> _ippairs = cso.getIppairs();
        ArrayList<Generator> _arrayList = new ArrayList<Generator>();
        IPPair _iPPair = new IPPair(pcapngName, _arrayList);
        _ippairs.add(_iPPair);
      }
    }
  }
  
  public void extractGenerators(final String directory) {
    for (final CaseStudy cso : this.caseStudyObjects) {
      List<IPPair> _ippairs = cso.getIppairs();
      for (final IPPair ippair : _ippairs) {
        {
          String _name = ippair.getName();
          final String path = ((directory + "/") + _name);
          List<Generator> _generators = ippair.getGenerators();
          Iterable<Generator> _generatorsFromFile = this.getGeneratorsFromFile(path);
          Iterables.<Generator>addAll(_generators, _generatorsFromFile);
        }
      }
    }
  }
  
  public Iterable<Generator> getGeneratorsFromFile(final String fname) {
    try {
      FileReader _fileReader = new FileReader(fname);
      List<String> _readLines = CharStreams.readLines(_fileReader);
      final Function1<String, Generator> _function = new Function1<String, Generator>() {
        @Override
        public Generator apply(final String line) {
          return CaseStudies.this.extractGeneratorFromLine(line);
        }
      };
      List<Generator> _map = ListExtensions.<String, Generator>map(_readLines, _function);
      final Function1<Generator, Boolean> _function_1 = new Function1<Generator, Boolean>() {
        @Override
        public Boolean apply(final Generator g) {
          return Boolean.valueOf((!Objects.equal(g, null)));
        }
      };
      return IterableExtensions.<Generator>filter(_map, _function_1);
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public Generator extractGeneratorFromLine(final String line) {
    boolean _startsWith = line.startsWith("scale");
    if (_startsWith) {
      return null;
    } else {
      boolean _isEmpty = line.isEmpty();
      boolean _not = (!_isEmpty);
      if (_not) {
        String[] _split = line.split(",");
        final Iterator<String> segments = ((List<String>)Conversions.doWrapArray(_split)).iterator();
        String _next = segments.next();
        int _parseInt = Integer.parseInt(_next);
        String _next_1 = segments.next();
        int _parseInt_1 = Integer.parseInt(_next_1);
        String _next_2 = segments.next();
        double _parseDouble = Double.parseDouble(_next_2);
        String _next_3 = segments.next();
        double _parseDouble_1 = Double.parseDouble(_next_3);
        return new Generator(
          "genname", _parseInt, _parseInt_1, _parseDouble, _parseDouble_1);
      }
    }
    return null;
  }
}
