package dnibuilder;

import dnibuilder.IPPair;
import java.util.List;
import org.eclipse.xtend.lib.annotations.Data;
import org.eclipse.xtext.xbase.lib.Pure;
import org.eclipse.xtext.xbase.lib.util.ToStringBuilder;

@Data
@SuppressWarnings("all")
public class CaseStudy {
  private final String orgPcapngFileNamePrefix;
  
  private final List<String> orgPcapngFileNames;
  
  private final List<IPPair> ippairs;
  
  public CaseStudy(final String orgPcapngFileNamePrefix, final List<String> orgPcapngFileNames, final List<IPPair> ippairs) {
    super();
    this.orgPcapngFileNamePrefix = orgPcapngFileNamePrefix;
    this.orgPcapngFileNames = orgPcapngFileNames;
    this.ippairs = ippairs;
  }
  
  @Override
  @Pure
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((this.orgPcapngFileNamePrefix== null) ? 0 : this.orgPcapngFileNamePrefix.hashCode());
    result = prime * result + ((this.orgPcapngFileNames== null) ? 0 : this.orgPcapngFileNames.hashCode());
    result = prime * result + ((this.ippairs== null) ? 0 : this.ippairs.hashCode());
    return result;
  }
  
  @Override
  @Pure
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    CaseStudy other = (CaseStudy) obj;
    if (this.orgPcapngFileNamePrefix == null) {
      if (other.orgPcapngFileNamePrefix != null)
        return false;
    } else if (!this.orgPcapngFileNamePrefix.equals(other.orgPcapngFileNamePrefix))
      return false;
    if (this.orgPcapngFileNames == null) {
      if (other.orgPcapngFileNames != null)
        return false;
    } else if (!this.orgPcapngFileNames.equals(other.orgPcapngFileNames))
      return false;
    if (this.ippairs == null) {
      if (other.ippairs != null)
        return false;
    } else if (!this.ippairs.equals(other.ippairs))
      return false;
    return true;
  }
  
  @Override
  @Pure
  public String toString() {
    ToStringBuilder b = new ToStringBuilder(this);
    b.add("orgPcapngFileNamePrefix", this.orgPcapngFileNamePrefix);
    b.add("orgPcapngFileNames", this.orgPcapngFileNames);
    b.add("ippairs", this.ippairs);
    return b.toString();
  }
  
  @Pure
  public String getOrgPcapngFileNamePrefix() {
    return this.orgPcapngFileNamePrefix;
  }
  
  @Pure
  public List<String> getOrgPcapngFileNames() {
    return this.orgPcapngFileNames;
  }
  
  @Pure
  public List<IPPair> getIppairs() {
    return this.ippairs;
  }
}
