package dnibuilder;

import DNImaster.NetworkInfrastructure;
import dnibuilder.CaseStudies;
import dnibuilder.CaseStudy;
import dnibuilder.DirectoryParser;
import dnibuilder.NetworkTrafficModelInstanceGenerator;
import java.io.FileOutputStream;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class DNIBuilder {
  public static void main(final String[] args) {
    DNIBuilder _dNIBuilder = new DNIBuilder();
    _dNIBuilder.buildDNI();
  }
  
  public XMIResourceImpl buildDNI() {
    XMIResourceImpl _xblockexpression = null;
    {
      final DirectoryParser dp = new DirectoryParser();
      final String directory = "/Users/Piotr/kit-svn/papers-bitbucket/paper-1-traffic-model-extraction/data_felix/data";
      final List<String> list_of_files = dp.parse(directory);
      InputOutput.<String>println(("files " + list_of_files));
      final CaseStudies cs = new CaseStudies();
      cs.read(list_of_files);
      cs.extractGenerators(directory);
      List<CaseStudy> _caseStudies = cs.getCaseStudies();
      String _plus = ("case studies " + _caseStudies);
      InputOutput.<String>println(_plus);
      final NetworkTrafficModelInstanceGenerator gen = new NetworkTrafficModelInstanceGenerator();
      List<CaseStudy> _caseStudies_1 = cs.getCaseStudies();
      CaseStudy _get = _caseStudies_1.get(0);
      final NetworkInfrastructure niModel = gen.generate(_get);
      XMIResourceImpl _xMIResourceImpl = new XMIResourceImpl();
      final Procedure1<XMIResourceImpl> _function = new Procedure1<XMIResourceImpl>() {
        @Override
        public void apply(final XMIResourceImpl it) {
          try {
            EList<EObject> _contents = it.getContents();
            _contents.add(niModel);
            FileOutputStream _fileOutputStream = new FileOutputStream("./generated-traffic-model.xmi");
            it.save(_fileOutputStream, null);
          } catch (Throwable _e) {
            throw Exceptions.sneakyThrow(_e);
          }
        }
      };
      _xblockexpression = ObjectExtensions.<XMIResourceImpl>operator_doubleArrow(_xMIResourceImpl, _function);
    }
    return _xblockexpression;
  }
}
