package dnibuilder;

import org.eclipse.xtend.lib.annotations.Data;
import org.eclipse.xtext.xbase.lib.Pure;

@Data
@SuppressWarnings("all")
public class Generator {
  private final String name;
  
  private final int scale;
  
  private final int value;
  
  private final double begin;
  
  private final double end;
  
  @Override
  public String toString() {
    return (((((((("GEN(B=" + Double.valueOf(this.begin)) + ", S=") + Integer.valueOf(this.scale)) + ", V=") + Integer.valueOf(this.value)) + ", E=") + Double.valueOf(this.end)) + ")");
  }
  
  public Generator(final String name, final int scale, final int value, final double begin, final double end) {
    super();
    this.name = name;
    this.scale = scale;
    this.value = value;
    this.begin = begin;
    this.end = end;
  }
  
  @Override
  @Pure
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((this.name== null) ? 0 : this.name.hashCode());
    result = prime * result + this.scale;
    result = prime * result + this.value;
    result = prime * result + (int) (Double.doubleToLongBits(this.begin) ^ (Double.doubleToLongBits(this.begin) >>> 32));
    result = prime * result + (int) (Double.doubleToLongBits(this.end) ^ (Double.doubleToLongBits(this.end) >>> 32));
    return result;
  }
  
  @Override
  @Pure
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    Generator other = (Generator) obj;
    if (this.name == null) {
      if (other.name != null)
        return false;
    } else if (!this.name.equals(other.name))
      return false;
    if (other.scale != this.scale)
      return false;
    if (other.value != this.value)
      return false;
    if (Double.doubleToLongBits(other.begin) != Double.doubleToLongBits(this.begin))
      return false; 
    if (Double.doubleToLongBits(other.end) != Double.doubleToLongBits(this.end))
      return false; 
    return true;
  }
  
  @Pure
  public String getName() {
    return this.name;
  }
  
  @Pure
  public int getScale() {
    return this.scale;
  }
  
  @Pure
  public int getValue() {
    return this.value;
  }
  
  @Pure
  public double getBegin() {
    return this.begin;
  }
  
  @Pure
  public double getEnd() {
    return this.end;
  }
}
