package dni_text2model

import DNImaster.impl.MasterPackageImpl
import tools.descatres.dml.dni.text.DNITextStandaloneSetupGenerated

//import org.xtext.example.mydsl.myDsl.impl.MyDslPackageImpl
//import org.xtext.example.mydsl.MyDslStandaloneSetupGenerated

import com.google.inject.Injector
import java.io.IOException
import org.eclipse.emf.common.util.URI
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.emf.ecore.util.EcoreUtil
import org.eclipse.xtext.resource.XtextResourceSet


/* This program takes a DSL text file and converts it to xmi */
class Converterr {
	

	def static void main(String[] args) {
		//extension dnitxt must be correct!!
		
//		new Converterr().convert_to_xmi("./d1.mydsl", "./d2.xmi")
		new Converterr().convert_to_dnitxt("./generated-traffic-model.xmi", "./d1.dnitxt")
//		new Converterr().convert_to_xmi("./d1.dnitxt", "./d2.xmi")
//		new Converterr().convert_to_dnitxt("./d4.xmi", "./d4.dnitxt")
//		new Converterr().convert_to_dnitxt("./untitled.xmi", "./u1.dnitxt")
		println("Done!")
	}
	
	def convert_to_dnitxt(String from, String to) {

//		MyDslPackageImpl.init();
//		val Injector injector = new MyDslStandaloneSetupGenerated().createInjectorAndDoEMFRegistration(); 
		MasterPackageImpl.init();
		val Injector injector = new DNITextStandaloneSetupGenerated().createInjectorAndDoEMFRegistration();
		
		val XtextResourceSet resourceSet = injector.getInstance(XtextResourceSet);
		
		val URI uri = URI.createURI(from);
		val Resource xtextResource = resourceSet.getResource(uri, true);
		
		val Resource dnitxtResource = resourceSet.createResource(URI.createURI(to));
		dnitxtResource.getContents().add(xtextResource.getContents().get(0));
		try {
			dnitxtResource.save(null);
		} catch (IOException e) {
			e.printStackTrace
		}
	}
	
	def convert_to_xmi(String dnitxtFile, String xmiFile){

//		val Injector injector = new MyDslStandaloneSetupGenerated().createInjectorAndDoEMFRegistration();
//		MyDslPackageImpl.init();
		val Injector injector = new DNITextStandaloneSetupGenerated().createInjectorAndDoEMFRegistration(); 
		MasterPackageImpl.init();
		
		
		val XtextResourceSet resourceSet = injector.getInstance(XtextResourceSet);

		val URI uri = URI.createURI(dnitxtFile);
		val Resource xtextResource = resourceSet.getResource(uri, true);
		
		EcoreUtil.resolveAll(xtextResource);		
		
		//validation of xmi model
//		val BasicDiagnostic diagnostics = new BasicDiagnostic();
//		val Map<Object, Object> context = new HashMap<Object, Object>();
//		Diagnostician.INSTANCE.validate(xtextResource.getContents().get(0),diagnostics,context);

		
		
		val Resource xmiResource = resourceSet.createResource(URI.createURI(xmiFile));
		xmiResource.getContents().add(xtextResource.getContents().get(0));
		try {
			xmiResource.save(null);
		} catch (IOException e) {
			e.printStackTrace
			
		}
	}
}


