package dni_text2model;

import DNImaster.impl.MasterPackageImpl;
import com.google.inject.Injector;
import java.io.IOException;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtext.resource.XtextResourceSet;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.InputOutput;
import tools.descatres.dml.dni.text.DNITextStandaloneSetupGenerated;

/**
 * This program takes a DSL text file and converts it to xmi
 */
@SuppressWarnings("all")
public class Converterr {
  public static void main(final String[] args) {
    Converterr _converterr = new Converterr();
    _converterr.convert_to_dnitxt("./generated-traffic-model.xmi", "./d1.dnitxt");
    InputOutput.<String>println("Done!");
  }
  
  public void convert_to_dnitxt(final String from, final String to) {
    MasterPackageImpl.init();
    DNITextStandaloneSetupGenerated _dNITextStandaloneSetupGenerated = new DNITextStandaloneSetupGenerated();
    final Injector injector = _dNITextStandaloneSetupGenerated.createInjectorAndDoEMFRegistration();
    final XtextResourceSet resourceSet = injector.<XtextResourceSet>getInstance(XtextResourceSet.class);
    final URI uri = URI.createURI(from);
    final Resource xtextResource = resourceSet.getResource(uri, true);
    URI _createURI = URI.createURI(to);
    final Resource dnitxtResource = resourceSet.createResource(_createURI);
    EList<EObject> _contents = dnitxtResource.getContents();
    EList<EObject> _contents_1 = xtextResource.getContents();
    EObject _get = _contents_1.get(0);
    _contents.add(_get);
    try {
      dnitxtResource.save(null);
    } catch (final Throwable _t) {
      if (_t instanceof IOException) {
        final IOException e = (IOException)_t;
        e.printStackTrace();
      } else {
        throw Exceptions.sneakyThrow(_t);
      }
    }
  }
  
  public void convert_to_xmi(final String dnitxtFile, final String xmiFile) {
    DNITextStandaloneSetupGenerated _dNITextStandaloneSetupGenerated = new DNITextStandaloneSetupGenerated();
    final Injector injector = _dNITextStandaloneSetupGenerated.createInjectorAndDoEMFRegistration();
    MasterPackageImpl.init();
    final XtextResourceSet resourceSet = injector.<XtextResourceSet>getInstance(XtextResourceSet.class);
    final URI uri = URI.createURI(dnitxtFile);
    final Resource xtextResource = resourceSet.getResource(uri, true);
    EcoreUtil.resolveAll(xtextResource);
    URI _createURI = URI.createURI(xmiFile);
    final Resource xmiResource = resourceSet.createResource(_createURI);
    EList<EObject> _contents = xmiResource.getContents();
    EList<EObject> _contents_1 = xtextResource.getContents();
    EObject _get = _contents_1.get(0);
    _contents.add(_get);
    try {
      xmiResource.save(null);
    } catch (final Throwable _t) {
      if (_t instanceof IOException) {
        final IOException e = (IOException)_t;
        e.printStackTrace();
      } else {
        throw Exceptions.sneakyThrow(_t);
      }
    }
  }
}
