/**
 */
package DNImaster.impl;

import DNImaster.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MasterFactoryImpl extends EFactoryImpl implements MasterFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static MasterFactory init() {
		try {
			MasterFactory theMasterFactory = (MasterFactory)EPackage.Registry.INSTANCE.getEFactory(MasterPackage.eNS_URI);
			if (theMasterFactory != null) {
				return theMasterFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MasterFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MasterFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case MasterPackage.NETWORK_INFRASTRUCTURE: return createNetworkInfrastructure();
			case MasterPackage.EXPERIMENT_PARAM: return createExperimentParam();
			case MasterPackage.NETWORK_STRUCTURE: return createNetworkStructure();
			case MasterPackage.VIRTUAL_NODE: return createVirtualNode();
			case MasterPackage.PHYSICAL_NODE: return createPhysicalNode();
			case MasterPackage.END_NODE_PERF_SPEC: return createEndNodePerfSpec();
			case MasterPackage.INTERMEDIATE_NODE_PERF_SPEC: return createIntermediateNodePerfSpec();
			case MasterPackage.DATA_PLANE_PERF_SPEC: return createDataPlanePerfSpec();
			case MasterPackage.CONTROL_PLANE_PERF_SPEC: return createControlPlanePerfSpec();
			case MasterPackage.PHYSICAL_LINK: return createPhysicalLink();
			case MasterPackage.VIRTUAL_LINK: return createVirtualLink();
			case MasterPackage.VIRTUAL_LINK_PERF_SPEC: return createVirtualLinkPerfSpec();
			case MasterPackage.PHYSICAL_LINK_PERF_SPEC: return createPhysicalLinkPerfSpec();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE_PERF_SPEC: return createVirtualNetworkInterfacePerfSpec();
			case MasterPackage.PHYSICAL_NETWORK_INTERFACE_PERF_SPEC: return createPhysicalNetworkInterfacePerfSpec();
			case MasterPackage.PHYSICAL_NETWORK_INTERFACE: return createPhysicalNetworkInterface();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE: return createVirtualNetworkInterface();
			case MasterPackage.ENTITY_ADDRESS: return createEntityAddress();
			case MasterPackage.NETWORK_CONFIGURATION: return createNetworkConfiguration();
			case MasterPackage.PROTOCOLS_REPOSITORY: return createProtocolsRepository();
			case MasterPackage.PROTOCOL_STACK: return createProtocolStack();
			case MasterPackage.PROTOCOL_LAYER: return createProtocolLayer();
			case MasterPackage.NETWORK_PROTOCOL: return createNetworkProtocol();
			case MasterPackage.ROUTES_REPOSITORY: return createRoutesRepository();
			case MasterPackage.DIRECTION: return createDirection();
			case MasterPackage.FLOW_ROUTE: return createFlowRoute();
			case MasterPackage.ROUTE: return createRoute();
			case MasterPackage.HOP: return createHop();
			case MasterPackage.NETWORK_TRAFFIC: return createNetworkTraffic();
			case MasterPackage.ONOFF_FLOW: return createONOFFFlow();
			case MasterPackage.GENERIC_FLOW: return createGenericFlow();
			case MasterPackage.SOFTWARE_COMPONENT: return createSoftwareComponent();
			case MasterPackage.TRAFFIC_SOURCE: return createTrafficSource();
			case MasterPackage.GENERIC_WORKLOAD: return createGenericWorkload();
			case MasterPackage.BRANCH_ACTION: return createBranchAction();
			case MasterPackage.LOOP_ACTION: return createLoopAction();
			case MasterPackage.SEQUENCE_ACTION: return createSequenceAction();
			case MasterPackage.START_ACTION: return createStartAction();
			case MasterPackage.STOP_ACTION: return createStopAction();
			case MasterPackage.TRANSMIT_ACTION: return createTransmitAction();
			case MasterPackage.WAIT_ACTION: return createWaitAction();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInfrastructure createNetworkInfrastructure() {
		NetworkInfrastructureImpl networkInfrastructure = new NetworkInfrastructureImpl();
		return networkInfrastructure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExperimentParam createExperimentParam() {
		ExperimentParamImpl experimentParam = new ExperimentParamImpl();
		return experimentParam;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkStructure createNetworkStructure() {
		NetworkStructureImpl networkStructure = new NetworkStructureImpl();
		return networkStructure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VirtualNode createVirtualNode() {
		VirtualNodeImpl virtualNode = new VirtualNodeImpl();
		return virtualNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalNode createPhysicalNode() {
		PhysicalNodeImpl physicalNode = new PhysicalNodeImpl();
		return physicalNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EndNodePerfSpec createEndNodePerfSpec() {
		EndNodePerfSpecImpl endNodePerfSpec = new EndNodePerfSpecImpl();
		return endNodePerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IntermediateNodePerfSpec createIntermediateNodePerfSpec() {
		IntermediateNodePerfSpecImpl intermediateNodePerfSpec = new IntermediateNodePerfSpecImpl();
		return intermediateNodePerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataPlanePerfSpec createDataPlanePerfSpec() {
		DataPlanePerfSpecImpl dataPlanePerfSpec = new DataPlanePerfSpecImpl();
		return dataPlanePerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ControlPlanePerfSpec createControlPlanePerfSpec() {
		ControlPlanePerfSpecImpl controlPlanePerfSpec = new ControlPlanePerfSpecImpl();
		return controlPlanePerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalLink createPhysicalLink() {
		PhysicalLinkImpl physicalLink = new PhysicalLinkImpl();
		return physicalLink;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VirtualLinkPerfSpec createVirtualLinkPerfSpec() {
		VirtualLinkPerfSpecImpl virtualLinkPerfSpec = new VirtualLinkPerfSpecImpl();
		return virtualLinkPerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalLinkPerfSpec createPhysicalLinkPerfSpec() {
		PhysicalLinkPerfSpecImpl physicalLinkPerfSpec = new PhysicalLinkPerfSpecImpl();
		return physicalLinkPerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VirtualLink createVirtualLink() {
		VirtualLinkImpl virtualLink = new VirtualLinkImpl();
		return virtualLink;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VirtualNetworkInterfacePerfSpec createVirtualNetworkInterfacePerfSpec() {
		VirtualNetworkInterfacePerfSpecImpl virtualNetworkInterfacePerfSpec = new VirtualNetworkInterfacePerfSpecImpl();
		return virtualNetworkInterfacePerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalNetworkInterfacePerfSpec createPhysicalNetworkInterfacePerfSpec() {
		PhysicalNetworkInterfacePerfSpecImpl physicalNetworkInterfacePerfSpec = new PhysicalNetworkInterfacePerfSpecImpl();
		return physicalNetworkInterfacePerfSpec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalNetworkInterface createPhysicalNetworkInterface() {
		PhysicalNetworkInterfaceImpl physicalNetworkInterface = new PhysicalNetworkInterfaceImpl();
		return physicalNetworkInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VirtualNetworkInterface createVirtualNetworkInterface() {
		VirtualNetworkInterfaceImpl virtualNetworkInterface = new VirtualNetworkInterfaceImpl();
		return virtualNetworkInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EntityAddress createEntityAddress() {
		EntityAddressImpl entityAddress = new EntityAddressImpl();
		return entityAddress;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkConfiguration createNetworkConfiguration() {
		NetworkConfigurationImpl networkConfiguration = new NetworkConfigurationImpl();
		return networkConfiguration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolsRepository createProtocolsRepository() {
		ProtocolsRepositoryImpl protocolsRepository = new ProtocolsRepositoryImpl();
		return protocolsRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolStack createProtocolStack() {
		ProtocolStackImpl protocolStack = new ProtocolStackImpl();
		return protocolStack;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolLayer createProtocolLayer() {
		ProtocolLayerImpl protocolLayer = new ProtocolLayerImpl();
		return protocolLayer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkProtocol createNetworkProtocol() {
		NetworkProtocolImpl networkProtocol = new NetworkProtocolImpl();
		return networkProtocol;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoutesRepository createRoutesRepository() {
		RoutesRepositoryImpl routesRepository = new RoutesRepositoryImpl();
		return routesRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Direction createDirection() {
		DirectionImpl direction = new DirectionImpl();
		return direction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FlowRoute createFlowRoute() {
		FlowRouteImpl flowRoute = new FlowRouteImpl();
		return flowRoute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Route createRoute() {
		RouteImpl route = new RouteImpl();
		return route;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Hop createHop() {
		HopImpl hop = new HopImpl();
		return hop;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkTraffic createNetworkTraffic() {
		NetworkTrafficImpl networkTraffic = new NetworkTrafficImpl();
		return networkTraffic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ONOFFFlow createONOFFFlow() {
		ONOFFFlowImpl onoffFlow = new ONOFFFlowImpl();
		return onoffFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericFlow createGenericFlow() {
		GenericFlowImpl genericFlow = new GenericFlowImpl();
		return genericFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent createSoftwareComponent() {
		SoftwareComponentImpl softwareComponent = new SoftwareComponentImpl();
		return softwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TrafficSource createTrafficSource() {
		TrafficSourceImpl trafficSource = new TrafficSourceImpl();
		return trafficSource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericWorkload createGenericWorkload() {
		GenericWorkloadImpl genericWorkload = new GenericWorkloadImpl();
		return genericWorkload;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BranchAction createBranchAction() {
		BranchActionImpl branchAction = new BranchActionImpl();
		return branchAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopAction createLoopAction() {
		LoopActionImpl loopAction = new LoopActionImpl();
		return loopAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SequenceAction createSequenceAction() {
		SequenceActionImpl sequenceAction = new SequenceActionImpl();
		return sequenceAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StartAction createStartAction() {
		StartActionImpl startAction = new StartActionImpl();
		return startAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StopAction createStopAction() {
		StopActionImpl stopAction = new StopActionImpl();
		return stopAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TransmitAction createTransmitAction() {
		TransmitActionImpl transmitAction = new TransmitActionImpl();
		return transmitAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WaitAction createWaitAction() {
		WaitActionImpl waitAction = new WaitActionImpl();
		return waitAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MasterPackage getMasterPackage() {
		return (MasterPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MasterPackage getPackage() {
		return MasterPackage.eINSTANCE;
	}

} //MasterFactoryImpl
