/**
 */
package DNImaster.impl;

import DNImaster.AbstractAction;
import DNImaster.AddressableEntity;
import DNImaster.BranchAction;
import DNImaster.ControlPlanePerfSpec;
import DNImaster.DataPlanePerfSpec;
import DNImaster.Direction;
import DNImaster.ElementWithPerformance;
import DNImaster.EndNodePerfSpec;
import DNImaster.Entity;
import DNImaster.EntityAddress;
import DNImaster.ExperimentParam;
import DNImaster.Flow;
import DNImaster.FlowRoute;
import DNImaster.GenericFlow;
import DNImaster.GenericWorkload;
import DNImaster.Hop;
import DNImaster.IntermediateNodePerfSpec;
import DNImaster.Link;
import DNImaster.LinkPerfSpec;
import DNImaster.LoopAction;
import DNImaster.MasterFactory;
import DNImaster.MasterPackage;
import DNImaster.NamedElement;
import DNImaster.NetworkConfiguration;
import DNImaster.NetworkInfrastructure;
import DNImaster.NetworkInterface;
import DNImaster.NetworkInterfacePerfSpec;
import DNImaster.NetworkProtocol;
import DNImaster.NetworkStructure;
import DNImaster.NetworkTraffic;
import DNImaster.Node;
import DNImaster.ONOFFFlow;
import DNImaster.PerformanceSpecification;
import DNImaster.PhysicalLink;
import DNImaster.PhysicalLinkPerfSpec;
import DNImaster.PhysicalNetworkInterface;
import DNImaster.PhysicalNetworkInterfacePerfSpec;
import DNImaster.PhysicalNode;
import DNImaster.ProtocolLayer;
import DNImaster.ProtocolStack;
import DNImaster.ProtocolsRepository;
import DNImaster.Route;
import DNImaster.RoutesRepository;
import DNImaster.SequenceAction;
import DNImaster.SoftwareComponent;
import DNImaster.StartAction;
import DNImaster.StopAction;
import DNImaster.TrafficSource;
import DNImaster.TransmitAction;
import DNImaster.VirtualLink;
import DNImaster.VirtualLinkPerfSpec;
import DNImaster.VirtualNetworkInterface;
import DNImaster.VirtualNetworkInterfacePerfSpec;
import DNImaster.VirtualNode;
import DNImaster.WaitAction;
import DNImaster.Workload;

import DNImaster.util.MasterValidator;

import DNIunits.UnitsPackage;

import DNIunits.impl.UnitsPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.ETypeParameter;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MasterPackageImpl extends EPackageImpl implements MasterPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass namedElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInfrastructureEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass experimentParamEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkStructureEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nodeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass virtualNodeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass physicalNodeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass performanceSpecificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endNodePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass intermediateNodePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataPlanePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass controlPlanePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkInterfacePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass elementWithPerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass physicalLinkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass virtualLinkPerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass physicalLinkPerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass virtualLinkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass virtualNetworkInterfacePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass physicalNetworkInterfacePerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkPerfSpecEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass physicalNetworkInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass virtualNetworkInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityAddressEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass addressableEntityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkConfigurationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass protocolsRepositoryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass protocolStackEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass protocolLayerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkProtocolEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass routesRepositoryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass directionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowRouteEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass routeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hopEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass networkTrafficEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass onoffFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass genericFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass softwareComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass trafficSourceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass workloadEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass genericWorkloadEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass branchActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sequenceActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass startActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stopActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass transmitActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass waitActionEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see DNImaster.MasterPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private MasterPackageImpl() {
		super(eNS_URI, MasterFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link MasterPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static MasterPackage init() {
		if (isInited) return (MasterPackage)EPackage.Registry.INSTANCE.getEPackage(MasterPackage.eNS_URI);

		// Obtain or create and register package
		MasterPackageImpl theMasterPackage = (MasterPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof MasterPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new MasterPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		UnitsPackageImpl theUnitsPackage = (UnitsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitsPackage.eNS_URI) instanceof UnitsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitsPackage.eNS_URI) : UnitsPackage.eINSTANCE);

		// Create package meta-data objects
		theMasterPackage.createPackageContents();
		theUnitsPackage.createPackageContents();

		// Initialize created meta-data
		theMasterPackage.initializePackageContents();
		theUnitsPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put
			(theMasterPackage, 
			 new EValidator.Descriptor() {
				 public EValidator getEValidator() {
					 return MasterValidator.INSTANCE;
				 }
			 });

		// Mark meta-data to indicate it can't be changed
		theMasterPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(MasterPackage.eNS_URI, theMasterPackage);
		return theMasterPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNamedElement() {
		return namedElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNamedElement_Name() {
		return (EAttribute)namedElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNamedElement_AlternativeNames() {
		return (EAttribute)namedElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntity() {
		return entityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEntity_Id() {
		return (EAttribute)entityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInfrastructure() {
		return networkInfrastructureEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Traffic() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Structure() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Configuration() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInfrastructure_Params() {
		return (EReference)networkInfrastructureEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInfrastructure_DataCenterName() {
		return (EAttribute)networkInfrastructureEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInfrastructure_DataCenterAltName() {
		return (EAttribute)networkInfrastructureEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExperimentParam() {
		return experimentParamEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getExperimentParam_Name() {
		return (EAttribute)experimentParamEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getExperimentParam_Value() {
		return (EAttribute)experimentParamEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkStructure() {
		return networkStructureEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkStructure_Nodes() {
		return (EReference)networkStructureEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkStructure_Links() {
		return (EReference)networkStructureEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInterface() {
		return networkInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterface_UsedProtocolStack() {
		return (EReference)networkInterfaceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNode() {
		return nodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_Software() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNode_Interfaces() {
		return (EReference)nodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNode_IsEndNode() {
		return (EAttribute)nodeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNode_IsIntermediateNode() {
		return (EAttribute)nodeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVirtualNode() {
		return virtualNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getVirtualNode_HostedOn() {
		return (EReference)virtualNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPhysicalNode() {
		return physicalNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPhysicalNode_Hosts() {
		return (EReference)physicalNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLink() {
		return linkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLink_Connects() {
		return (EReference)linkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPerformanceSpecification() {
		return performanceSpecificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndNodePerfSpec() {
		return endNodePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndNodePerfSpec_SoftwareLayersDelay() {
		return (EReference)endNodePerfSpecEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntermediateNodePerfSpec() {
		return intermediateNodePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediateNodePerfSpec_Dataplane() {
		return (EReference)intermediateNodePerfSpecEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIntermediateNodePerfSpec_Controlplane() {
		return (EReference)intermediateNodePerfSpecEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataPlanePerfSpec() {
		return dataPlanePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataPlanePerfSpec_ForwardingLatency() {
		return (EReference)dataPlanePerfSpecEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataPlanePerfSpec_ForwardingBandwidthPPS() {
		return (EReference)dataPlanePerfSpecEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataPlanePerfSpec_ForwardingBandwidthBPS() {
		return (EReference)dataPlanePerfSpecEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataPlanePerfSpec_PacketProcessingTime() {
		return (EReference)dataPlanePerfSpecEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getControlPlanePerfSpec() {
		return controlPlanePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getControlPlanePerfSpec_ProcessingLatency() {
		return (EReference)controlPlanePerfSpecEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getControlPlanePerfSpec_ProcessingBandwidthReqPS() {
		return (EReference)controlPlanePerfSpecEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getControlPlanePerfSpec_PacketProcessingTime() {
		return (EReference)controlPlanePerfSpecEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkInterfacePerfSpec() {
		return networkInterfacePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInterfacePerfSpec_IsUp() {
		return (EAttribute)networkInterfacePerfSpecEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterfacePerfSpec_PacketProcessingTime() {
		return (EReference)networkInterfacePerfSpecEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkInterfacePerfSpec_MTU() {
		return (EAttribute)networkInterfacePerfSpecEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkInterfacePerfSpec_InterfaceSpeed() {
		return (EReference)networkInterfacePerfSpecEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getElementWithPerformance() {
		return elementWithPerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getElementWithPerformance_Performance() {
		return (EReference)elementWithPerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPhysicalLink() {
		return physicalLinkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVirtualLinkPerfSpec() {
		return virtualLinkPerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPhysicalLinkPerfSpec() {
		return physicalLinkPerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVirtualLink() {
		return virtualLinkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVirtualNetworkInterfacePerfSpec() {
		return virtualNetworkInterfacePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPhysicalNetworkInterfacePerfSpec() {
		return physicalNetworkInterfacePerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLinkPerfSpec() {
		return linkPerfSpecEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLinkPerfSpec_PropagationDelay() {
		return (EReference)linkPerfSpecEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLinkPerfSpec_MaxSupportedBandwidth() {
		return (EReference)linkPerfSpecEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPhysicalNetworkInterface() {
		return physicalNetworkInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVirtualNetworkInterface() {
		return virtualNetworkInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntityAddress() {
		return entityAddressEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEntityAddress_Address() {
		return (EAttribute)entityAddressEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntityAddress_AddressGivenBy() {
		return (EReference)entityAddressEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAddressableEntity() {
		return addressableEntityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAddressableEntity_Addresses() {
		return (EReference)addressableEntityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkConfiguration() {
		return networkConfigurationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkConfiguration_ProtocolsAndStacks() {
		return (EReference)networkConfigurationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkConfiguration_Routes() {
		return (EReference)networkConfigurationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProtocolsRepository() {
		return protocolsRepositoryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolsRepository_Stacks() {
		return (EReference)protocolsRepositoryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolsRepository_Protocols() {
		return (EReference)protocolsRepositoryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProtocolStack() {
		return protocolStackEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolStack_Layers() {
		return (EReference)protocolStackEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProtocolLayer() {
		return protocolLayerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolLayer_Protocol() {
		return (EReference)protocolLayerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolLayer_IsCarriedBy() {
		return (EReference)protocolLayerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProtocolLayer_Carries() {
		return (EReference)protocolLayerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkProtocol() {
		return networkProtocolEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_Mtu() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_HeadersLength() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_DataUnitLength() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_Connectionless() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetworkProtocol_DeliveryGuaranteed() {
		return (EAttribute)networkProtocolEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRoutesRepository() {
		return routesRepositoryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoutesRepository_Routes() {
		return (EReference)routesRepositoryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoutesRepository_FlowRoutes() {
		return (EReference)routesRepositoryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoutesRepository_Directions() {
		return (EReference)routesRepositoryEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDirection() {
		return directionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDirection_OnNode() {
		return (EReference)directionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDirection_Flow() {
		return (EReference)directionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDirection_Via() {
		return (EReference)directionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDirection_IsDefault() {
		return (EAttribute)directionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDirection_Distance() {
		return (EAttribute)directionEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlowRoute() {
		return flowRouteEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_Hops() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlowRoute_NumHops() {
		return (EAttribute)flowRouteEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_Flow() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_Start() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlowRoute_End() {
		return (EReference)flowRouteEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRoute() {
		return routeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoute_Hops() {
		return (EReference)routeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRoute_NumHops() {
		return (EAttribute)routeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoute_Start() {
		return (EReference)routeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRoute_End() {
		return (EReference)routeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHop() {
		return hopEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHop_NextHop() {
		return (EReference)hopEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHop_Interfaceref() {
		return (EReference)hopEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetworkTraffic() {
		return networkTrafficEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkTraffic_Flows() {
		return (EReference)networkTrafficEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetworkTraffic_Software() {
		return (EReference)networkTrafficEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlow() {
		return flowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_DestinationSoftwareComponent() {
		return (EReference)flowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_SourceSoftwareComponent() {
		return (EReference)flowEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFlow_DestinationAddresses() {
		return (EReference)flowEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getONOFFFlow() {
		return onoffFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getONOFFFlow_ONstateIAT() {
		return (EReference)onoffFlowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getONOFFFlow_ONstateDuration() {
		return (EReference)onoffFlowEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getONOFFFlow_OFFstateDuration() {
		return (EReference)onoffFlowEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getONOFFFlow_PacketLength() {
		return (EReference)onoffFlowEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getONOFFFlow_StartState() {
		return (EAttribute)onoffFlowEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGenericFlow() {
		return genericFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericFlow_DataSize() {
		return (EReference)genericFlowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSoftwareComponent() {
		return softwareComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSoftwareComponent_TrafficSources() {
		return (EReference)softwareComponentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSoftwareComponent_DeployedOn() {
		return (EReference)softwareComponentEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTrafficSource() {
		return trafficSourceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTrafficSource_Workload() {
		return (EReference)trafficSourceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTrafficSource_SoftwareComponent() {
		return (EReference)trafficSourceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWorkload() {
		return workloadEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGenericWorkload() {
		return genericWorkloadEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericWorkload_Actions() {
		return (EReference)genericWorkloadEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractAction() {
		return abstractActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBranchAction() {
		return branchActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchAction_Intern() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopAction() {
		return loopActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopAction_Intern() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopAction_NumIterations() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSequenceAction() {
		return sequenceActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSequenceAction_Intern() {
		return (EReference)sequenceActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStartAction() {
		return startActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStopAction() {
		return stopActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTransmitAction() {
		return transmitActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTransmitAction_Flow() {
		return (EReference)transmitActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWaitAction() {
		return waitActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getWaitAction_WaitTime() {
		return (EReference)waitActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MasterFactory getMasterFactory() {
		return (MasterFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		namedElementEClass = createEClass(NAMED_ELEMENT);
		createEAttribute(namedElementEClass, NAMED_ELEMENT__NAME);
		createEAttribute(namedElementEClass, NAMED_ELEMENT__ALTERNATIVE_NAMES);

		entityEClass = createEClass(ENTITY);
		createEAttribute(entityEClass, ENTITY__ID);

		networkInfrastructureEClass = createEClass(NETWORK_INFRASTRUCTURE);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__TRAFFIC);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__STRUCTURE);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__CONFIGURATION);
		createEReference(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__PARAMS);
		createEAttribute(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__DATA_CENTER_NAME);
		createEAttribute(networkInfrastructureEClass, NETWORK_INFRASTRUCTURE__DATA_CENTER_ALT_NAME);

		experimentParamEClass = createEClass(EXPERIMENT_PARAM);
		createEAttribute(experimentParamEClass, EXPERIMENT_PARAM__NAME);
		createEAttribute(experimentParamEClass, EXPERIMENT_PARAM__VALUE);

		networkStructureEClass = createEClass(NETWORK_STRUCTURE);
		createEReference(networkStructureEClass, NETWORK_STRUCTURE__NODES);
		createEReference(networkStructureEClass, NETWORK_STRUCTURE__LINKS);

		performanceSpecificationEClass = createEClass(PERFORMANCE_SPECIFICATION);

		elementWithPerformanceEClass = createEClass(ELEMENT_WITH_PERFORMANCE);
		createEReference(elementWithPerformanceEClass, ELEMENT_WITH_PERFORMANCE__PERFORMANCE);

		nodeEClass = createEClass(NODE);
		createEReference(nodeEClass, NODE__SOFTWARE);
		createEReference(nodeEClass, NODE__INTERFACES);
		createEAttribute(nodeEClass, NODE__IS_END_NODE);
		createEAttribute(nodeEClass, NODE__IS_INTERMEDIATE_NODE);

		virtualNodeEClass = createEClass(VIRTUAL_NODE);
		createEReference(virtualNodeEClass, VIRTUAL_NODE__HOSTED_ON);

		physicalNodeEClass = createEClass(PHYSICAL_NODE);
		createEReference(physicalNodeEClass, PHYSICAL_NODE__HOSTS);

		endNodePerfSpecEClass = createEClass(END_NODE_PERF_SPEC);
		createEReference(endNodePerfSpecEClass, END_NODE_PERF_SPEC__SOFTWARE_LAYERS_DELAY);

		intermediateNodePerfSpecEClass = createEClass(INTERMEDIATE_NODE_PERF_SPEC);
		createEReference(intermediateNodePerfSpecEClass, INTERMEDIATE_NODE_PERF_SPEC__DATAPLANE);
		createEReference(intermediateNodePerfSpecEClass, INTERMEDIATE_NODE_PERF_SPEC__CONTROLPLANE);

		dataPlanePerfSpecEClass = createEClass(DATA_PLANE_PERF_SPEC);
		createEReference(dataPlanePerfSpecEClass, DATA_PLANE_PERF_SPEC__FORWARDING_LATENCY);
		createEReference(dataPlanePerfSpecEClass, DATA_PLANE_PERF_SPEC__FORWARDING_BANDWIDTH_PPS);
		createEReference(dataPlanePerfSpecEClass, DATA_PLANE_PERF_SPEC__FORWARDING_BANDWIDTH_BPS);
		createEReference(dataPlanePerfSpecEClass, DATA_PLANE_PERF_SPEC__PACKET_PROCESSING_TIME);

		controlPlanePerfSpecEClass = createEClass(CONTROL_PLANE_PERF_SPEC);
		createEReference(controlPlanePerfSpecEClass, CONTROL_PLANE_PERF_SPEC__PROCESSING_LATENCY);
		createEReference(controlPlanePerfSpecEClass, CONTROL_PLANE_PERF_SPEC__PROCESSING_BANDWIDTH_REQ_PS);
		createEReference(controlPlanePerfSpecEClass, CONTROL_PLANE_PERF_SPEC__PACKET_PROCESSING_TIME);

		linkEClass = createEClass(LINK);
		createEReference(linkEClass, LINK__CONNECTS);

		physicalLinkEClass = createEClass(PHYSICAL_LINK);

		virtualLinkEClass = createEClass(VIRTUAL_LINK);

		linkPerfSpecEClass = createEClass(LINK_PERF_SPEC);
		createEReference(linkPerfSpecEClass, LINK_PERF_SPEC__PROPAGATION_DELAY);
		createEReference(linkPerfSpecEClass, LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH);

		virtualLinkPerfSpecEClass = createEClass(VIRTUAL_LINK_PERF_SPEC);

		physicalLinkPerfSpecEClass = createEClass(PHYSICAL_LINK_PERF_SPEC);

		networkInterfaceEClass = createEClass(NETWORK_INTERFACE);
		createEReference(networkInterfaceEClass, NETWORK_INTERFACE__USED_PROTOCOL_STACK);

		networkInterfacePerfSpecEClass = createEClass(NETWORK_INTERFACE_PERF_SPEC);
		createEAttribute(networkInterfacePerfSpecEClass, NETWORK_INTERFACE_PERF_SPEC__IS_UP);
		createEReference(networkInterfacePerfSpecEClass, NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME);
		createEAttribute(networkInterfacePerfSpecEClass, NETWORK_INTERFACE_PERF_SPEC__MTU);
		createEReference(networkInterfacePerfSpecEClass, NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED);

		virtualNetworkInterfacePerfSpecEClass = createEClass(VIRTUAL_NETWORK_INTERFACE_PERF_SPEC);

		physicalNetworkInterfacePerfSpecEClass = createEClass(PHYSICAL_NETWORK_INTERFACE_PERF_SPEC);

		physicalNetworkInterfaceEClass = createEClass(PHYSICAL_NETWORK_INTERFACE);

		virtualNetworkInterfaceEClass = createEClass(VIRTUAL_NETWORK_INTERFACE);

		entityAddressEClass = createEClass(ENTITY_ADDRESS);
		createEAttribute(entityAddressEClass, ENTITY_ADDRESS__ADDRESS);
		createEReference(entityAddressEClass, ENTITY_ADDRESS__ADDRESS_GIVEN_BY);

		addressableEntityEClass = createEClass(ADDRESSABLE_ENTITY);
		createEReference(addressableEntityEClass, ADDRESSABLE_ENTITY__ADDRESSES);

		networkConfigurationEClass = createEClass(NETWORK_CONFIGURATION);
		createEReference(networkConfigurationEClass, NETWORK_CONFIGURATION__PROTOCOLS_AND_STACKS);
		createEReference(networkConfigurationEClass, NETWORK_CONFIGURATION__ROUTES);

		protocolsRepositoryEClass = createEClass(PROTOCOLS_REPOSITORY);
		createEReference(protocolsRepositoryEClass, PROTOCOLS_REPOSITORY__STACKS);
		createEReference(protocolsRepositoryEClass, PROTOCOLS_REPOSITORY__PROTOCOLS);

		protocolStackEClass = createEClass(PROTOCOL_STACK);
		createEReference(protocolStackEClass, PROTOCOL_STACK__LAYERS);

		protocolLayerEClass = createEClass(PROTOCOL_LAYER);
		createEReference(protocolLayerEClass, PROTOCOL_LAYER__PROTOCOL);
		createEReference(protocolLayerEClass, PROTOCOL_LAYER__IS_CARRIED_BY);
		createEReference(protocolLayerEClass, PROTOCOL_LAYER__CARRIES);

		networkProtocolEClass = createEClass(NETWORK_PROTOCOL);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__MTU);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__HEADERS_LENGTH);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__DATA_UNIT_LENGTH);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__CONNECTIONLESS);
		createEAttribute(networkProtocolEClass, NETWORK_PROTOCOL__DELIVERY_GUARANTEED);

		routesRepositoryEClass = createEClass(ROUTES_REPOSITORY);
		createEReference(routesRepositoryEClass, ROUTES_REPOSITORY__ROUTES);
		createEReference(routesRepositoryEClass, ROUTES_REPOSITORY__FLOW_ROUTES);
		createEReference(routesRepositoryEClass, ROUTES_REPOSITORY__DIRECTIONS);

		directionEClass = createEClass(DIRECTION);
		createEReference(directionEClass, DIRECTION__ON_NODE);
		createEReference(directionEClass, DIRECTION__FLOW);
		createEReference(directionEClass, DIRECTION__VIA);
		createEAttribute(directionEClass, DIRECTION__IS_DEFAULT);
		createEAttribute(directionEClass, DIRECTION__DISTANCE);

		flowRouteEClass = createEClass(FLOW_ROUTE);
		createEReference(flowRouteEClass, FLOW_ROUTE__HOPS);
		createEAttribute(flowRouteEClass, FLOW_ROUTE__NUM_HOPS);
		createEReference(flowRouteEClass, FLOW_ROUTE__FLOW);
		createEReference(flowRouteEClass, FLOW_ROUTE__START);
		createEReference(flowRouteEClass, FLOW_ROUTE__END);

		routeEClass = createEClass(ROUTE);
		createEReference(routeEClass, ROUTE__HOPS);
		createEAttribute(routeEClass, ROUTE__NUM_HOPS);
		createEReference(routeEClass, ROUTE__START);
		createEReference(routeEClass, ROUTE__END);

		hopEClass = createEClass(HOP);
		createEReference(hopEClass, HOP__NEXT_HOP);
		createEReference(hopEClass, HOP__INTERFACEREF);

		networkTrafficEClass = createEClass(NETWORK_TRAFFIC);
		createEReference(networkTrafficEClass, NETWORK_TRAFFIC__FLOWS);
		createEReference(networkTrafficEClass, NETWORK_TRAFFIC__SOFTWARE);

		flowEClass = createEClass(FLOW);
		createEReference(flowEClass, FLOW__DESTINATION_SOFTWARE_COMPONENT);
		createEReference(flowEClass, FLOW__SOURCE_SOFTWARE_COMPONENT);
		createEReference(flowEClass, FLOW__DESTINATION_ADDRESSES);

		onoffFlowEClass = createEClass(ONOFF_FLOW);
		createEReference(onoffFlowEClass, ONOFF_FLOW__ONSTATE_IAT);
		createEReference(onoffFlowEClass, ONOFF_FLOW__ONSTATE_DURATION);
		createEReference(onoffFlowEClass, ONOFF_FLOW__OF_FSTATE_DURATION);
		createEReference(onoffFlowEClass, ONOFF_FLOW__PACKET_LENGTH);
		createEAttribute(onoffFlowEClass, ONOFF_FLOW__START_STATE);

		genericFlowEClass = createEClass(GENERIC_FLOW);
		createEReference(genericFlowEClass, GENERIC_FLOW__DATA_SIZE);

		softwareComponentEClass = createEClass(SOFTWARE_COMPONENT);
		createEReference(softwareComponentEClass, SOFTWARE_COMPONENT__TRAFFIC_SOURCES);
		createEReference(softwareComponentEClass, SOFTWARE_COMPONENT__DEPLOYED_ON);

		trafficSourceEClass = createEClass(TRAFFIC_SOURCE);
		createEReference(trafficSourceEClass, TRAFFIC_SOURCE__WORKLOAD);
		createEReference(trafficSourceEClass, TRAFFIC_SOURCE__SOFTWARE_COMPONENT);

		workloadEClass = createEClass(WORKLOAD);

		genericWorkloadEClass = createEClass(GENERIC_WORKLOAD);
		createEReference(genericWorkloadEClass, GENERIC_WORKLOAD__ACTIONS);

		abstractActionEClass = createEClass(ABSTRACT_ACTION);

		branchActionEClass = createEClass(BRANCH_ACTION);
		createEReference(branchActionEClass, BRANCH_ACTION__INTERN);

		loopActionEClass = createEClass(LOOP_ACTION);
		createEReference(loopActionEClass, LOOP_ACTION__INTERN);
		createEReference(loopActionEClass, LOOP_ACTION__NUM_ITERATIONS);

		sequenceActionEClass = createEClass(SEQUENCE_ACTION);
		createEReference(sequenceActionEClass, SEQUENCE_ACTION__INTERN);

		startActionEClass = createEClass(START_ACTION);

		stopActionEClass = createEClass(STOP_ACTION);

		transmitActionEClass = createEClass(TRANSMIT_ACTION);
		createEReference(transmitActionEClass, TRANSMIT_ACTION__FLOW);

		waitActionEClass = createEClass(WAIT_ACTION);
		createEReference(waitActionEClass, WAIT_ACTION__WAIT_TIME);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		UnitsPackage theUnitsPackage = (UnitsPackage)EPackage.Registry.INSTANCE.getEPackage(UnitsPackage.eNS_URI);

		// Create type parameters
		ETypeParameter elementWithPerformanceEClass_P = addETypeParameter(elementWithPerformanceEClass, "P");
		ETypeParameter nodeEClass_I = addETypeParameter(nodeEClass, "I");
		ETypeParameter linkEClass_P = addETypeParameter(linkEClass, "P");
		ETypeParameter linkEClass_I = addETypeParameter(linkEClass, "I");
		ETypeParameter networkInterfaceEClass_P = addETypeParameter(networkInterfaceEClass, "P");

		// Set bounds for type parameters

		// Add supertypes to classes
		entityEClass.getESuperTypes().add(this.getNamedElement());
		EGenericType g1 = createEGenericType(this.getEntity());
		nodeEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getElementWithPerformance());
		EGenericType g2 = createEGenericType(this.getPerformanceSpecification());
		g1.getETypeArguments().add(g2);
		nodeEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getNode());
		g2 = createEGenericType(this.getVirtualNetworkInterface());
		g1.getETypeArguments().add(g2);
		virtualNodeEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getNode());
		g2 = createEGenericType(this.getPhysicalNetworkInterface());
		g1.getETypeArguments().add(g2);
		physicalNodeEClass.getEGenericSuperTypes().add(g1);
		endNodePerfSpecEClass.getESuperTypes().add(this.getIntermediateNodePerfSpec());
		intermediateNodePerfSpecEClass.getESuperTypes().add(this.getPerformanceSpecification());
		g1 = createEGenericType(this.getEntity());
		linkEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getElementWithPerformance());
		g2 = createEGenericType(linkEClass_P);
		g1.getETypeArguments().add(g2);
		linkEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getLink());
		g2 = createEGenericType(this.getPhysicalLinkPerfSpec());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getPhysicalNetworkInterface());
		g1.getETypeArguments().add(g2);
		physicalLinkEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getLink());
		g2 = createEGenericType(this.getVirtualLinkPerfSpec());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getVirtualNetworkInterface());
		g1.getETypeArguments().add(g2);
		virtualLinkEClass.getEGenericSuperTypes().add(g1);
		linkPerfSpecEClass.getESuperTypes().add(this.getPerformanceSpecification());
		virtualLinkPerfSpecEClass.getESuperTypes().add(this.getLinkPerfSpec());
		physicalLinkPerfSpecEClass.getESuperTypes().add(this.getLinkPerfSpec());
		g1 = createEGenericType(this.getAddressableEntity());
		networkInterfaceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getElementWithPerformance());
		g2 = createEGenericType(networkInterfaceEClass_P);
		g1.getETypeArguments().add(g2);
		networkInterfaceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getEntity());
		networkInterfaceEClass.getEGenericSuperTypes().add(g1);
		networkInterfacePerfSpecEClass.getESuperTypes().add(this.getPerformanceSpecification());
		virtualNetworkInterfacePerfSpecEClass.getESuperTypes().add(this.getNetworkInterfacePerfSpec());
		physicalNetworkInterfacePerfSpecEClass.getESuperTypes().add(this.getNetworkInterfacePerfSpec());
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType(this.getPhysicalNetworkInterfacePerfSpec());
		g1.getETypeArguments().add(g2);
		physicalNetworkInterfaceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType(this.getVirtualNetworkInterfacePerfSpec());
		g1.getETypeArguments().add(g2);
		virtualNetworkInterfaceEClass.getEGenericSuperTypes().add(g1);
		addressableEntityEClass.getESuperTypes().add(this.getEntity());
		protocolStackEClass.getESuperTypes().add(this.getNamedElement());
		protocolLayerEClass.getESuperTypes().add(this.getNamedElement());
		networkProtocolEClass.getESuperTypes().add(this.getNamedElement());
		directionEClass.getESuperTypes().add(this.getEntity());
		flowRouteEClass.getESuperTypes().add(this.getEntity());
		routeEClass.getESuperTypes().add(this.getEntity());
		flowEClass.getESuperTypes().add(this.getEntity());
		onoffFlowEClass.getESuperTypes().add(this.getFlow());
		genericFlowEClass.getESuperTypes().add(this.getFlow());
		softwareComponentEClass.getESuperTypes().add(this.getEntity());
		trafficSourceEClass.getESuperTypes().add(this.getAddressableEntity());
		genericWorkloadEClass.getESuperTypes().add(this.getWorkload());
		branchActionEClass.getESuperTypes().add(this.getAbstractAction());
		loopActionEClass.getESuperTypes().add(this.getAbstractAction());
		sequenceActionEClass.getESuperTypes().add(this.getAbstractAction());
		startActionEClass.getESuperTypes().add(this.getAbstractAction());
		stopActionEClass.getESuperTypes().add(this.getAbstractAction());
		transmitActionEClass.getESuperTypes().add(this.getAbstractAction());
		waitActionEClass.getESuperTypes().add(this.getAbstractAction());

		// Initialize classes, features, and operations; add parameters
		initEClass(namedElementEClass, NamedElement.class, "NamedElement", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNamedElement_Name(), ecorePackage.getEString(), "name", null, 1, 1, NamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNamedElement_AlternativeNames(), ecorePackage.getEString(), "alternativeNames", null, 0, -1, NamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(entityEClass, Entity.class, "Entity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEntity_Id(), ecorePackage.getEString(), "id", null, 1, 1, Entity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkInfrastructureEClass, NetworkInfrastructure.class, "NetworkInfrastructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkInfrastructure_Traffic(), this.getNetworkTraffic(), null, "traffic", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInfrastructure_Structure(), this.getNetworkStructure(), null, "structure", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInfrastructure_Configuration(), this.getNetworkConfiguration(), null, "configuration", null, 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInfrastructure_Params(), this.getExperimentParam(), null, "params", null, 0, -1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkInfrastructure_DataCenterName(), ecorePackage.getEString(), "dataCenterName", "noname", 1, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkInfrastructure_DataCenterAltName(), ecorePackage.getEString(), "dataCenterAltName", null, 0, 1, NetworkInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(experimentParamEClass, ExperimentParam.class, "ExperimentParam", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getExperimentParam_Name(), ecorePackage.getEString(), "name", null, 1, 1, ExperimentParam.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getExperimentParam_Value(), ecorePackage.getEString(), "value", null, 1, 1, ExperimentParam.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkStructureEClass, NetworkStructure.class, "NetworkStructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(this.getNode());
		g2 = createEGenericType(this.getNetworkInterface());
		g1.getETypeArguments().add(g2);
		EGenericType g3 = createEGenericType(this.getNetworkInterfacePerfSpec());
		g2.getETypeArguments().add(g3);
		initEReference(getNetworkStructure_Nodes(), g1, null, "nodes", null, 0, -1, NetworkStructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getLink());
		g2 = createEGenericType(this.getLinkPerfSpec());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getNetworkInterface());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(this.getNetworkInterfacePerfSpec());
		g2.getETypeArguments().add(g3);
		initEReference(getNetworkStructure_Links(), g1, null, "links", null, 0, -1, NetworkStructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(performanceSpecificationEClass, PerformanceSpecification.class, "PerformanceSpecification", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(elementWithPerformanceEClass, ElementWithPerformance.class, "ElementWithPerformance", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(elementWithPerformanceEClass_P);
		initEReference(getElementWithPerformance_Performance(), g1, null, "performance", null, 1, 1, ElementWithPerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(nodeEClass, Node.class, "Node", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNode_Software(), this.getSoftwareComponent(), null, "software", null, 0, -1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(nodeEClass_I);
		initEReference(getNode_Interfaces(), g1, null, "interfaces", null, 0, -1, Node.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNode_IsEndNode(), ecorePackage.getEBoolean(), "isEndNode", null, 1, 1, Node.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		initEAttribute(getNode_IsIntermediateNode(), ecorePackage.getEBoolean(), "isIntermediateNode", null, 1, 1, Node.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);

		initEClass(virtualNodeEClass, VirtualNode.class, "VirtualNode", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getVirtualNode_HostedOn(), this.getPhysicalNode(), this.getPhysicalNode_Hosts(), "hostedOn", null, 1, 1, VirtualNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(physicalNodeEClass, PhysicalNode.class, "PhysicalNode", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPhysicalNode_Hosts(), this.getVirtualNode(), this.getVirtualNode_HostedOn(), "hosts", null, 0, -1, PhysicalNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(endNodePerfSpecEClass, EndNodePerfSpec.class, "EndNodePerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEndNodePerfSpec_SoftwareLayersDelay(), theUnitsPackage.getDependency(), null, "softwareLayersDelay", null, 1, 1, EndNodePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(intermediateNodePerfSpecEClass, IntermediateNodePerfSpec.class, "IntermediateNodePerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIntermediateNodePerfSpec_Dataplane(), this.getDataPlanePerfSpec(), null, "dataplane", null, 1, 1, IntermediateNodePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIntermediateNodePerfSpec_Controlplane(), this.getControlPlanePerfSpec(), null, "controlplane", null, 1, 1, IntermediateNodePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dataPlanePerfSpecEClass, DataPlanePerfSpec.class, "DataPlanePerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDataPlanePerfSpec_ForwardingLatency(), theUnitsPackage.getDependency(), null, "forwardingLatency", null, 1, 1, DataPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDataPlanePerfSpec_ForwardingBandwidthPPS(), theUnitsPackage.getDependency(), null, "forwardingBandwidthPPS", null, 1, 1, DataPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDataPlanePerfSpec_ForwardingBandwidthBPS(), theUnitsPackage.getDependency(), null, "forwardingBandwidthBPS", null, 1, 1, DataPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDataPlanePerfSpec_PacketProcessingTime(), theUnitsPackage.getDependency(), null, "packetProcessingTime", null, 1, 1, DataPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(controlPlanePerfSpecEClass, ControlPlanePerfSpec.class, "ControlPlanePerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getControlPlanePerfSpec_ProcessingLatency(), theUnitsPackage.getDependency(), null, "processingLatency", null, 1, 1, ControlPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getControlPlanePerfSpec_ProcessingBandwidthReqPS(), theUnitsPackage.getDependency(), null, "processingBandwidthReqPS", null, 1, 1, ControlPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getControlPlanePerfSpec_PacketProcessingTime(), theUnitsPackage.getDependency(), null, "packetProcessingTime", null, 1, 1, ControlPlanePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(linkEClass, Link.class, "Link", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(linkEClass_I);
		initEReference(getLink_Connects(), g1, null, "connects", null, 2, 2, Link.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(physicalLinkEClass, PhysicalLink.class, "PhysicalLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(virtualLinkEClass, VirtualLink.class, "VirtualLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(linkPerfSpecEClass, LinkPerfSpec.class, "LinkPerfSpec", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLinkPerfSpec_PropagationDelay(), theUnitsPackage.getDependency(), null, "propagationDelay", null, 1, 1, LinkPerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLinkPerfSpec_MaxSupportedBandwidth(), theUnitsPackage.getDependency(), null, "maxSupportedBandwidth", null, 0, 1, LinkPerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(virtualLinkPerfSpecEClass, VirtualLinkPerfSpec.class, "VirtualLinkPerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(physicalLinkPerfSpecEClass, PhysicalLinkPerfSpec.class, "PhysicalLinkPerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(networkInterfaceEClass, NetworkInterface.class, "NetworkInterface", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkInterface_UsedProtocolStack(), this.getProtocolStack(), null, "usedProtocolStack", null, 1, 1, NetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkInterfacePerfSpecEClass, NetworkInterfacePerfSpec.class, "NetworkInterfacePerfSpec", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNetworkInterfacePerfSpec_IsUp(), ecorePackage.getEBoolean(), "isUp", "true", 0, 1, NetworkInterfacePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInterfacePerfSpec_PacketProcessingTime(), theUnitsPackage.getDependency(), null, "packetProcessingTime", null, 1, 1, NetworkInterfacePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkInterfacePerfSpec_MTU(), ecorePackage.getEInt(), "MTU", "1500", 1, 1, NetworkInterfacePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkInterfacePerfSpec_InterfaceSpeed(), theUnitsPackage.getSpeedUnit(), null, "interfaceSpeed", null, 1, 1, NetworkInterfacePerfSpec.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(virtualNetworkInterfacePerfSpecEClass, VirtualNetworkInterfacePerfSpec.class, "VirtualNetworkInterfacePerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(physicalNetworkInterfacePerfSpecEClass, PhysicalNetworkInterfacePerfSpec.class, "PhysicalNetworkInterfacePerfSpec", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(physicalNetworkInterfaceEClass, PhysicalNetworkInterface.class, "PhysicalNetworkInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(virtualNetworkInterfaceEClass, VirtualNetworkInterface.class, "VirtualNetworkInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(entityAddressEClass, EntityAddress.class, "EntityAddress", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEntityAddress_Address(), ecorePackage.getEString(), "address", null, 0, 1, EntityAddress.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEntityAddress_AddressGivenBy(), this.getNetworkProtocol(), null, "addressGivenBy", null, 0, 1, EntityAddress.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(addressableEntityEClass, AddressableEntity.class, "AddressableEntity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAddressableEntity_Addresses(), this.getEntityAddress(), null, "addresses", null, 0, -1, AddressableEntity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkConfigurationEClass, NetworkConfiguration.class, "NetworkConfiguration", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkConfiguration_ProtocolsAndStacks(), this.getProtocolsRepository(), null, "protocolsAndStacks", null, 1, 1, NetworkConfiguration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkConfiguration_Routes(), this.getRoutesRepository(), null, "routes", null, 1, 1, NetworkConfiguration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(protocolsRepositoryEClass, ProtocolsRepository.class, "ProtocolsRepository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getProtocolsRepository_Stacks(), this.getProtocolStack(), null, "stacks", null, 0, -1, ProtocolsRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProtocolsRepository_Protocols(), this.getNetworkProtocol(), null, "protocols", null, 1, -1, ProtocolsRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(protocolStackEClass, ProtocolStack.class, "ProtocolStack", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getProtocolStack_Layers(), this.getProtocolLayer(), null, "layers", null, 1, -1, ProtocolStack.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(protocolLayerEClass, ProtocolLayer.class, "ProtocolLayer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getProtocolLayer_Protocol(), this.getNetworkProtocol(), null, "protocol", null, 1, 1, ProtocolLayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProtocolLayer_IsCarriedBy(), this.getProtocolLayer(), this.getProtocolLayer_Carries(), "isCarriedBy", null, 0, 1, ProtocolLayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProtocolLayer_Carries(), this.getProtocolLayer(), this.getProtocolLayer_IsCarriedBy(), "carries", null, 0, 1, ProtocolLayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkProtocolEClass, NetworkProtocol.class, "NetworkProtocol", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNetworkProtocol_Mtu(), ecorePackage.getEInt(), "mtu", null, 1, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkProtocol_HeadersLength(), ecorePackage.getEInt(), "headersLength", null, 1, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkProtocol_DataUnitLength(), ecorePackage.getEInt(), "dataUnitLength", null, 1, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkProtocol_Connectionless(), ecorePackage.getEBoolean(), "connectionless", "true", 0, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNetworkProtocol_DeliveryGuaranteed(), ecorePackage.getEBoolean(), "deliveryGuaranteed", "false", 0, 1, NetworkProtocol.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(routesRepositoryEClass, RoutesRepository.class, "RoutesRepository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRoutesRepository_Routes(), this.getRoute(), null, "routes", null, 0, -1, RoutesRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRoutesRepository_FlowRoutes(), this.getFlowRoute(), null, "flowRoutes", null, 0, -1, RoutesRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRoutesRepository_Directions(), this.getDirection(), null, "directions", null, 0, -1, RoutesRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(directionEClass, Direction.class, "Direction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(this.getNode());
		g2 = createEGenericType(this.getPerformanceSpecification());
		g1.getETypeArguments().add(g2);
		initEReference(getDirection_OnNode(), g1, null, "onNode", null, 1, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDirection_Flow(), this.getFlow(), null, "flow", null, 0, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType(this.getNetworkInterfacePerfSpec());
		g1.getETypeArguments().add(g2);
		initEReference(getDirection_Via(), g1, null, "via", null, 1, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDirection_IsDefault(), ecorePackage.getEBoolean(), "isDefault", null, 0, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDirection_Distance(), ecorePackage.getELong(), "distance", null, 0, 1, Direction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowRouteEClass, FlowRoute.class, "FlowRoute", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFlowRoute_Hops(), this.getHop(), null, "hops", null, 0, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFlowRoute_NumHops(), ecorePackage.getEIntegerObject(), "numHops", null, 0, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlowRoute_Flow(), this.getFlow(), null, "flow", null, 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType();
		g1.getETypeArguments().add(g2);
		initEReference(getFlowRoute_Start(), g1, null, "start", null, 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType();
		g1.getETypeArguments().add(g2);
		initEReference(getFlowRoute_End(), g1, null, "end", null, 1, 1, FlowRoute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(routeEClass, Route.class, "Route", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRoute_Hops(), this.getHop(), null, "hops", null, 0, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRoute_NumHops(), ecorePackage.getEIntegerObject(), "numHops", null, 0, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType();
		g1.getETypeArguments().add(g2);
		initEReference(getRoute_Start(), g1, null, "start", null, 1, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType();
		g1.getETypeArguments().add(g2);
		initEReference(getRoute_End(), g1, null, "end", null, 1, 1, Route.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hopEClass, Hop.class, "Hop", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getHop_NextHop(), this.getHop(), null, "nextHop", null, 0, 1, Hop.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNetworkInterface());
		g2 = createEGenericType(this.getNetworkInterfacePerfSpec());
		g1.getETypeArguments().add(g2);
		initEReference(getHop_Interfaceref(), g1, null, "interfaceref", null, 1, 1, Hop.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(networkTrafficEClass, NetworkTraffic.class, "NetworkTraffic", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNetworkTraffic_Flows(), this.getFlow(), null, "flows", null, 0, -1, NetworkTraffic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNetworkTraffic_Software(), this.getSoftwareComponent(), null, "software", null, 0, -1, NetworkTraffic.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(flowEClass, Flow.class, "Flow", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFlow_DestinationSoftwareComponent(), this.getSoftwareComponent(), null, "destinationSoftwareComponent", null, 0, 1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlow_SourceSoftwareComponent(), this.getSoftwareComponent(), null, "sourceSoftwareComponent", null, 0, 1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFlow_DestinationAddresses(), this.getEntityAddress(), null, "destinationAddresses", null, 0, -1, Flow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(onoffFlowEClass, ONOFFFlow.class, "ONOFFFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getONOFFFlow_ONstateIAT(), theUnitsPackage.getDependency(), null, "ONstateIAT", null, 1, 1, ONOFFFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getONOFFFlow_ONstateDuration(), theUnitsPackage.getDependency(), null, "ONstateDuration", null, 1, 1, ONOFFFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getONOFFFlow_OFFstateDuration(), theUnitsPackage.getDependency(), null, "OFFstateDuration", null, 1, 1, ONOFFFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getONOFFFlow_PacketLength(), theUnitsPackage.getDependency(), null, "packetLength", null, 1, 1, ONOFFFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getONOFFFlow_StartState(), ecorePackage.getEBoolean(), "startState", null, 1, 1, ONOFFFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(genericFlowEClass, GenericFlow.class, "GenericFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGenericFlow_DataSize(), theUnitsPackage.getDependency(), null, "dataSize", null, 1, 1, GenericFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(softwareComponentEClass, SoftwareComponent.class, "SoftwareComponent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSoftwareComponent_TrafficSources(), this.getTrafficSource(), this.getTrafficSource_SoftwareComponent(), "trafficSources", null, 0, -1, SoftwareComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getNode());
		g2 = createEGenericType(this.getNetworkInterface());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(this.getNetworkInterfacePerfSpec());
		g2.getETypeArguments().add(g3);
		initEReference(getSoftwareComponent_DeployedOn(), g1, null, "deployedOn", null, 1, 1, SoftwareComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(trafficSourceEClass, TrafficSource.class, "TrafficSource", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTrafficSource_Workload(), this.getWorkload(), null, "workload", null, 1, -1, TrafficSource.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTrafficSource_SoftwareComponent(), this.getSoftwareComponent(), this.getSoftwareComponent_TrafficSources(), "softwareComponent", null, 1, 1, TrafficSource.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(workloadEClass, Workload.class, "Workload", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(genericWorkloadEClass, GenericWorkload.class, "GenericWorkload", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGenericWorkload_Actions(), this.getAbstractAction(), null, "actions", null, 0, -1, GenericWorkload.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(abstractActionEClass, AbstractAction.class, "AbstractAction", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(branchActionEClass, BranchAction.class, "BranchAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchAction_Intern(), this.getAbstractAction(), null, "intern", null, 1, -1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(loopActionEClass, LoopAction.class, "LoopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopAction_Intern(), this.getAbstractAction(), null, "intern", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLoopAction_NumIterations(), theUnitsPackage.getDependency(), null, "numIterations", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sequenceActionEClass, SequenceAction.class, "SequenceAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSequenceAction_Intern(), this.getAbstractAction(), null, "intern", null, 1, -1, SequenceAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(startActionEClass, StartAction.class, "StartAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(stopActionEClass, StopAction.class, "StopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(transmitActionEClass, TransmitAction.class, "TransmitAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTransmitAction_Flow(), this.getFlow(), null, "flow", null, 1, 1, TransmitAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(waitActionEClass, WaitAction.class, "WaitAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWaitAction_WaitTime(), theUnitsPackage.getDependency(), null, "waitTime", null, 1, 1, WaitAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL
		createOCLAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";	
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL",
			 "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL",
			 "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL"
		   });	
		addAnnotation
		  (entityEClass, 
		   source, 
		   new String[] {
			 "constraints", "idHasToBeUnique"
		   });	
		addAnnotation
		  (nodeEClass, 
		   source, 
		   new String[] {
			 "constraints", "SoftwareHostedOnlyOnEndNode"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createOCLAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL";	
		addAnnotation
		  (entityEClass, 
		   source, 
		   new String[] {
			 "idHasToBeUnique", "Entity.allInstances()->isUnique(p: Entity | p.id)"
		   });	
		addAnnotation
		  (getNode_IsEndNode(), 
		   source, 
		   new String[] {
			 "derivation", "performance.oclIsKindOf(EndNodePerfSpec)"
		   });	
		addAnnotation
		  (getNode_IsIntermediateNode(), 
		   source, 
		   new String[] {
			 "derivation", "performance.oclIsKindOf(IntermediateNodePerfSpec)"
		   });
	}

} //MasterPackageImpl
