/**
 */
package DNImaster.impl;

import DNImaster.EntityAddress;
import DNImaster.MasterPackage;
import DNImaster.ONOFFFlow;
import DNImaster.SoftwareComponent;

import DNIunits.Dependency;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>ONOFF Flow</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getName <em>Name</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getAlternativeNames <em>Alternative Names</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getId <em>Id</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getDestinationSoftwareComponent <em>Destination Software Component</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getSourceSoftwareComponent <em>Source Software Component</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getDestinationAddresses <em>Destination Addresses</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getONstateIAT <em>ONstate IAT</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getONstateDuration <em>ONstate Duration</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getOFFstateDuration <em>OF Fstate Duration</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#getPacketLength <em>Packet Length</em>}</li>
 *   <li>{@link DNImaster.impl.ONOFFFlowImpl#isStartState <em>Start State</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ONOFFFlowImpl extends MinimalEObjectImpl.Container implements ONOFFFlow {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAlternativeNames() <em>Alternative Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternativeNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> alternativeNames;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDestinationSoftwareComponent() <em>Destination Software Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDestinationSoftwareComponent()
	 * @generated
	 * @ordered
	 */
	protected SoftwareComponent destinationSoftwareComponent;

	/**
	 * The cached value of the '{@link #getSourceSoftwareComponent() <em>Source Software Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceSoftwareComponent()
	 * @generated
	 * @ordered
	 */
	protected SoftwareComponent sourceSoftwareComponent;

	/**
	 * The cached value of the '{@link #getDestinationAddresses() <em>Destination Addresses</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDestinationAddresses()
	 * @generated
	 * @ordered
	 */
	protected EList<EntityAddress> destinationAddresses;

	/**
	 * The cached value of the '{@link #getONstateIAT() <em>ONstate IAT</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getONstateIAT()
	 * @generated
	 * @ordered
	 */
	protected Dependency oNstateIAT;

	/**
	 * The cached value of the '{@link #getONstateDuration() <em>ONstate Duration</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getONstateDuration()
	 * @generated
	 * @ordered
	 */
	protected Dependency oNstateDuration;

	/**
	 * The cached value of the '{@link #getOFFstateDuration() <em>OF Fstate Duration</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOFFstateDuration()
	 * @generated
	 * @ordered
	 */
	protected Dependency ofFstateDuration;

	/**
	 * The cached value of the '{@link #getPacketLength() <em>Packet Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPacketLength()
	 * @generated
	 * @ordered
	 */
	protected Dependency packetLength;

	/**
	 * The default value of the '{@link #isStartState() <em>Start State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isStartState()
	 * @generated
	 * @ordered
	 */
	protected static final boolean START_STATE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isStartState() <em>Start State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isStartState()
	 * @generated
	 * @ordered
	 */
	protected boolean startState = START_STATE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ONOFFFlowImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MasterPackage.Literals.ONOFF_FLOW;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAlternativeNames() {
		if (alternativeNames == null) {
			alternativeNames = new EDataTypeUniqueEList<String>(String.class, this, MasterPackage.ONOFF_FLOW__ALTERNATIVE_NAMES);
		}
		return alternativeNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent getDestinationSoftwareComponent() {
		if (destinationSoftwareComponent != null && destinationSoftwareComponent.eIsProxy()) {
			InternalEObject oldDestinationSoftwareComponent = (InternalEObject)destinationSoftwareComponent;
			destinationSoftwareComponent = (SoftwareComponent)eResolveProxy(oldDestinationSoftwareComponent);
			if (destinationSoftwareComponent != oldDestinationSoftwareComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT, oldDestinationSoftwareComponent, destinationSoftwareComponent));
			}
		}
		return destinationSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent basicGetDestinationSoftwareComponent() {
		return destinationSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDestinationSoftwareComponent(SoftwareComponent newDestinationSoftwareComponent) {
		SoftwareComponent oldDestinationSoftwareComponent = destinationSoftwareComponent;
		destinationSoftwareComponent = newDestinationSoftwareComponent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT, oldDestinationSoftwareComponent, destinationSoftwareComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent getSourceSoftwareComponent() {
		if (sourceSoftwareComponent != null && sourceSoftwareComponent.eIsProxy()) {
			InternalEObject oldSourceSoftwareComponent = (InternalEObject)sourceSoftwareComponent;
			sourceSoftwareComponent = (SoftwareComponent)eResolveProxy(oldSourceSoftwareComponent);
			if (sourceSoftwareComponent != oldSourceSoftwareComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT, oldSourceSoftwareComponent, sourceSoftwareComponent));
			}
		}
		return sourceSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent basicGetSourceSoftwareComponent() {
		return sourceSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceSoftwareComponent(SoftwareComponent newSourceSoftwareComponent) {
		SoftwareComponent oldSourceSoftwareComponent = sourceSoftwareComponent;
		sourceSoftwareComponent = newSourceSoftwareComponent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT, oldSourceSoftwareComponent, sourceSoftwareComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EntityAddress> getDestinationAddresses() {
		if (destinationAddresses == null) {
			destinationAddresses = new EObjectContainmentEList<EntityAddress>(EntityAddress.class, this, MasterPackage.ONOFF_FLOW__DESTINATION_ADDRESSES);
		}
		return destinationAddresses;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Dependency getONstateIAT() {
		return oNstateIAT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetONstateIAT(Dependency newONstateIAT, NotificationChain msgs) {
		Dependency oldONstateIAT = oNstateIAT;
		oNstateIAT = newONstateIAT;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__ONSTATE_IAT, oldONstateIAT, newONstateIAT);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setONstateIAT(Dependency newONstateIAT) {
		if (newONstateIAT != oNstateIAT) {
			NotificationChain msgs = null;
			if (oNstateIAT != null)
				msgs = ((InternalEObject)oNstateIAT).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__ONSTATE_IAT, null, msgs);
			if (newONstateIAT != null)
				msgs = ((InternalEObject)newONstateIAT).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__ONSTATE_IAT, null, msgs);
			msgs = basicSetONstateIAT(newONstateIAT, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__ONSTATE_IAT, newONstateIAT, newONstateIAT));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Dependency getONstateDuration() {
		return oNstateDuration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetONstateDuration(Dependency newONstateDuration, NotificationChain msgs) {
		Dependency oldONstateDuration = oNstateDuration;
		oNstateDuration = newONstateDuration;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__ONSTATE_DURATION, oldONstateDuration, newONstateDuration);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setONstateDuration(Dependency newONstateDuration) {
		if (newONstateDuration != oNstateDuration) {
			NotificationChain msgs = null;
			if (oNstateDuration != null)
				msgs = ((InternalEObject)oNstateDuration).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__ONSTATE_DURATION, null, msgs);
			if (newONstateDuration != null)
				msgs = ((InternalEObject)newONstateDuration).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__ONSTATE_DURATION, null, msgs);
			msgs = basicSetONstateDuration(newONstateDuration, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__ONSTATE_DURATION, newONstateDuration, newONstateDuration));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Dependency getOFFstateDuration() {
		return ofFstateDuration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOFFstateDuration(Dependency newOFFstateDuration, NotificationChain msgs) {
		Dependency oldOFFstateDuration = ofFstateDuration;
		ofFstateDuration = newOFFstateDuration;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION, oldOFFstateDuration, newOFFstateDuration);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOFFstateDuration(Dependency newOFFstateDuration) {
		if (newOFFstateDuration != ofFstateDuration) {
			NotificationChain msgs = null;
			if (ofFstateDuration != null)
				msgs = ((InternalEObject)ofFstateDuration).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION, null, msgs);
			if (newOFFstateDuration != null)
				msgs = ((InternalEObject)newOFFstateDuration).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION, null, msgs);
			msgs = basicSetOFFstateDuration(newOFFstateDuration, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION, newOFFstateDuration, newOFFstateDuration));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Dependency getPacketLength() {
		return packetLength;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPacketLength(Dependency newPacketLength, NotificationChain msgs) {
		Dependency oldPacketLength = packetLength;
		packetLength = newPacketLength;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__PACKET_LENGTH, oldPacketLength, newPacketLength);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPacketLength(Dependency newPacketLength) {
		if (newPacketLength != packetLength) {
			NotificationChain msgs = null;
			if (packetLength != null)
				msgs = ((InternalEObject)packetLength).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__PACKET_LENGTH, null, msgs);
			if (newPacketLength != null)
				msgs = ((InternalEObject)newPacketLength).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.ONOFF_FLOW__PACKET_LENGTH, null, msgs);
			msgs = basicSetPacketLength(newPacketLength, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__PACKET_LENGTH, newPacketLength, newPacketLength));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isStartState() {
		return startState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartState(boolean newStartState) {
		boolean oldStartState = startState;
		startState = newStartState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.ONOFF_FLOW__START_STATE, oldStartState, startState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.ONOFF_FLOW__DESTINATION_ADDRESSES:
				return ((InternalEList<?>)getDestinationAddresses()).basicRemove(otherEnd, msgs);
			case MasterPackage.ONOFF_FLOW__ONSTATE_IAT:
				return basicSetONstateIAT(null, msgs);
			case MasterPackage.ONOFF_FLOW__ONSTATE_DURATION:
				return basicSetONstateDuration(null, msgs);
			case MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION:
				return basicSetOFFstateDuration(null, msgs);
			case MasterPackage.ONOFF_FLOW__PACKET_LENGTH:
				return basicSetPacketLength(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MasterPackage.ONOFF_FLOW__NAME:
				return getName();
			case MasterPackage.ONOFF_FLOW__ALTERNATIVE_NAMES:
				return getAlternativeNames();
			case MasterPackage.ONOFF_FLOW__ID:
				return getId();
			case MasterPackage.ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				if (resolve) return getDestinationSoftwareComponent();
				return basicGetDestinationSoftwareComponent();
			case MasterPackage.ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT:
				if (resolve) return getSourceSoftwareComponent();
				return basicGetSourceSoftwareComponent();
			case MasterPackage.ONOFF_FLOW__DESTINATION_ADDRESSES:
				return getDestinationAddresses();
			case MasterPackage.ONOFF_FLOW__ONSTATE_IAT:
				return getONstateIAT();
			case MasterPackage.ONOFF_FLOW__ONSTATE_DURATION:
				return getONstateDuration();
			case MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION:
				return getOFFstateDuration();
			case MasterPackage.ONOFF_FLOW__PACKET_LENGTH:
				return getPacketLength();
			case MasterPackage.ONOFF_FLOW__START_STATE:
				return isStartState();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MasterPackage.ONOFF_FLOW__NAME:
				setName((String)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				getAlternativeNames().addAll((Collection<? extends String>)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__ID:
				setId((String)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				setDestinationSoftwareComponent((SoftwareComponent)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT:
				setSourceSoftwareComponent((SoftwareComponent)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__DESTINATION_ADDRESSES:
				getDestinationAddresses().clear();
				getDestinationAddresses().addAll((Collection<? extends EntityAddress>)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__ONSTATE_IAT:
				setONstateIAT((Dependency)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__ONSTATE_DURATION:
				setONstateDuration((Dependency)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION:
				setOFFstateDuration((Dependency)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__PACKET_LENGTH:
				setPacketLength((Dependency)newValue);
				return;
			case MasterPackage.ONOFF_FLOW__START_STATE:
				setStartState((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MasterPackage.ONOFF_FLOW__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MasterPackage.ONOFF_FLOW__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				return;
			case MasterPackage.ONOFF_FLOW__ID:
				setId(ID_EDEFAULT);
				return;
			case MasterPackage.ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				setDestinationSoftwareComponent((SoftwareComponent)null);
				return;
			case MasterPackage.ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT:
				setSourceSoftwareComponent((SoftwareComponent)null);
				return;
			case MasterPackage.ONOFF_FLOW__DESTINATION_ADDRESSES:
				getDestinationAddresses().clear();
				return;
			case MasterPackage.ONOFF_FLOW__ONSTATE_IAT:
				setONstateIAT((Dependency)null);
				return;
			case MasterPackage.ONOFF_FLOW__ONSTATE_DURATION:
				setONstateDuration((Dependency)null);
				return;
			case MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION:
				setOFFstateDuration((Dependency)null);
				return;
			case MasterPackage.ONOFF_FLOW__PACKET_LENGTH:
				setPacketLength((Dependency)null);
				return;
			case MasterPackage.ONOFF_FLOW__START_STATE:
				setStartState(START_STATE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MasterPackage.ONOFF_FLOW__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MasterPackage.ONOFF_FLOW__ALTERNATIVE_NAMES:
				return alternativeNames != null && !alternativeNames.isEmpty();
			case MasterPackage.ONOFF_FLOW__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case MasterPackage.ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				return destinationSoftwareComponent != null;
			case MasterPackage.ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT:
				return sourceSoftwareComponent != null;
			case MasterPackage.ONOFF_FLOW__DESTINATION_ADDRESSES:
				return destinationAddresses != null && !destinationAddresses.isEmpty();
			case MasterPackage.ONOFF_FLOW__ONSTATE_IAT:
				return oNstateIAT != null;
			case MasterPackage.ONOFF_FLOW__ONSTATE_DURATION:
				return oNstateDuration != null;
			case MasterPackage.ONOFF_FLOW__OF_FSTATE_DURATION:
				return ofFstateDuration != null;
			case MasterPackage.ONOFF_FLOW__PACKET_LENGTH:
				return packetLength != null;
			case MasterPackage.ONOFF_FLOW__START_STATE:
				return startState != START_STATE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", alternativeNames: ");
		result.append(alternativeNames);
		result.append(", id: ");
		result.append(id);
		result.append(", startState: ");
		result.append(startState);
		result.append(')');
		return result.toString();
	}

} //ONOFFFlowImpl
