/**
 */
package DNImaster.impl;

import DNImaster.ElementWithPerformance;
import DNImaster.MasterPackage;
import DNImaster.PerformanceSpecification;
import DNImaster.PhysicalNetworkInterface;
import DNImaster.PhysicalNode;
import DNImaster.SoftwareComponent;
import DNImaster.VirtualNode;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Physical Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getAlternativeNames <em>Alternative Names</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getId <em>Id</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getPerformance <em>Performance</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getSoftware <em>Software</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getInterfaces <em>Interfaces</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#isIsEndNode <em>Is End Node</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#isIsIntermediateNode <em>Is Intermediate Node</em>}</li>
 *   <li>{@link DNImaster.impl.PhysicalNodeImpl#getHosts <em>Hosts</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PhysicalNodeImpl extends MinimalEObjectImpl.Container implements PhysicalNode {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAlternativeNames() <em>Alternative Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternativeNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> alternativeNames;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPerformance() <em>Performance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPerformance()
	 * @generated
	 * @ordered
	 */
	protected PerformanceSpecification performance;

	/**
	 * The cached value of the '{@link #getSoftware() <em>Software</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSoftware()
	 * @generated
	 * @ordered
	 */
	protected EList<SoftwareComponent> software;

	/**
	 * The cached value of the '{@link #getInterfaces() <em>Interfaces</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaces()
	 * @generated
	 * @ordered
	 */
	protected EList<PhysicalNetworkInterface> interfaces;

	/**
	 * The cached setting delegate for the '{@link #isIsEndNode() <em>Is End Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsEndNode()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature.Internal.SettingDelegate IS_END_NODE__ESETTING_DELEGATE = ((EStructuralFeature.Internal)MasterPackage.Literals.NODE__IS_END_NODE).getSettingDelegate();

	/**
	 * The cached setting delegate for the '{@link #isIsIntermediateNode() <em>Is Intermediate Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsIntermediateNode()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature.Internal.SettingDelegate IS_INTERMEDIATE_NODE__ESETTING_DELEGATE = ((EStructuralFeature.Internal)MasterPackage.Literals.NODE__IS_INTERMEDIATE_NODE).getSettingDelegate();

	/**
	 * The cached value of the '{@link #getHosts() <em>Hosts</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHosts()
	 * @generated
	 * @ordered
	 */
	protected EList<VirtualNode> hosts;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PhysicalNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MasterPackage.Literals.PHYSICAL_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.PHYSICAL_NODE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAlternativeNames() {
		if (alternativeNames == null) {
			alternativeNames = new EDataTypeUniqueEList<String>(String.class, this, MasterPackage.PHYSICAL_NODE__ALTERNATIVE_NAMES);
		}
		return alternativeNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.PHYSICAL_NODE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceSpecification getPerformance() {
		return performance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPerformance(PerformanceSpecification newPerformance, NotificationChain msgs) {
		PerformanceSpecification oldPerformance = performance;
		performance = newPerformance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.PHYSICAL_NODE__PERFORMANCE, oldPerformance, newPerformance);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPerformance(PerformanceSpecification newPerformance) {
		if (newPerformance != performance) {
			NotificationChain msgs = null;
			if (performance != null)
				msgs = ((InternalEObject)performance).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.PHYSICAL_NODE__PERFORMANCE, null, msgs);
			if (newPerformance != null)
				msgs = ((InternalEObject)newPerformance).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.PHYSICAL_NODE__PERFORMANCE, null, msgs);
			msgs = basicSetPerformance(newPerformance, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.PHYSICAL_NODE__PERFORMANCE, newPerformance, newPerformance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SoftwareComponent> getSoftware() {
		if (software == null) {
			software = new EObjectResolvingEList<SoftwareComponent>(SoftwareComponent.class, this, MasterPackage.PHYSICAL_NODE__SOFTWARE);
		}
		return software;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PhysicalNetworkInterface> getInterfaces() {
		if (interfaces == null) {
			interfaces = new EObjectContainmentEList<PhysicalNetworkInterface>(PhysicalNetworkInterface.class, this, MasterPackage.PHYSICAL_NODE__INTERFACES);
		}
		return interfaces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsEndNode() {
		return (Boolean)IS_END_NODE__ESETTING_DELEGATE.dynamicGet(this, null, 0, true, false);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsIntermediateNode() {
		return (Boolean)IS_INTERMEDIATE_NODE__ESETTING_DELEGATE.dynamicGet(this, null, 0, true, false);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<VirtualNode> getHosts() {
		if (hosts == null) {
			hosts = new EObjectWithInverseResolvingEList<VirtualNode>(VirtualNode.class, this, MasterPackage.PHYSICAL_NODE__HOSTS, MasterPackage.VIRTUAL_NODE__HOSTED_ON);
		}
		return hosts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.PHYSICAL_NODE__HOSTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getHosts()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.PHYSICAL_NODE__PERFORMANCE:
				return basicSetPerformance(null, msgs);
			case MasterPackage.PHYSICAL_NODE__INTERFACES:
				return ((InternalEList<?>)getInterfaces()).basicRemove(otherEnd, msgs);
			case MasterPackage.PHYSICAL_NODE__HOSTS:
				return ((InternalEList<?>)getHosts()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MasterPackage.PHYSICAL_NODE__NAME:
				return getName();
			case MasterPackage.PHYSICAL_NODE__ALTERNATIVE_NAMES:
				return getAlternativeNames();
			case MasterPackage.PHYSICAL_NODE__ID:
				return getId();
			case MasterPackage.PHYSICAL_NODE__PERFORMANCE:
				return getPerformance();
			case MasterPackage.PHYSICAL_NODE__SOFTWARE:
				return getSoftware();
			case MasterPackage.PHYSICAL_NODE__INTERFACES:
				return getInterfaces();
			case MasterPackage.PHYSICAL_NODE__IS_END_NODE:
				return isIsEndNode();
			case MasterPackage.PHYSICAL_NODE__IS_INTERMEDIATE_NODE:
				return isIsIntermediateNode();
			case MasterPackage.PHYSICAL_NODE__HOSTS:
				return getHosts();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MasterPackage.PHYSICAL_NODE__NAME:
				setName((String)newValue);
				return;
			case MasterPackage.PHYSICAL_NODE__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				getAlternativeNames().addAll((Collection<? extends String>)newValue);
				return;
			case MasterPackage.PHYSICAL_NODE__ID:
				setId((String)newValue);
				return;
			case MasterPackage.PHYSICAL_NODE__PERFORMANCE:
				setPerformance((PerformanceSpecification)newValue);
				return;
			case MasterPackage.PHYSICAL_NODE__SOFTWARE:
				getSoftware().clear();
				getSoftware().addAll((Collection<? extends SoftwareComponent>)newValue);
				return;
			case MasterPackage.PHYSICAL_NODE__INTERFACES:
				getInterfaces().clear();
				getInterfaces().addAll((Collection<? extends PhysicalNetworkInterface>)newValue);
				return;
			case MasterPackage.PHYSICAL_NODE__HOSTS:
				getHosts().clear();
				getHosts().addAll((Collection<? extends VirtualNode>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MasterPackage.PHYSICAL_NODE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MasterPackage.PHYSICAL_NODE__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				return;
			case MasterPackage.PHYSICAL_NODE__ID:
				setId(ID_EDEFAULT);
				return;
			case MasterPackage.PHYSICAL_NODE__PERFORMANCE:
				setPerformance((PerformanceSpecification)null);
				return;
			case MasterPackage.PHYSICAL_NODE__SOFTWARE:
				getSoftware().clear();
				return;
			case MasterPackage.PHYSICAL_NODE__INTERFACES:
				getInterfaces().clear();
				return;
			case MasterPackage.PHYSICAL_NODE__HOSTS:
				getHosts().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MasterPackage.PHYSICAL_NODE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MasterPackage.PHYSICAL_NODE__ALTERNATIVE_NAMES:
				return alternativeNames != null && !alternativeNames.isEmpty();
			case MasterPackage.PHYSICAL_NODE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case MasterPackage.PHYSICAL_NODE__PERFORMANCE:
				return performance != null;
			case MasterPackage.PHYSICAL_NODE__SOFTWARE:
				return software != null && !software.isEmpty();
			case MasterPackage.PHYSICAL_NODE__INTERFACES:
				return interfaces != null && !interfaces.isEmpty();
			case MasterPackage.PHYSICAL_NODE__IS_END_NODE:
				return IS_END_NODE__ESETTING_DELEGATE.dynamicIsSet(this, null, 0);
			case MasterPackage.PHYSICAL_NODE__IS_INTERMEDIATE_NODE:
				return IS_INTERMEDIATE_NODE__ESETTING_DELEGATE.dynamicIsSet(this, null, 0);
			case MasterPackage.PHYSICAL_NODE__HOSTS:
				return hosts != null && !hosts.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ElementWithPerformance.class) {
			switch (derivedFeatureID) {
				case MasterPackage.PHYSICAL_NODE__PERFORMANCE: return MasterPackage.ELEMENT_WITH_PERFORMANCE__PERFORMANCE;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ElementWithPerformance.class) {
			switch (baseFeatureID) {
				case MasterPackage.ELEMENT_WITH_PERFORMANCE__PERFORMANCE: return MasterPackage.PHYSICAL_NODE__PERFORMANCE;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", alternativeNames: ");
		result.append(alternativeNames);
		result.append(", id: ");
		result.append(id);
		result.append(')');
		return result.toString();
	}

} //PhysicalNodeImpl
