/**
 */
package DNImaster.impl;

import DNImaster.MasterPackage;
import DNImaster.NetworkInterface;
import DNImaster.NetworkInterfacePerfSpec;
import DNImaster.Node;
import DNImaster.SoftwareComponent;
import DNImaster.TrafficSource;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Software Component</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link DNImaster.impl.SoftwareComponentImpl#getName <em>Name</em>}</li>
 *   <li>{@link DNImaster.impl.SoftwareComponentImpl#getAlternativeNames <em>Alternative Names</em>}</li>
 *   <li>{@link DNImaster.impl.SoftwareComponentImpl#getId <em>Id</em>}</li>
 *   <li>{@link DNImaster.impl.SoftwareComponentImpl#getTrafficSources <em>Traffic Sources</em>}</li>
 *   <li>{@link DNImaster.impl.SoftwareComponentImpl#getDeployedOn <em>Deployed On</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SoftwareComponentImpl extends MinimalEObjectImpl.Container implements SoftwareComponent {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAlternativeNames() <em>Alternative Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternativeNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> alternativeNames;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTrafficSources() <em>Traffic Sources</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTrafficSources()
	 * @generated
	 * @ordered
	 */
	protected EList<TrafficSource> trafficSources;

	/**
	 * The cached value of the '{@link #getDeployedOn() <em>Deployed On</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeployedOn()
	 * @generated
	 * @ordered
	 */
	protected Node<NetworkInterface<NetworkInterfacePerfSpec>> deployedOn;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SoftwareComponentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MasterPackage.Literals.SOFTWARE_COMPONENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.SOFTWARE_COMPONENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAlternativeNames() {
		if (alternativeNames == null) {
			alternativeNames = new EDataTypeUniqueEList<String>(String.class, this, MasterPackage.SOFTWARE_COMPONENT__ALTERNATIVE_NAMES);
		}
		return alternativeNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.SOFTWARE_COMPONENT__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TrafficSource> getTrafficSources() {
		if (trafficSources == null) {
			trafficSources = new EObjectContainmentWithInverseEList<TrafficSource>(TrafficSource.class, this, MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES, MasterPackage.TRAFFIC_SOURCE__SOFTWARE_COMPONENT);
		}
		return trafficSources;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public Node<NetworkInterface<NetworkInterfacePerfSpec>> getDeployedOn() {
		if (deployedOn != null && deployedOn.eIsProxy()) {
			InternalEObject oldDeployedOn = (InternalEObject)deployedOn;
			deployedOn = (Node<NetworkInterface<NetworkInterfacePerfSpec>>)eResolveProxy(oldDeployedOn);
			if (deployedOn != oldDeployedOn) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.SOFTWARE_COMPONENT__DEPLOYED_ON, oldDeployedOn, deployedOn));
			}
		}
		return deployedOn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Node<NetworkInterface<NetworkInterfacePerfSpec>> basicGetDeployedOn() {
		return deployedOn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeployedOn(Node<NetworkInterface<NetworkInterfacePerfSpec>> newDeployedOn) {
		Node<NetworkInterface<NetworkInterfacePerfSpec>> oldDeployedOn = deployedOn;
		deployedOn = newDeployedOn;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.SOFTWARE_COMPONENT__DEPLOYED_ON, oldDeployedOn, deployedOn));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTrafficSources()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES:
				return ((InternalEList<?>)getTrafficSources()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MasterPackage.SOFTWARE_COMPONENT__NAME:
				return getName();
			case MasterPackage.SOFTWARE_COMPONENT__ALTERNATIVE_NAMES:
				return getAlternativeNames();
			case MasterPackage.SOFTWARE_COMPONENT__ID:
				return getId();
			case MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES:
				return getTrafficSources();
			case MasterPackage.SOFTWARE_COMPONENT__DEPLOYED_ON:
				if (resolve) return getDeployedOn();
				return basicGetDeployedOn();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MasterPackage.SOFTWARE_COMPONENT__NAME:
				setName((String)newValue);
				return;
			case MasterPackage.SOFTWARE_COMPONENT__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				getAlternativeNames().addAll((Collection<? extends String>)newValue);
				return;
			case MasterPackage.SOFTWARE_COMPONENT__ID:
				setId((String)newValue);
				return;
			case MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES:
				getTrafficSources().clear();
				getTrafficSources().addAll((Collection<? extends TrafficSource>)newValue);
				return;
			case MasterPackage.SOFTWARE_COMPONENT__DEPLOYED_ON:
				setDeployedOn((Node<NetworkInterface<NetworkInterfacePerfSpec>>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MasterPackage.SOFTWARE_COMPONENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MasterPackage.SOFTWARE_COMPONENT__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				return;
			case MasterPackage.SOFTWARE_COMPONENT__ID:
				setId(ID_EDEFAULT);
				return;
			case MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES:
				getTrafficSources().clear();
				return;
			case MasterPackage.SOFTWARE_COMPONENT__DEPLOYED_ON:
				setDeployedOn((Node<NetworkInterface<NetworkInterfacePerfSpec>>)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MasterPackage.SOFTWARE_COMPONENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MasterPackage.SOFTWARE_COMPONENT__ALTERNATIVE_NAMES:
				return alternativeNames != null && !alternativeNames.isEmpty();
			case MasterPackage.SOFTWARE_COMPONENT__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case MasterPackage.SOFTWARE_COMPONENT__TRAFFIC_SOURCES:
				return trafficSources != null && !trafficSources.isEmpty();
			case MasterPackage.SOFTWARE_COMPONENT__DEPLOYED_ON:
				return deployedOn != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", alternativeNames: ");
		result.append(alternativeNames);
		result.append(", id: ");
		result.append(id);
		result.append(')');
		return result.toString();
	}

} //SoftwareComponentImpl
