/**
 */
package DNImaster.util;

import DNImaster.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see DNImaster.MasterPackage
 * @generated
 */
public class MasterAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static MasterPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MasterAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = MasterPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MasterSwitch<Adapter> modelSwitch =
		new MasterSwitch<Adapter>() {
			@Override
			public Adapter caseNamedElement(NamedElement object) {
				return createNamedElementAdapter();
			}
			@Override
			public Adapter caseEntity(Entity object) {
				return createEntityAdapter();
			}
			@Override
			public Adapter caseNetworkInfrastructure(NetworkInfrastructure object) {
				return createNetworkInfrastructureAdapter();
			}
			@Override
			public Adapter caseExperimentParam(ExperimentParam object) {
				return createExperimentParamAdapter();
			}
			@Override
			public Adapter caseNetworkStructure(NetworkStructure object) {
				return createNetworkStructureAdapter();
			}
			@Override
			public Adapter casePerformanceSpecification(PerformanceSpecification object) {
				return createPerformanceSpecificationAdapter();
			}
			@Override
			public <P> Adapter caseElementWithPerformance(ElementWithPerformance<P> object) {
				return createElementWithPerformanceAdapter();
			}
			@Override
			public <I> Adapter caseNode(Node<I> object) {
				return createNodeAdapter();
			}
			@Override
			public Adapter caseVirtualNode(VirtualNode object) {
				return createVirtualNodeAdapter();
			}
			@Override
			public Adapter casePhysicalNode(PhysicalNode object) {
				return createPhysicalNodeAdapter();
			}
			@Override
			public Adapter caseEndNodePerfSpec(EndNodePerfSpec object) {
				return createEndNodePerfSpecAdapter();
			}
			@Override
			public Adapter caseIntermediateNodePerfSpec(IntermediateNodePerfSpec object) {
				return createIntermediateNodePerfSpecAdapter();
			}
			@Override
			public Adapter caseDataPlanePerfSpec(DataPlanePerfSpec object) {
				return createDataPlanePerfSpecAdapter();
			}
			@Override
			public Adapter caseControlPlanePerfSpec(ControlPlanePerfSpec object) {
				return createControlPlanePerfSpecAdapter();
			}
			@Override
			public <P, I> Adapter caseLink(Link<P, I> object) {
				return createLinkAdapter();
			}
			@Override
			public Adapter casePhysicalLink(PhysicalLink object) {
				return createPhysicalLinkAdapter();
			}
			@Override
			public Adapter caseVirtualLink(VirtualLink object) {
				return createVirtualLinkAdapter();
			}
			@Override
			public Adapter caseLinkPerfSpec(LinkPerfSpec object) {
				return createLinkPerfSpecAdapter();
			}
			@Override
			public Adapter caseVirtualLinkPerfSpec(VirtualLinkPerfSpec object) {
				return createVirtualLinkPerfSpecAdapter();
			}
			@Override
			public Adapter casePhysicalLinkPerfSpec(PhysicalLinkPerfSpec object) {
				return createPhysicalLinkPerfSpecAdapter();
			}
			@Override
			public <P> Adapter caseNetworkInterface(NetworkInterface<P> object) {
				return createNetworkInterfaceAdapter();
			}
			@Override
			public Adapter caseNetworkInterfacePerfSpec(NetworkInterfacePerfSpec object) {
				return createNetworkInterfacePerfSpecAdapter();
			}
			@Override
			public Adapter caseVirtualNetworkInterfacePerfSpec(VirtualNetworkInterfacePerfSpec object) {
				return createVirtualNetworkInterfacePerfSpecAdapter();
			}
			@Override
			public Adapter casePhysicalNetworkInterfacePerfSpec(PhysicalNetworkInterfacePerfSpec object) {
				return createPhysicalNetworkInterfacePerfSpecAdapter();
			}
			@Override
			public Adapter casePhysicalNetworkInterface(PhysicalNetworkInterface object) {
				return createPhysicalNetworkInterfaceAdapter();
			}
			@Override
			public Adapter caseVirtualNetworkInterface(VirtualNetworkInterface object) {
				return createVirtualNetworkInterfaceAdapter();
			}
			@Override
			public Adapter caseEntityAddress(EntityAddress object) {
				return createEntityAddressAdapter();
			}
			@Override
			public Adapter caseAddressableEntity(AddressableEntity object) {
				return createAddressableEntityAdapter();
			}
			@Override
			public Adapter caseNetworkConfiguration(NetworkConfiguration object) {
				return createNetworkConfigurationAdapter();
			}
			@Override
			public Adapter caseProtocolsRepository(ProtocolsRepository object) {
				return createProtocolsRepositoryAdapter();
			}
			@Override
			public Adapter caseProtocolStack(ProtocolStack object) {
				return createProtocolStackAdapter();
			}
			@Override
			public Adapter caseProtocolLayer(ProtocolLayer object) {
				return createProtocolLayerAdapter();
			}
			@Override
			public Adapter caseNetworkProtocol(NetworkProtocol object) {
				return createNetworkProtocolAdapter();
			}
			@Override
			public Adapter caseRoutesRepository(RoutesRepository object) {
				return createRoutesRepositoryAdapter();
			}
			@Override
			public Adapter caseDirection(Direction object) {
				return createDirectionAdapter();
			}
			@Override
			public Adapter caseFlowRoute(FlowRoute object) {
				return createFlowRouteAdapter();
			}
			@Override
			public Adapter caseRoute(Route object) {
				return createRouteAdapter();
			}
			@Override
			public Adapter caseHop(Hop object) {
				return createHopAdapter();
			}
			@Override
			public Adapter caseNetworkTraffic(NetworkTraffic object) {
				return createNetworkTrafficAdapter();
			}
			@Override
			public Adapter caseFlow(Flow object) {
				return createFlowAdapter();
			}
			@Override
			public Adapter caseONOFFFlow(ONOFFFlow object) {
				return createONOFFFlowAdapter();
			}
			@Override
			public Adapter caseGenericFlow(GenericFlow object) {
				return createGenericFlowAdapter();
			}
			@Override
			public Adapter caseSoftwareComponent(SoftwareComponent object) {
				return createSoftwareComponentAdapter();
			}
			@Override
			public Adapter caseTrafficSource(TrafficSource object) {
				return createTrafficSourceAdapter();
			}
			@Override
			public Adapter caseWorkload(Workload object) {
				return createWorkloadAdapter();
			}
			@Override
			public Adapter caseGenericWorkload(GenericWorkload object) {
				return createGenericWorkloadAdapter();
			}
			@Override
			public Adapter caseAbstractAction(AbstractAction object) {
				return createAbstractActionAdapter();
			}
			@Override
			public Adapter caseBranchAction(BranchAction object) {
				return createBranchActionAdapter();
			}
			@Override
			public Adapter caseLoopAction(LoopAction object) {
				return createLoopActionAdapter();
			}
			@Override
			public Adapter caseSequenceAction(SequenceAction object) {
				return createSequenceActionAdapter();
			}
			@Override
			public Adapter caseStartAction(StartAction object) {
				return createStartActionAdapter();
			}
			@Override
			public Adapter caseStopAction(StopAction object) {
				return createStopActionAdapter();
			}
			@Override
			public Adapter caseTransmitAction(TransmitAction object) {
				return createTransmitActionAdapter();
			}
			@Override
			public Adapter caseWaitAction(WaitAction object) {
				return createWaitActionAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NamedElement
	 * @generated
	 */
	public Adapter createNamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Entity
	 * @generated
	 */
	public Adapter createEntityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkInfrastructure <em>Network Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkInfrastructure
	 * @generated
	 */
	public Adapter createNetworkInfrastructureAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ExperimentParam <em>Experiment Param</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ExperimentParam
	 * @generated
	 */
	public Adapter createExperimentParamAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkStructure <em>Network Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkStructure
	 * @generated
	 */
	public Adapter createNetworkStructureAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkInterface
	 * @generated
	 */
	public Adapter createNetworkInterfaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Node <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Node
	 * @generated
	 */
	public Adapter createNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.VirtualNode <em>Virtual Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.VirtualNode
	 * @generated
	 */
	public Adapter createVirtualNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.PhysicalNode <em>Physical Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.PhysicalNode
	 * @generated
	 */
	public Adapter createPhysicalNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Link <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Link
	 * @generated
	 */
	public Adapter createLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.PerformanceSpecification <em>Performance Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.PerformanceSpecification
	 * @generated
	 */
	public Adapter createPerformanceSpecificationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.EndNodePerfSpec <em>End Node Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.EndNodePerfSpec
	 * @generated
	 */
	public Adapter createEndNodePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.IntermediateNodePerfSpec <em>Intermediate Node Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.IntermediateNodePerfSpec
	 * @generated
	 */
	public Adapter createIntermediateNodePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.DataPlanePerfSpec <em>Data Plane Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.DataPlanePerfSpec
	 * @generated
	 */
	public Adapter createDataPlanePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ControlPlanePerfSpec <em>Control Plane Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ControlPlanePerfSpec
	 * @generated
	 */
	public Adapter createControlPlanePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkInterfacePerfSpec <em>Network Interface Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkInterfacePerfSpec
	 * @generated
	 */
	public Adapter createNetworkInterfacePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ElementWithPerformance <em>Element With Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ElementWithPerformance
	 * @generated
	 */
	public Adapter createElementWithPerformanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.PhysicalLink <em>Physical Link</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.PhysicalLink
	 * @generated
	 */
	public Adapter createPhysicalLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.VirtualLinkPerfSpec <em>Virtual Link Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.VirtualLinkPerfSpec
	 * @generated
	 */
	public Adapter createVirtualLinkPerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.PhysicalLinkPerfSpec <em>Physical Link Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.PhysicalLinkPerfSpec
	 * @generated
	 */
	public Adapter createPhysicalLinkPerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.VirtualLink <em>Virtual Link</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.VirtualLink
	 * @generated
	 */
	public Adapter createVirtualLinkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.VirtualNetworkInterfacePerfSpec <em>Virtual Network Interface Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.VirtualNetworkInterfacePerfSpec
	 * @generated
	 */
	public Adapter createVirtualNetworkInterfacePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.PhysicalNetworkInterfacePerfSpec <em>Physical Network Interface Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.PhysicalNetworkInterfacePerfSpec
	 * @generated
	 */
	public Adapter createPhysicalNetworkInterfacePerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.LinkPerfSpec <em>Link Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.LinkPerfSpec
	 * @generated
	 */
	public Adapter createLinkPerfSpecAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.PhysicalNetworkInterface <em>Physical Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.PhysicalNetworkInterface
	 * @generated
	 */
	public Adapter createPhysicalNetworkInterfaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.VirtualNetworkInterface <em>Virtual Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.VirtualNetworkInterface
	 * @generated
	 */
	public Adapter createVirtualNetworkInterfaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.EntityAddress <em>Entity Address</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.EntityAddress
	 * @generated
	 */
	public Adapter createEntityAddressAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.AddressableEntity <em>Addressable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.AddressableEntity
	 * @generated
	 */
	public Adapter createAddressableEntityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkConfiguration <em>Network Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkConfiguration
	 * @generated
	 */
	public Adapter createNetworkConfigurationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ProtocolsRepository <em>Protocols Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ProtocolsRepository
	 * @generated
	 */
	public Adapter createProtocolsRepositoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ProtocolStack <em>Protocol Stack</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ProtocolStack
	 * @generated
	 */
	public Adapter createProtocolStackAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ProtocolLayer <em>Protocol Layer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ProtocolLayer
	 * @generated
	 */
	public Adapter createProtocolLayerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkProtocol <em>Network Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkProtocol
	 * @generated
	 */
	public Adapter createNetworkProtocolAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.RoutesRepository <em>Routes Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.RoutesRepository
	 * @generated
	 */
	public Adapter createRoutesRepositoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Direction <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Direction
	 * @generated
	 */
	public Adapter createDirectionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.FlowRoute <em>Flow Route</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.FlowRoute
	 * @generated
	 */
	public Adapter createFlowRouteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Route <em>Route</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Route
	 * @generated
	 */
	public Adapter createRouteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Hop <em>Hop</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Hop
	 * @generated
	 */
	public Adapter createHopAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.NetworkTraffic <em>Network Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.NetworkTraffic
	 * @generated
	 */
	public Adapter createNetworkTrafficAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Flow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Flow
	 * @generated
	 */
	public Adapter createFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.ONOFFFlow <em>ONOFF Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.ONOFFFlow
	 * @generated
	 */
	public Adapter createONOFFFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.GenericFlow <em>Generic Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.GenericFlow
	 * @generated
	 */
	public Adapter createGenericFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.SoftwareComponent <em>Software Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.SoftwareComponent
	 * @generated
	 */
	public Adapter createSoftwareComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.TrafficSource <em>Traffic Source</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.TrafficSource
	 * @generated
	 */
	public Adapter createTrafficSourceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.Workload <em>Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.Workload
	 * @generated
	 */
	public Adapter createWorkloadAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.GenericWorkload <em>Generic Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.GenericWorkload
	 * @generated
	 */
	public Adapter createGenericWorkloadAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.AbstractAction <em>Abstract Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.AbstractAction
	 * @generated
	 */
	public Adapter createAbstractActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.BranchAction <em>Branch Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.BranchAction
	 * @generated
	 */
	public Adapter createBranchActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.LoopAction <em>Loop Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.LoopAction
	 * @generated
	 */
	public Adapter createLoopActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.SequenceAction <em>Sequence Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.SequenceAction
	 * @generated
	 */
	public Adapter createSequenceActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.StartAction <em>Start Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.StartAction
	 * @generated
	 */
	public Adapter createStartActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.StopAction <em>Stop Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.StopAction
	 * @generated
	 */
	public Adapter createStopActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.TransmitAction <em>Transmit Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.TransmitAction
	 * @generated
	 */
	public Adapter createTransmitActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link DNImaster.WaitAction <em>Wait Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see DNImaster.WaitAction
	 * @generated
	 */
	public Adapter createWaitActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //MasterAdapterFactory
