/**
 */
package DNIunits;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Speed</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see DNIunits.UnitsPackage#getSpeed()
 * @model
 * @generated
 */
public enum Speed implements Enumerator {
	/**
	 * The '<em><b>Bytes Per Sec</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BYTES_PER_SEC_VALUE
	 * @generated
	 * @ordered
	 */
	BYTES_PER_SEC(0, "BytesPerSec", "BytesPerSec"),

	/**
	 * The '<em><b>Bits Per Sec</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BITS_PER_SEC_VALUE
	 * @generated
	 * @ordered
	 */
	BITS_PER_SEC(1, "bitsPerSec", "bitsPerSec"),

	/**
	 * The '<em><b>Packets Per Sec</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PACKETS_PER_SEC_VALUE
	 * @generated
	 * @ordered
	 */
	PACKETS_PER_SEC(2, "packetsPerSec", "packetsPerSec");

	/**
	 * The '<em><b>Bytes Per Sec</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Bytes Per Sec</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BYTES_PER_SEC
	 * @model name="BytesPerSec"
	 * @generated
	 * @ordered
	 */
	public static final int BYTES_PER_SEC_VALUE = 0;

	/**
	 * The '<em><b>Bits Per Sec</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Bits Per Sec</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BITS_PER_SEC
	 * @model name="bitsPerSec"
	 * @generated
	 * @ordered
	 */
	public static final int BITS_PER_SEC_VALUE = 1;

	/**
	 * The '<em><b>Packets Per Sec</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Packets Per Sec</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PACKETS_PER_SEC
	 * @model name="packetsPerSec"
	 * @generated
	 * @ordered
	 */
	public static final int PACKETS_PER_SEC_VALUE = 2;

	/**
	 * An array of all the '<em><b>Speed</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final Speed[] VALUES_ARRAY =
		new Speed[] {
			BYTES_PER_SEC,
			BITS_PER_SEC,
			PACKETS_PER_SEC,
		};

	/**
	 * A public read-only list of all the '<em><b>Speed</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<Speed> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Speed</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Speed get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			Speed result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Speed</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Speed getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			Speed result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Speed</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Speed get(int value) {
		switch (value) {
			case BYTES_PER_SEC_VALUE: return BYTES_PER_SEC;
			case BITS_PER_SEC_VALUE: return BITS_PER_SEC;
			case PACKETS_PER_SEC_VALUE: return PACKETS_PER_SEC;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private Speed(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //Speed
