/**
 */
package DNIunits;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see DNIunits.UnitsFactory
 * @model kind="package"
 * @generated
 */
public interface UnitsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "DNIunits";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://tools.descartes.dml.dni.units/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "units";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	UnitsPackage eINSTANCE = DNIunits.impl.UnitsPackageImpl.init();

	/**
	 * The meta object id for the '{@link DNIunits.DNIUnit <em>DNI Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.DNIUnit
	 * @see DNIunits.impl.UnitsPackageImpl#getDNIUnit()
	 * @generated
	 */
	int DNI_UNIT = 0;

	/**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DNI_UNIT__PREFIX = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DNI_UNIT__VALUE = 1;

	/**
	 * The number of structural features of the '<em>DNI Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DNI_UNIT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>DNI Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DNI_UNIT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.SpeedUnitImpl <em>Speed Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.SpeedUnitImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getSpeedUnit()
	 * @generated
	 */
	int SPEED_UNIT = 1;

	/**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT__PREFIX = DNI_UNIT__PREFIX;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT__VALUE = DNI_UNIT__VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT__UNIT = DNI_UNIT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Speed Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT_FEATURE_COUNT = DNI_UNIT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Speed Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT_OPERATION_COUNT = DNI_UNIT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.Dependency <em>Dependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.Dependency
	 * @see DNIunits.impl.UnitsPackageImpl#getDependency()
	 * @generated
	 */
	int DEPENDENCY = 2;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__UNIT = 0;

	/**
	 * The number of structural features of the '<em>Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNIunits.Variable <em>Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.Variable
	 * @see DNIunits.impl.UnitsPackageImpl#getVariable()
	 * @generated
	 */
	int VARIABLE = 3;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE__UNIT = DEPENDENCY__UNIT;

	/**
	 * The number of structural features of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_OPERATION_COUNT = DEPENDENCY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.Function <em>Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.Function
	 * @see DNIunits.impl.UnitsPackageImpl#getFunction()
	 * @generated
	 */
	int FUNCTION = 4;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__UNIT = DEPENDENCY__UNIT;

	/**
	 * The feature id for the '<em><b>Num Args</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__NUM_ARGS = DEPENDENCY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_OPERATION_COUNT = DEPENDENCY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.ConstantDoubleVariableImpl <em>Constant Double Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.ConstantDoubleVariableImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getConstantDoubleVariable()
	 * @generated
	 */
	int CONSTANT_DOUBLE_VARIABLE = 5;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE__UNIT = VARIABLE__UNIT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE__VALUE = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Double Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Constant Double Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.ConstantLongVariableImpl <em>Constant Long Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.ConstantLongVariableImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getConstantLongVariable()
	 * @generated
	 */
	int CONSTANT_LONG_VARIABLE = 6;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE__UNIT = VARIABLE__UNIT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE__VALUE = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Long Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Constant Long Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.RandomVariableImpl <em>Random Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.RandomVariableImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getRandomVariable()
	 * @generated
	 */
	int RANDOM_VARIABLE = 7;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE__UNIT = VARIABLE__UNIT;

	/**
	 * The feature id for the '<em><b>Cdf</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE__CDF = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Random Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Random Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.ContinuousFunctionImpl <em>Continuous Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.ContinuousFunctionImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getContinuousFunction()
	 * @generated
	 */
	int CONTINUOUS_FUNCTION = 8;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_FUNCTION__UNIT = FUNCTION__UNIT;

	/**
	 * The feature id for the '<em><b>Num Args</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_FUNCTION__NUM_ARGS = FUNCTION__NUM_ARGS;

	/**
	 * The feature id for the '<em><b>Equation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_FUNCTION__EQUATION = FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Continuous Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_FUNCTION_FEATURE_COUNT = FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Continuous Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_FUNCTION_OPERATION_COUNT = FUNCTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.DiscreteFunctionImpl <em>Discrete Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.DiscreteFunctionImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getDiscreteFunction()
	 * @generated
	 */
	int DISCRETE_FUNCTION = 9;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION__UNIT = FUNCTION__UNIT;

	/**
	 * The feature id for the '<em><b>Num Args</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION__NUM_ARGS = FUNCTION__NUM_ARGS;

	/**
	 * The feature id for the '<em><b>X</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION__X = FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Y</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION__Y = FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Discrete Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION_FEATURE_COUNT = FUNCTION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Discrete Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION_OPERATION_COUNT = FUNCTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNIunits.impl.DataSeriesImpl <em>Data Series</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.impl.DataSeriesImpl
	 * @see DNIunits.impl.UnitsPackageImpl#getDataSeries()
	 * @generated
	 */
	int DATA_SERIES = 10;

	/**
	 * The feature id for the '<em><b>Data</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SERIES__DATA = 0;

	/**
	 * The number of structural features of the '<em>Data Series</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SERIES_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Data Series</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_SERIES_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNIunits.UnitPrefix <em>Unit Prefix</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.UnitPrefix
	 * @see DNIunits.impl.UnitsPackageImpl#getUnitPrefix()
	 * @generated
	 */
	int UNIT_PREFIX = 11;

	/**
	 * The meta object id for the '{@link DNIunits.Speed <em>Speed</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNIunits.Speed
	 * @see DNIunits.impl.UnitsPackageImpl#getSpeed()
	 * @generated
	 */
	int SPEED = 12;


	/**
	 * Returns the meta object for class '{@link DNIunits.DNIUnit <em>DNI Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>DNI Unit</em>'.
	 * @see DNIunits.DNIUnit
	 * @generated
	 */
	EClass getDNIUnit();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.DNIUnit#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see DNIunits.DNIUnit#getPrefix()
	 * @see #getDNIUnit()
	 * @generated
	 */
	EAttribute getDNIUnit_Prefix();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.DNIUnit#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see DNIunits.DNIUnit#getValue()
	 * @see #getDNIUnit()
	 * @generated
	 */
	EAttribute getDNIUnit_Value();

	/**
	 * Returns the meta object for class '{@link DNIunits.SpeedUnit <em>Speed Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Speed Unit</em>'.
	 * @see DNIunits.SpeedUnit
	 * @generated
	 */
	EClass getSpeedUnit();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.SpeedUnit#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see DNIunits.SpeedUnit#getUnit()
	 * @see #getSpeedUnit()
	 * @generated
	 */
	EAttribute getSpeedUnit_Unit();

	/**
	 * Returns the meta object for class '{@link DNIunits.Dependency <em>Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency</em>'.
	 * @see DNIunits.Dependency
	 * @generated
	 */
	EClass getDependency();

	/**
	 * Returns the meta object for the containment reference '{@link DNIunits.Dependency#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unit</em>'.
	 * @see DNIunits.Dependency#getUnit()
	 * @see #getDependency()
	 * @generated
	 */
	EReference getDependency_Unit();

	/**
	 * Returns the meta object for class '{@link DNIunits.Variable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable</em>'.
	 * @see DNIunits.Variable
	 * @generated
	 */
	EClass getVariable();

	/**
	 * Returns the meta object for class '{@link DNIunits.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function</em>'.
	 * @see DNIunits.Function
	 * @generated
	 */
	EClass getFunction();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.Function#getNumArgs <em>Num Args</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Num Args</em>'.
	 * @see DNIunits.Function#getNumArgs()
	 * @see #getFunction()
	 * @generated
	 */
	EAttribute getFunction_NumArgs();

	/**
	 * Returns the meta object for class '{@link DNIunits.ConstantDoubleVariable <em>Constant Double Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Double Variable</em>'.
	 * @see DNIunits.ConstantDoubleVariable
	 * @generated
	 */
	EClass getConstantDoubleVariable();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.ConstantDoubleVariable#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see DNIunits.ConstantDoubleVariable#getValue()
	 * @see #getConstantDoubleVariable()
	 * @generated
	 */
	EAttribute getConstantDoubleVariable_Value();

	/**
	 * Returns the meta object for class '{@link DNIunits.ConstantLongVariable <em>Constant Long Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Long Variable</em>'.
	 * @see DNIunits.ConstantLongVariable
	 * @generated
	 */
	EClass getConstantLongVariable();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.ConstantLongVariable#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see DNIunits.ConstantLongVariable#getValue()
	 * @see #getConstantLongVariable()
	 * @generated
	 */
	EAttribute getConstantLongVariable_Value();

	/**
	 * Returns the meta object for class '{@link DNIunits.RandomVariable <em>Random Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Random Variable</em>'.
	 * @see DNIunits.RandomVariable
	 * @generated
	 */
	EClass getRandomVariable();

	/**
	 * Returns the meta object for the containment reference '{@link DNIunits.RandomVariable#getCdf <em>Cdf</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Cdf</em>'.
	 * @see DNIunits.RandomVariable#getCdf()
	 * @see #getRandomVariable()
	 * @generated
	 */
	EReference getRandomVariable_Cdf();

	/**
	 * Returns the meta object for class '{@link DNIunits.ContinuousFunction <em>Continuous Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Continuous Function</em>'.
	 * @see DNIunits.ContinuousFunction
	 * @generated
	 */
	EClass getContinuousFunction();

	/**
	 * Returns the meta object for the attribute '{@link DNIunits.ContinuousFunction#getEquation <em>Equation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Equation</em>'.
	 * @see DNIunits.ContinuousFunction#getEquation()
	 * @see #getContinuousFunction()
	 * @generated
	 */
	EAttribute getContinuousFunction_Equation();

	/**
	 * Returns the meta object for class '{@link DNIunits.DiscreteFunction <em>Discrete Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Discrete Function</em>'.
	 * @see DNIunits.DiscreteFunction
	 * @generated
	 */
	EClass getDiscreteFunction();

	/**
	 * Returns the meta object for the containment reference list '{@link DNIunits.DiscreteFunction#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>X</em>'.
	 * @see DNIunits.DiscreteFunction#getX()
	 * @see #getDiscreteFunction()
	 * @generated
	 */
	EReference getDiscreteFunction_X();

	/**
	 * Returns the meta object for the containment reference '{@link DNIunits.DiscreteFunction#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Y</em>'.
	 * @see DNIunits.DiscreteFunction#getY()
	 * @see #getDiscreteFunction()
	 * @generated
	 */
	EReference getDiscreteFunction_Y();

	/**
	 * Returns the meta object for class '{@link DNIunits.DataSeries <em>Data Series</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Series</em>'.
	 * @see DNIunits.DataSeries
	 * @generated
	 */
	EClass getDataSeries();

	/**
	 * Returns the meta object for the attribute list '{@link DNIunits.DataSeries#getData <em>Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Data</em>'.
	 * @see DNIunits.DataSeries#getData()
	 * @see #getDataSeries()
	 * @generated
	 */
	EAttribute getDataSeries_Data();

	/**
	 * Returns the meta object for enum '{@link DNIunits.UnitPrefix <em>Unit Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Unit Prefix</em>'.
	 * @see DNIunits.UnitPrefix
	 * @generated
	 */
	EEnum getUnitPrefix();

	/**
	 * Returns the meta object for enum '{@link DNIunits.Speed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Speed</em>'.
	 * @see DNIunits.Speed
	 * @generated
	 */
	EEnum getSpeed();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	UnitsFactory getUnitsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link DNIunits.DNIUnit <em>DNI Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.DNIUnit
		 * @see DNIunits.impl.UnitsPackageImpl#getDNIUnit()
		 * @generated
		 */
		EClass DNI_UNIT = eINSTANCE.getDNIUnit();

		/**
		 * The meta object literal for the '<em><b>Prefix</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DNI_UNIT__PREFIX = eINSTANCE.getDNIUnit_Prefix();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DNI_UNIT__VALUE = eINSTANCE.getDNIUnit_Value();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.SpeedUnitImpl <em>Speed Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.SpeedUnitImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getSpeedUnit()
		 * @generated
		 */
		EClass SPEED_UNIT = eINSTANCE.getSpeedUnit();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SPEED_UNIT__UNIT = eINSTANCE.getSpeedUnit_Unit();

		/**
		 * The meta object literal for the '{@link DNIunits.Dependency <em>Dependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.Dependency
		 * @see DNIunits.impl.UnitsPackageImpl#getDependency()
		 * @generated
		 */
		EClass DEPENDENCY = eINSTANCE.getDependency();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY__UNIT = eINSTANCE.getDependency_Unit();

		/**
		 * The meta object literal for the '{@link DNIunits.Variable <em>Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.Variable
		 * @see DNIunits.impl.UnitsPackageImpl#getVariable()
		 * @generated
		 */
		EClass VARIABLE = eINSTANCE.getVariable();

		/**
		 * The meta object literal for the '{@link DNIunits.Function <em>Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.Function
		 * @see DNIunits.impl.UnitsPackageImpl#getFunction()
		 * @generated
		 */
		EClass FUNCTION = eINSTANCE.getFunction();

		/**
		 * The meta object literal for the '<em><b>Num Args</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUNCTION__NUM_ARGS = eINSTANCE.getFunction_NumArgs();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.ConstantDoubleVariableImpl <em>Constant Double Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.ConstantDoubleVariableImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getConstantDoubleVariable()
		 * @generated
		 */
		EClass CONSTANT_DOUBLE_VARIABLE = eINSTANCE.getConstantDoubleVariable();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTANT_DOUBLE_VARIABLE__VALUE = eINSTANCE.getConstantDoubleVariable_Value();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.ConstantLongVariableImpl <em>Constant Long Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.ConstantLongVariableImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getConstantLongVariable()
		 * @generated
		 */
		EClass CONSTANT_LONG_VARIABLE = eINSTANCE.getConstantLongVariable();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTANT_LONG_VARIABLE__VALUE = eINSTANCE.getConstantLongVariable_Value();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.RandomVariableImpl <em>Random Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.RandomVariableImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getRandomVariable()
		 * @generated
		 */
		EClass RANDOM_VARIABLE = eINSTANCE.getRandomVariable();

		/**
		 * The meta object literal for the '<em><b>Cdf</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_VARIABLE__CDF = eINSTANCE.getRandomVariable_Cdf();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.ContinuousFunctionImpl <em>Continuous Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.ContinuousFunctionImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getContinuousFunction()
		 * @generated
		 */
		EClass CONTINUOUS_FUNCTION = eINSTANCE.getContinuousFunction();

		/**
		 * The meta object literal for the '<em><b>Equation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONTINUOUS_FUNCTION__EQUATION = eINSTANCE.getContinuousFunction_Equation();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.DiscreteFunctionImpl <em>Discrete Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.DiscreteFunctionImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getDiscreteFunction()
		 * @generated
		 */
		EClass DISCRETE_FUNCTION = eINSTANCE.getDiscreteFunction();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DISCRETE_FUNCTION__X = eINSTANCE.getDiscreteFunction_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DISCRETE_FUNCTION__Y = eINSTANCE.getDiscreteFunction_Y();

		/**
		 * The meta object literal for the '{@link DNIunits.impl.DataSeriesImpl <em>Data Series</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.impl.DataSeriesImpl
		 * @see DNIunits.impl.UnitsPackageImpl#getDataSeries()
		 * @generated
		 */
		EClass DATA_SERIES = eINSTANCE.getDataSeries();

		/**
		 * The meta object literal for the '<em><b>Data</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_SERIES__DATA = eINSTANCE.getDataSeries_Data();

		/**
		 * The meta object literal for the '{@link DNIunits.UnitPrefix <em>Unit Prefix</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.UnitPrefix
		 * @see DNIunits.impl.UnitsPackageImpl#getUnitPrefix()
		 * @generated
		 */
		EEnum UNIT_PREFIX = eINSTANCE.getUnitPrefix();

		/**
		 * The meta object literal for the '{@link DNIunits.Speed <em>Speed</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNIunits.Speed
		 * @see DNIunits.impl.UnitsPackageImpl#getSpeed()
		 * @generated
		 */
		EEnum SPEED = eINSTANCE.getSpeed();

	}

} //UnitsPackage
