/**
 */
package DNImaster;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see DNImaster.MasterFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL'"
 * @generated
 */
public interface MasterPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "DNImaster";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://tools.descartes.dml.dni.master/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "master";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MasterPackage eINSTANCE = DNImaster.impl.MasterPackageImpl.init();

	/**
	 * The meta object id for the '{@link DNImaster.NamedElement <em>Named Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.NamedElement
	 * @see DNImaster.impl.MasterPackageImpl#getNamedElement()
	 * @generated
	 */
	int NAMED_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__ALTERNATIVE_NAMES = 1;

	/**
	 * The number of structural features of the '<em>Named Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Named Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.Entity <em>Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.Entity
	 * @see DNImaster.impl.MasterPackageImpl#getEntity()
	 * @generated
	 */
	int ENTITY = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__ALTERNATIVE_NAMES = NAMED_ELEMENT__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__ID = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_OPERATION_COUNT = NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.NetworkInfrastructureImpl <em>Network Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.NetworkInfrastructureImpl
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkInfrastructure()
	 * @generated
	 */
	int NETWORK_INFRASTRUCTURE = 2;

	/**
	 * The feature id for the '<em><b>Traffic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__TRAFFIC = 0;

	/**
	 * The feature id for the '<em><b>Structure</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__STRUCTURE = 1;

	/**
	 * The feature id for the '<em><b>Configuration</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__CONFIGURATION = 2;

	/**
	 * The feature id for the '<em><b>Params</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__PARAMS = 3;

	/**
	 * The feature id for the '<em><b>Data Center Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__DATA_CENTER_NAME = 4;

	/**
	 * The feature id for the '<em><b>Data Center Alt Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__DATA_CENTER_ALT_NAME = 5;

	/**
	 * The number of structural features of the '<em>Network Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Network Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.ExperimentParamImpl <em>Experiment Param</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.ExperimentParamImpl
	 * @see DNImaster.impl.MasterPackageImpl#getExperimentParam()
	 * @generated
	 */
	int EXPERIMENT_PARAM = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPERIMENT_PARAM__NAME = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPERIMENT_PARAM__VALUE = 1;

	/**
	 * The number of structural features of the '<em>Experiment Param</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPERIMENT_PARAM_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Experiment Param</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPERIMENT_PARAM_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.NetworkStructureImpl <em>Network Structure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.NetworkStructureImpl
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkStructure()
	 * @generated
	 */
	int NETWORK_STRUCTURE = 4;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE__NODES = 0;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE__LINKS = 1;

	/**
	 * The number of structural features of the '<em>Network Structure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Network Structure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.AddressableEntity <em>Addressable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.AddressableEntity
	 * @see DNImaster.impl.MasterPackageImpl#getAddressableEntity()
	 * @generated
	 */
	int ADDRESSABLE_ENTITY = 27;

	/**
	 * The meta object id for the '{@link DNImaster.NetworkInterface <em>Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.NetworkInterface
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkInterface()
	 * @generated
	 */
	int NETWORK_INTERFACE = 20;

	/**
	 * The meta object id for the '{@link DNImaster.Node <em>Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.Node
	 * @see DNImaster.impl.MasterPackageImpl#getNode()
	 * @generated
	 */
	int NODE = 7;

	/**
	 * The meta object id for the '{@link DNImaster.impl.VirtualNodeImpl <em>Virtual Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.VirtualNodeImpl
	 * @see DNImaster.impl.MasterPackageImpl#getVirtualNode()
	 * @generated
	 */
	int VIRTUAL_NODE = 8;

	/**
	 * The meta object id for the '{@link DNImaster.impl.PhysicalNodeImpl <em>Physical Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.PhysicalNodeImpl
	 * @see DNImaster.impl.MasterPackageImpl#getPhysicalNode()
	 * @generated
	 */
	int PHYSICAL_NODE = 9;

	/**
	 * The meta object id for the '{@link DNImaster.Link <em>Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.Link
	 * @see DNImaster.impl.MasterPackageImpl#getLink()
	 * @generated
	 */
	int LINK = 14;

	/**
	 * The meta object id for the '{@link DNImaster.PerformanceSpecification <em>Performance Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.PerformanceSpecification
	 * @see DNImaster.impl.MasterPackageImpl#getPerformanceSpecification()
	 * @generated
	 */
	int PERFORMANCE_SPECIFICATION = 5;

	/**
	 * The number of structural features of the '<em>Performance Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SPECIFICATION_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Performance Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SPECIFICATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.IntermediateNodePerfSpecImpl <em>Intermediate Node Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.IntermediateNodePerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getIntermediateNodePerfSpec()
	 * @generated
	 */
	int INTERMEDIATE_NODE_PERF_SPEC = 11;

	/**
	 * The meta object id for the '{@link DNImaster.impl.EndNodePerfSpecImpl <em>End Node Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.EndNodePerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getEndNodePerfSpec()
	 * @generated
	 */
	int END_NODE_PERF_SPEC = 10;

	/**
	 * The meta object id for the '{@link DNImaster.impl.DataPlanePerfSpecImpl <em>Data Plane Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.DataPlanePerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getDataPlanePerfSpec()
	 * @generated
	 */
	int DATA_PLANE_PERF_SPEC = 12;

	/**
	 * The meta object id for the '{@link DNImaster.impl.ControlPlanePerfSpecImpl <em>Control Plane Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.ControlPlanePerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getControlPlanePerfSpec()
	 * @generated
	 */
	int CONTROL_PLANE_PERF_SPEC = 13;

	/**
	 * The meta object id for the '{@link DNImaster.NetworkInterfacePerfSpec <em>Network Interface Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.NetworkInterfacePerfSpec
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkInterfacePerfSpec()
	 * @generated
	 */
	int NETWORK_INTERFACE_PERF_SPEC = 21;

	/**
	 * The meta object id for the '{@link DNImaster.ElementWithPerformance <em>Element With Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.ElementWithPerformance
	 * @see DNImaster.impl.MasterPackageImpl#getElementWithPerformance()
	 * @generated
	 */
	int ELEMENT_WITH_PERFORMANCE = 6;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PERFORMANCE__PERFORMANCE = 0;

	/**
	 * The number of structural features of the '<em>Element With Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PERFORMANCE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Element With Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PERFORMANCE_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__PERFORMANCE = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__SOFTWARE = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__INTERFACES = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Is End Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__IS_END_NODE = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Is Intermediate Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__IS_INTERMEDIATE_NODE = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__NAME = NODE__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__ALTERNATIVE_NAMES = NODE__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__ID = NODE__ID;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__PERFORMANCE = NODE__PERFORMANCE;

	/**
	 * The feature id for the '<em><b>Software</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__SOFTWARE = NODE__SOFTWARE;

	/**
	 * The feature id for the '<em><b>Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__INTERFACES = NODE__INTERFACES;

	/**
	 * The feature id for the '<em><b>Is End Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__IS_END_NODE = NODE__IS_END_NODE;

	/**
	 * The feature id for the '<em><b>Is Intermediate Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__IS_INTERMEDIATE_NODE = NODE__IS_INTERMEDIATE_NODE;

	/**
	 * The feature id for the '<em><b>Hosted On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE__HOSTED_ON = NODE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Virtual Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE_FEATURE_COUNT = NODE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Virtual Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NODE_OPERATION_COUNT = NODE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__NAME = NODE__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__ALTERNATIVE_NAMES = NODE__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__ID = NODE__ID;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__PERFORMANCE = NODE__PERFORMANCE;

	/**
	 * The feature id for the '<em><b>Software</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__SOFTWARE = NODE__SOFTWARE;

	/**
	 * The feature id for the '<em><b>Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__INTERFACES = NODE__INTERFACES;

	/**
	 * The feature id for the '<em><b>Is End Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__IS_END_NODE = NODE__IS_END_NODE;

	/**
	 * The feature id for the '<em><b>Is Intermediate Node</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__IS_INTERMEDIATE_NODE = NODE__IS_INTERMEDIATE_NODE;

	/**
	 * The feature id for the '<em><b>Hosts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE__HOSTS = NODE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Physical Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE_FEATURE_COUNT = NODE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Physical Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NODE_OPERATION_COUNT = NODE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Dataplane</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_NODE_PERF_SPEC__DATAPLANE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Controlplane</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_NODE_PERF_SPEC__CONTROLPLANE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Intermediate Node Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_NODE_PERF_SPEC_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Intermediate Node Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_NODE_PERF_SPEC_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Dataplane</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_NODE_PERF_SPEC__DATAPLANE = INTERMEDIATE_NODE_PERF_SPEC__DATAPLANE;

	/**
	 * The feature id for the '<em><b>Controlplane</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_NODE_PERF_SPEC__CONTROLPLANE = INTERMEDIATE_NODE_PERF_SPEC__CONTROLPLANE;

	/**
	 * The feature id for the '<em><b>Software Layers Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_NODE_PERF_SPEC__SOFTWARE_LAYERS_DELAY = INTERMEDIATE_NODE_PERF_SPEC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>End Node Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_NODE_PERF_SPEC_FEATURE_COUNT = INTERMEDIATE_NODE_PERF_SPEC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>End Node Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_NODE_PERF_SPEC_OPERATION_COUNT = INTERMEDIATE_NODE_PERF_SPEC_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Forwarding Latency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PLANE_PERF_SPEC__FORWARDING_LATENCY = 0;

	/**
	 * The feature id for the '<em><b>Forwarding Bandwidth PPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PLANE_PERF_SPEC__FORWARDING_BANDWIDTH_PPS = 1;

	/**
	 * The feature id for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PLANE_PERF_SPEC__FORWARDING_BANDWIDTH_BPS = 2;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PLANE_PERF_SPEC__PACKET_PROCESSING_TIME = 3;

	/**
	 * The number of structural features of the '<em>Data Plane Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PLANE_PERF_SPEC_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Data Plane Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_PLANE_PERF_SPEC_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Processing Latency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_PLANE_PERF_SPEC__PROCESSING_LATENCY = 0;

	/**
	 * The feature id for the '<em><b>Processing Bandwidth Req PS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_PLANE_PERF_SPEC__PROCESSING_BANDWIDTH_REQ_PS = 1;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_PLANE_PERF_SPEC__PACKET_PROCESSING_TIME = 2;

	/**
	 * The number of structural features of the '<em>Control Plane Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_PLANE_PERF_SPEC_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Control Plane Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_PLANE_PERF_SPEC_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__PERFORMANCE = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Connects</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__CONNECTS = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.PhysicalLinkImpl <em>Physical Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.PhysicalLinkImpl
	 * @see DNImaster.impl.MasterPackageImpl#getPhysicalLink()
	 * @generated
	 */
	int PHYSICAL_LINK = 15;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK__NAME = LINK__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK__ALTERNATIVE_NAMES = LINK__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK__ID = LINK__ID;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK__PERFORMANCE = LINK__PERFORMANCE;

	/**
	 * The feature id for the '<em><b>Connects</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK__CONNECTS = LINK__CONNECTS;

	/**
	 * The number of structural features of the '<em>Physical Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK_FEATURE_COUNT = LINK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Physical Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK_OPERATION_COUNT = LINK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.LinkPerfSpec <em>Link Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.LinkPerfSpec
	 * @see DNImaster.impl.MasterPackageImpl#getLinkPerfSpec()
	 * @generated
	 */
	int LINK_PERF_SPEC = 17;

	/**
	 * The meta object id for the '{@link DNImaster.impl.VirtualLinkPerfSpecImpl <em>Virtual Link Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.VirtualLinkPerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getVirtualLinkPerfSpec()
	 * @generated
	 */
	int VIRTUAL_LINK_PERF_SPEC = 18;

	/**
	 * The meta object id for the '{@link DNImaster.impl.PhysicalLinkPerfSpecImpl <em>Physical Link Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.PhysicalLinkPerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getPhysicalLinkPerfSpec()
	 * @generated
	 */
	int PHYSICAL_LINK_PERF_SPEC = 19;

	/**
	 * The meta object id for the '{@link DNImaster.impl.VirtualLinkImpl <em>Virtual Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.VirtualLinkImpl
	 * @see DNImaster.impl.MasterPackageImpl#getVirtualLink()
	 * @generated
	 */
	int VIRTUAL_LINK = 16;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK__NAME = LINK__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK__ALTERNATIVE_NAMES = LINK__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK__ID = LINK__ID;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK__PERFORMANCE = LINK__PERFORMANCE;

	/**
	 * The feature id for the '<em><b>Connects</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK__CONNECTS = LINK__CONNECTS;

	/**
	 * The number of structural features of the '<em>Virtual Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_FEATURE_COUNT = LINK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Virtual Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_OPERATION_COUNT = LINK_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Propagation Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERF_SPEC__PROPAGATION_DELAY = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Max Supported Bandwidth</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Link Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERF_SPEC_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Link Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERF_SPEC_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Propagation Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_PERF_SPEC__PROPAGATION_DELAY = LINK_PERF_SPEC__PROPAGATION_DELAY;

	/**
	 * The feature id for the '<em><b>Max Supported Bandwidth</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH = LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH;

	/**
	 * The number of structural features of the '<em>Virtual Link Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_PERF_SPEC_FEATURE_COUNT = LINK_PERF_SPEC_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Virtual Link Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_PERF_SPEC_OPERATION_COUNT = LINK_PERF_SPEC_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Propagation Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK_PERF_SPEC__PROPAGATION_DELAY = LINK_PERF_SPEC__PROPAGATION_DELAY;

	/**
	 * The feature id for the '<em><b>Max Supported Bandwidth</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH = LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH;

	/**
	 * The number of structural features of the '<em>Physical Link Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK_PERF_SPEC_FEATURE_COUNT = LINK_PERF_SPEC_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Physical Link Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_LINK_PERF_SPEC_OPERATION_COUNT = LINK_PERF_SPEC_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY__ADDRESSES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Addressable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Addressable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__NAME = ADDRESSABLE_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__ALTERNATIVE_NAMES = ADDRESSABLE_ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__ID = ADDRESSABLE_ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__ADDRESSES = ADDRESSABLE_ENTITY__ADDRESSES;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__PERFORMANCE = ADDRESSABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Used Protocol Stack</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__USED_PROTOCOL_STACK = ADDRESSABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_FEATURE_COUNT = ADDRESSABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_OPERATION_COUNT = ADDRESSABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Up</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERF_SPEC__IS_UP = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>MTU</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERF_SPEC__MTU = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Interface Speed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Network Interface Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERF_SPEC_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Network Interface Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERF_SPEC_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.VirtualNetworkInterfacePerfSpecImpl <em>Virtual Network Interface Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.VirtualNetworkInterfacePerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getVirtualNetworkInterfacePerfSpec()
	 * @generated
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC = 22;

	/**
	 * The feature id for the '<em><b>Is Up</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC__IS_UP = NETWORK_INTERFACE_PERF_SPEC__IS_UP;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME = NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME;

	/**
	 * The feature id for the '<em><b>MTU</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC__MTU = NETWORK_INTERFACE_PERF_SPEC__MTU;

	/**
	 * The feature id for the '<em><b>Interface Speed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED = NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED;

	/**
	 * The number of structural features of the '<em>Virtual Network Interface Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC_FEATURE_COUNT = NETWORK_INTERFACE_PERF_SPEC_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Virtual Network Interface Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_PERF_SPEC_OPERATION_COUNT = NETWORK_INTERFACE_PERF_SPEC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.PhysicalNetworkInterfacePerfSpecImpl <em>Physical Network Interface Perf Spec</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.PhysicalNetworkInterfacePerfSpecImpl
	 * @see DNImaster.impl.MasterPackageImpl#getPhysicalNetworkInterfacePerfSpec()
	 * @generated
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC = 23;

	/**
	 * The feature id for the '<em><b>Is Up</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC__IS_UP = NETWORK_INTERFACE_PERF_SPEC__IS_UP;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME = NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME;

	/**
	 * The feature id for the '<em><b>MTU</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC__MTU = NETWORK_INTERFACE_PERF_SPEC__MTU;

	/**
	 * The feature id for the '<em><b>Interface Speed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED = NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED;

	/**
	 * The number of structural features of the '<em>Physical Network Interface Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC_FEATURE_COUNT = NETWORK_INTERFACE_PERF_SPEC_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Physical Network Interface Perf Spec</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_PERF_SPEC_OPERATION_COUNT = NETWORK_INTERFACE_PERF_SPEC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.PhysicalNetworkInterfaceImpl <em>Physical Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.PhysicalNetworkInterfaceImpl
	 * @see DNImaster.impl.MasterPackageImpl#getPhysicalNetworkInterface()
	 * @generated
	 */
	int PHYSICAL_NETWORK_INTERFACE = 24;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE__NAME = NETWORK_INTERFACE__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES = NETWORK_INTERFACE__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE__ID = NETWORK_INTERFACE__ID;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE__ADDRESSES = NETWORK_INTERFACE__ADDRESSES;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE__PERFORMANCE = NETWORK_INTERFACE__PERFORMANCE;

	/**
	 * The feature id for the '<em><b>Used Protocol Stack</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK = NETWORK_INTERFACE__USED_PROTOCOL_STACK;

	/**
	 * The number of structural features of the '<em>Physical Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_FEATURE_COUNT = NETWORK_INTERFACE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Physical Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PHYSICAL_NETWORK_INTERFACE_OPERATION_COUNT = NETWORK_INTERFACE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.VirtualNetworkInterfaceImpl <em>Virtual Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.VirtualNetworkInterfaceImpl
	 * @see DNImaster.impl.MasterPackageImpl#getVirtualNetworkInterface()
	 * @generated
	 */
	int VIRTUAL_NETWORK_INTERFACE = 25;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE__NAME = NETWORK_INTERFACE__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES = NETWORK_INTERFACE__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE__ID = NETWORK_INTERFACE__ID;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE__ADDRESSES = NETWORK_INTERFACE__ADDRESSES;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE__PERFORMANCE = NETWORK_INTERFACE__PERFORMANCE;

	/**
	 * The feature id for the '<em><b>Used Protocol Stack</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK = NETWORK_INTERFACE__USED_PROTOCOL_STACK;

	/**
	 * The number of structural features of the '<em>Virtual Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_FEATURE_COUNT = NETWORK_INTERFACE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Virtual Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_NETWORK_INTERFACE_OPERATION_COUNT = NETWORK_INTERFACE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.EntityAddressImpl <em>Entity Address</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.EntityAddressImpl
	 * @see DNImaster.impl.MasterPackageImpl#getEntityAddress()
	 * @generated
	 */
	int ENTITY_ADDRESS = 26;

	/**
	 * The feature id for the '<em><b>Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS__ADDRESS = 0;

	/**
	 * The feature id for the '<em><b>Address Given By</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS__ADDRESS_GIVEN_BY = 1;

	/**
	 * The number of structural features of the '<em>Entity Address</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Entity Address</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.NetworkConfigurationImpl <em>Network Configuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.NetworkConfigurationImpl
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkConfiguration()
	 * @generated
	 */
	int NETWORK_CONFIGURATION = 28;

	/**
	 * The feature id for the '<em><b>Protocols And Stacks</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION__PROTOCOLS_AND_STACKS = 0;

	/**
	 * The feature id for the '<em><b>Routes</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION__ROUTES = 1;

	/**
	 * The number of structural features of the '<em>Network Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Network Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.ProtocolsRepositoryImpl <em>Protocols Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.ProtocolsRepositoryImpl
	 * @see DNImaster.impl.MasterPackageImpl#getProtocolsRepository()
	 * @generated
	 */
	int PROTOCOLS_REPOSITORY = 29;

	/**
	 * The feature id for the '<em><b>Stacks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY__STACKS = 0;

	/**
	 * The feature id for the '<em><b>Protocols</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY__PROTOCOLS = 1;

	/**
	 * The number of structural features of the '<em>Protocols Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Protocols Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.ProtocolStackImpl <em>Protocol Stack</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.ProtocolStackImpl
	 * @see DNImaster.impl.MasterPackageImpl#getProtocolStack()
	 * @generated
	 */
	int PROTOCOL_STACK = 30;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__ALTERNATIVE_NAMES = NAMED_ELEMENT__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Layers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__LAYERS = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Protocol Stack</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Protocol Stack</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK_OPERATION_COUNT = NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.ProtocolLayerImpl <em>Protocol Layer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.ProtocolLayerImpl
	 * @see DNImaster.impl.MasterPackageImpl#getProtocolLayer()
	 * @generated
	 */
	int PROTOCOL_LAYER = 31;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__ALTERNATIVE_NAMES = NAMED_ELEMENT__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Protocol</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__PROTOCOL = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Carried By</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__IS_CARRIED_BY = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Carries</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__CARRIES = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Protocol Layer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Protocol Layer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER_OPERATION_COUNT = NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.NetworkProtocolImpl <em>Network Protocol</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.NetworkProtocolImpl
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkProtocol()
	 * @generated
	 */
	int NETWORK_PROTOCOL = 32;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__ALTERNATIVE_NAMES = NAMED_ELEMENT__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Mtu</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__MTU = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Headers Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__HEADERS_LENGTH = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Data Unit Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__DATA_UNIT_LENGTH = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Connectionless</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__CONNECTIONLESS = NAMED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Delivery Guaranteed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__DELIVERY_GUARANTEED = NAMED_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Network Protocol</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Network Protocol</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL_OPERATION_COUNT = NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.RoutesRepositoryImpl <em>Routes Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.RoutesRepositoryImpl
	 * @see DNImaster.impl.MasterPackageImpl#getRoutesRepository()
	 * @generated
	 */
	int ROUTES_REPOSITORY = 33;

	/**
	 * The feature id for the '<em><b>Routes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY__ROUTES = 0;

	/**
	 * The feature id for the '<em><b>Flow Routes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY__FLOW_ROUTES = 1;

	/**
	 * The feature id for the '<em><b>Directions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY__DIRECTIONS = 2;

	/**
	 * The number of structural features of the '<em>Routes Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Routes Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.DirectionImpl <em>Direction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.DirectionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getDirection()
	 * @generated
	 */
	int DIRECTION = 34;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>On Node</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__ON_NODE = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__FLOW = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Via</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__VIA = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Is Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__IS_DEFAULT = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Distance</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__DISTANCE = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Direction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Direction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.FlowRouteImpl <em>Flow Route</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.FlowRouteImpl
	 * @see DNImaster.impl.MasterPackageImpl#getFlowRoute()
	 * @generated
	 */
	int FLOW_ROUTE = 35;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Hops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__HOPS = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Num Hops</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__NUM_HOPS = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__FLOW = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__START = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__END = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Flow Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Flow Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.RouteImpl <em>Route</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.RouteImpl
	 * @see DNImaster.impl.MasterPackageImpl#getRoute()
	 * @generated
	 */
	int ROUTE = 36;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Hops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__HOPS = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Num Hops</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__NUM_HOPS = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__START = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__END = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.HopImpl <em>Hop</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.HopImpl
	 * @see DNImaster.impl.MasterPackageImpl#getHop()
	 * @generated
	 */
	int HOP = 37;

	/**
	 * The feature id for the '<em><b>Next Hop</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP__NEXT_HOP = 0;

	/**
	 * The feature id for the '<em><b>Interfaceref</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP__INTERFACEREF = 1;

	/**
	 * The number of structural features of the '<em>Hop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Hop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.NetworkTrafficImpl <em>Network Traffic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.NetworkTrafficImpl
	 * @see DNImaster.impl.MasterPackageImpl#getNetworkTraffic()
	 * @generated
	 */
	int NETWORK_TRAFFIC = 38;

	/**
	 * The feature id for the '<em><b>Flows</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC__FLOWS = 0;

	/**
	 * The feature id for the '<em><b>Software</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC__SOFTWARE = 1;

	/**
	 * The number of structural features of the '<em>Network Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Network Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.Flow <em>Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.Flow
	 * @see DNImaster.impl.MasterPackageImpl#getFlow()
	 * @generated
	 */
	int FLOW = 39;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Destination Software Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__DESTINATION_SOFTWARE_COMPONENT = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Source Software Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__SOURCE_SOFTWARE_COMPONENT = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Destination Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__DESTINATION_ADDRESSES = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.ONOFFFlowImpl <em>ONOFF Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.ONOFFFlowImpl
	 * @see DNImaster.impl.MasterPackageImpl#getONOFFFlow()
	 * @generated
	 */
	int ONOFF_FLOW = 40;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__NAME = FLOW__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__ALTERNATIVE_NAMES = FLOW__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__ID = FLOW__ID;

	/**
	 * The feature id for the '<em><b>Destination Software Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__DESTINATION_SOFTWARE_COMPONENT = FLOW__DESTINATION_SOFTWARE_COMPONENT;

	/**
	 * The feature id for the '<em><b>Source Software Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__SOURCE_SOFTWARE_COMPONENT = FLOW__SOURCE_SOFTWARE_COMPONENT;

	/**
	 * The feature id for the '<em><b>Destination Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__DESTINATION_ADDRESSES = FLOW__DESTINATION_ADDRESSES;

	/**
	 * The feature id for the '<em><b>ONstate IAT</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__ONSTATE_IAT = FLOW_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>ONstate Duration</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__ONSTATE_DURATION = FLOW_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>OF Fstate Duration</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__OF_FSTATE_DURATION = FLOW_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Packet Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__PACKET_LENGTH = FLOW_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Start State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW__START_STATE = FLOW_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>ONOFF Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW_FEATURE_COUNT = FLOW_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>ONOFF Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONOFF_FLOW_OPERATION_COUNT = FLOW_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.GenericFlowImpl <em>Generic Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.GenericFlowImpl
	 * @see DNImaster.impl.MasterPackageImpl#getGenericFlow()
	 * @generated
	 */
	int GENERIC_FLOW = 41;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__NAME = FLOW__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__ALTERNATIVE_NAMES = FLOW__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__ID = FLOW__ID;

	/**
	 * The feature id for the '<em><b>Destination Software Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT = FLOW__DESTINATION_SOFTWARE_COMPONENT;

	/**
	 * The feature id for the '<em><b>Source Software Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT = FLOW__SOURCE_SOFTWARE_COMPONENT;

	/**
	 * The feature id for the '<em><b>Destination Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__DESTINATION_ADDRESSES = FLOW__DESTINATION_ADDRESSES;

	/**
	 * The feature id for the '<em><b>Data Size</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW__DATA_SIZE = FLOW_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Generic Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_FEATURE_COUNT = FLOW_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Generic Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_OPERATION_COUNT = FLOW_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.SoftwareComponentImpl <em>Software Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.SoftwareComponentImpl
	 * @see DNImaster.impl.MasterPackageImpl#getSoftwareComponent()
	 * @generated
	 */
	int SOFTWARE_COMPONENT = 42;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT__ALTERNATIVE_NAMES = ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT__ID = ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Traffic Sources</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT__TRAFFIC_SOURCES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Deployed On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT__DEPLOYED_ON = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Software Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Software Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOFTWARE_COMPONENT_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.TrafficSourceImpl <em>Traffic Source</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.TrafficSourceImpl
	 * @see DNImaster.impl.MasterPackageImpl#getTrafficSource()
	 * @generated
	 */
	int TRAFFIC_SOURCE = 43;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__NAME = ADDRESSABLE_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Alternative Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__ALTERNATIVE_NAMES = ADDRESSABLE_ENTITY__ALTERNATIVE_NAMES;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__ID = ADDRESSABLE_ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__ADDRESSES = ADDRESSABLE_ENTITY__ADDRESSES;

	/**
	 * The feature id for the '<em><b>Workload</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__WORKLOAD = ADDRESSABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software Component</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__SOFTWARE_COMPONENT = ADDRESSABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Traffic Source</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE_FEATURE_COUNT = ADDRESSABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Traffic Source</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE_OPERATION_COUNT = ADDRESSABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.Workload <em>Workload</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.Workload
	 * @see DNImaster.impl.MasterPackageImpl#getWorkload()
	 * @generated
	 */
	int WORKLOAD = 44;

	/**
	 * The number of structural features of the '<em>Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.GenericWorkloadImpl <em>Generic Workload</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.GenericWorkloadImpl
	 * @see DNImaster.impl.MasterPackageImpl#getGenericWorkload()
	 * @generated
	 */
	int GENERIC_WORKLOAD = 45;

	/**
	 * The feature id for the '<em><b>Actions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_WORKLOAD__ACTIONS = WORKLOAD_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Generic Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_WORKLOAD_FEATURE_COUNT = WORKLOAD_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Generic Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_WORKLOAD_OPERATION_COUNT = WORKLOAD_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.AbstractAction <em>Abstract Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.AbstractAction
	 * @see DNImaster.impl.MasterPackageImpl#getAbstractAction()
	 * @generated
	 */
	int ABSTRACT_ACTION = 46;

	/**
	 * The number of structural features of the '<em>Abstract Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ACTION_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Abstract Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ACTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.BranchActionImpl <em>Branch Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.BranchActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getBranchAction()
	 * @generated
	 */
	int BRANCH_ACTION = 47;

	/**
	 * The feature id for the '<em><b>Intern</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_ACTION__INTERN = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Branch Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Branch Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.LoopActionImpl <em>Loop Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.LoopActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getLoopAction()
	 * @generated
	 */
	int LOOP_ACTION = 48;

	/**
	 * The feature id for the '<em><b>Intern</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION__INTERN = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Num Iterations</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION__NUM_ITERATIONS = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Loop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Loop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.SequenceActionImpl <em>Sequence Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.SequenceActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getSequenceAction()
	 * @generated
	 */
	int SEQUENCE_ACTION = 49;

	/**
	 * The feature id for the '<em><b>Intern</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_ACTION__INTERN = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sequence Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Sequence Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.StartActionImpl <em>Start Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.StartActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getStartAction()
	 * @generated
	 */
	int START_ACTION = 50;

	/**
	 * The number of structural features of the '<em>Start Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int START_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Start Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int START_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.StopActionImpl <em>Stop Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.StopActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getStopAction()
	 * @generated
	 */
	int STOP_ACTION = 51;

	/**
	 * The number of structural features of the '<em>Stop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Stop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.TransmitActionImpl <em>Transmit Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.TransmitActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getTransmitAction()
	 * @generated
	 */
	int TRANSMIT_ACTION = 52;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSMIT_ACTION__FLOW = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Transmit Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSMIT_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Transmit Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSMIT_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link DNImaster.impl.WaitActionImpl <em>Wait Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see DNImaster.impl.WaitActionImpl
	 * @see DNImaster.impl.MasterPackageImpl#getWaitAction()
	 * @generated
	 */
	int WAIT_ACTION = 53;

	/**
	 * The feature id for the '<em><b>Wait Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_ACTION__WAIT_TIME = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Wait Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Wait Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link DNImaster.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Named Element</em>'.
	 * @see DNImaster.NamedElement
	 * @generated
	 */
	EClass getNamedElement();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NamedElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see DNImaster.NamedElement#getName()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_Name();

	/**
	 * Returns the meta object for the attribute list '{@link DNImaster.NamedElement#getAlternativeNames <em>Alternative Names</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Alternative Names</em>'.
	 * @see DNImaster.NamedElement#getAlternativeNames()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_AlternativeNames();

	/**
	 * Returns the meta object for class '{@link DNImaster.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity</em>'.
	 * @see DNImaster.Entity
	 * @generated
	 */
	EClass getEntity();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.Entity#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see DNImaster.Entity#getId()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_Id();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkInfrastructure <em>Network Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Infrastructure</em>'.
	 * @see DNImaster.NetworkInfrastructure
	 * @generated
	 */
	EClass getNetworkInfrastructure();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkInfrastructure#getTraffic <em>Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Traffic</em>'.
	 * @see DNImaster.NetworkInfrastructure#getTraffic()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Traffic();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkInfrastructure#getStructure <em>Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Structure</em>'.
	 * @see DNImaster.NetworkInfrastructure#getStructure()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Structure();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkInfrastructure#getConfiguration <em>Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Configuration</em>'.
	 * @see DNImaster.NetworkInfrastructure#getConfiguration()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Configuration();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.NetworkInfrastructure#getParams <em>Params</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Params</em>'.
	 * @see DNImaster.NetworkInfrastructure#getParams()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Params();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkInfrastructure#getDataCenterName <em>Data Center Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Center Name</em>'.
	 * @see DNImaster.NetworkInfrastructure#getDataCenterName()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EAttribute getNetworkInfrastructure_DataCenterName();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkInfrastructure#getDataCenterAltName <em>Data Center Alt Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Center Alt Name</em>'.
	 * @see DNImaster.NetworkInfrastructure#getDataCenterAltName()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EAttribute getNetworkInfrastructure_DataCenterAltName();

	/**
	 * Returns the meta object for class '{@link DNImaster.ExperimentParam <em>Experiment Param</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Experiment Param</em>'.
	 * @see DNImaster.ExperimentParam
	 * @generated
	 */
	EClass getExperimentParam();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.ExperimentParam#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see DNImaster.ExperimentParam#getName()
	 * @see #getExperimentParam()
	 * @generated
	 */
	EAttribute getExperimentParam_Name();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.ExperimentParam#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see DNImaster.ExperimentParam#getValue()
	 * @see #getExperimentParam()
	 * @generated
	 */
	EAttribute getExperimentParam_Value();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkStructure <em>Network Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Structure</em>'.
	 * @see DNImaster.NetworkStructure
	 * @generated
	 */
	EClass getNetworkStructure();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.NetworkStructure#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see DNImaster.NetworkStructure#getNodes()
	 * @see #getNetworkStructure()
	 * @generated
	 */
	EReference getNetworkStructure_Nodes();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.NetworkStructure#getLinks <em>Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Links</em>'.
	 * @see DNImaster.NetworkStructure#getLinks()
	 * @see #getNetworkStructure()
	 * @generated
	 */
	EReference getNetworkStructure_Links();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Interface</em>'.
	 * @see DNImaster.NetworkInterface
	 * @generated
	 */
	EClass getNetworkInterface();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.NetworkInterface#getUsedProtocolStack <em>Used Protocol Stack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Used Protocol Stack</em>'.
	 * @see DNImaster.NetworkInterface#getUsedProtocolStack()
	 * @see #getNetworkInterface()
	 * @generated
	 */
	EReference getNetworkInterface_UsedProtocolStack();

	/**
	 * Returns the meta object for class '{@link DNImaster.Node <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Node</em>'.
	 * @see DNImaster.Node
	 * @generated
	 */
	EClass getNode();

	/**
	 * Returns the meta object for the reference list '{@link DNImaster.Node#getSoftware <em>Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Software</em>'.
	 * @see DNImaster.Node#getSoftware()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Software();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.Node#getInterfaces <em>Interfaces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interfaces</em>'.
	 * @see DNImaster.Node#getInterfaces()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Interfaces();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.Node#isIsEndNode <em>Is End Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is End Node</em>'.
	 * @see DNImaster.Node#isIsEndNode()
	 * @see #getNode()
	 * @generated
	 */
	EAttribute getNode_IsEndNode();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.Node#isIsIntermediateNode <em>Is Intermediate Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Intermediate Node</em>'.
	 * @see DNImaster.Node#isIsIntermediateNode()
	 * @see #getNode()
	 * @generated
	 */
	EAttribute getNode_IsIntermediateNode();

	/**
	 * Returns the meta object for class '{@link DNImaster.VirtualNode <em>Virtual Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Node</em>'.
	 * @see DNImaster.VirtualNode
	 * @generated
	 */
	EClass getVirtualNode();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.VirtualNode#getHostedOn <em>Hosted On</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Hosted On</em>'.
	 * @see DNImaster.VirtualNode#getHostedOn()
	 * @see #getVirtualNode()
	 * @generated
	 */
	EReference getVirtualNode_HostedOn();

	/**
	 * Returns the meta object for class '{@link DNImaster.PhysicalNode <em>Physical Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Physical Node</em>'.
	 * @see DNImaster.PhysicalNode
	 * @generated
	 */
	EClass getPhysicalNode();

	/**
	 * Returns the meta object for the reference list '{@link DNImaster.PhysicalNode#getHosts <em>Hosts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Hosts</em>'.
	 * @see DNImaster.PhysicalNode#getHosts()
	 * @see #getPhysicalNode()
	 * @generated
	 */
	EReference getPhysicalNode_Hosts();

	/**
	 * Returns the meta object for class '{@link DNImaster.Link <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link</em>'.
	 * @see DNImaster.Link
	 * @generated
	 */
	EClass getLink();

	/**
	 * Returns the meta object for the reference list '{@link DNImaster.Link#getConnects <em>Connects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Connects</em>'.
	 * @see DNImaster.Link#getConnects()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_Connects();

	/**
	 * Returns the meta object for class '{@link DNImaster.PerformanceSpecification <em>Performance Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Performance Specification</em>'.
	 * @see DNImaster.PerformanceSpecification
	 * @generated
	 */
	EClass getPerformanceSpecification();

	/**
	 * Returns the meta object for class '{@link DNImaster.EndNodePerfSpec <em>End Node Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End Node Perf Spec</em>'.
	 * @see DNImaster.EndNodePerfSpec
	 * @generated
	 */
	EClass getEndNodePerfSpec();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.EndNodePerfSpec#getSoftwareLayersDelay <em>Software Layers Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Software Layers Delay</em>'.
	 * @see DNImaster.EndNodePerfSpec#getSoftwareLayersDelay()
	 * @see #getEndNodePerfSpec()
	 * @generated
	 */
	EReference getEndNodePerfSpec_SoftwareLayersDelay();

	/**
	 * Returns the meta object for class '{@link DNImaster.IntermediateNodePerfSpec <em>Intermediate Node Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Intermediate Node Perf Spec</em>'.
	 * @see DNImaster.IntermediateNodePerfSpec
	 * @generated
	 */
	EClass getIntermediateNodePerfSpec();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.IntermediateNodePerfSpec#getDataplane <em>Dataplane</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Dataplane</em>'.
	 * @see DNImaster.IntermediateNodePerfSpec#getDataplane()
	 * @see #getIntermediateNodePerfSpec()
	 * @generated
	 */
	EReference getIntermediateNodePerfSpec_Dataplane();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.IntermediateNodePerfSpec#getControlplane <em>Controlplane</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Controlplane</em>'.
	 * @see DNImaster.IntermediateNodePerfSpec#getControlplane()
	 * @see #getIntermediateNodePerfSpec()
	 * @generated
	 */
	EReference getIntermediateNodePerfSpec_Controlplane();

	/**
	 * Returns the meta object for class '{@link DNImaster.DataPlanePerfSpec <em>Data Plane Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Plane Perf Spec</em>'.
	 * @see DNImaster.DataPlanePerfSpec
	 * @generated
	 */
	EClass getDataPlanePerfSpec();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.DataPlanePerfSpec#getForwardingLatency <em>Forwarding Latency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Latency</em>'.
	 * @see DNImaster.DataPlanePerfSpec#getForwardingLatency()
	 * @see #getDataPlanePerfSpec()
	 * @generated
	 */
	EReference getDataPlanePerfSpec_ForwardingLatency();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.DataPlanePerfSpec#getForwardingBandwidthPPS <em>Forwarding Bandwidth PPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Bandwidth PPS</em>'.
	 * @see DNImaster.DataPlanePerfSpec#getForwardingBandwidthPPS()
	 * @see #getDataPlanePerfSpec()
	 * @generated
	 */
	EReference getDataPlanePerfSpec_ForwardingBandwidthPPS();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.DataPlanePerfSpec#getForwardingBandwidthBPS <em>Forwarding Bandwidth BPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Bandwidth BPS</em>'.
	 * @see DNImaster.DataPlanePerfSpec#getForwardingBandwidthBPS()
	 * @see #getDataPlanePerfSpec()
	 * @generated
	 */
	EReference getDataPlanePerfSpec_ForwardingBandwidthBPS();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.DataPlanePerfSpec#getPacketProcessingTime <em>Packet Processing Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Processing Time</em>'.
	 * @see DNImaster.DataPlanePerfSpec#getPacketProcessingTime()
	 * @see #getDataPlanePerfSpec()
	 * @generated
	 */
	EReference getDataPlanePerfSpec_PacketProcessingTime();

	/**
	 * Returns the meta object for class '{@link DNImaster.ControlPlanePerfSpec <em>Control Plane Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control Plane Perf Spec</em>'.
	 * @see DNImaster.ControlPlanePerfSpec
	 * @generated
	 */
	EClass getControlPlanePerfSpec();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ControlPlanePerfSpec#getProcessingLatency <em>Processing Latency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Processing Latency</em>'.
	 * @see DNImaster.ControlPlanePerfSpec#getProcessingLatency()
	 * @see #getControlPlanePerfSpec()
	 * @generated
	 */
	EReference getControlPlanePerfSpec_ProcessingLatency();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ControlPlanePerfSpec#getProcessingBandwidthReqPS <em>Processing Bandwidth Req PS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Processing Bandwidth Req PS</em>'.
	 * @see DNImaster.ControlPlanePerfSpec#getProcessingBandwidthReqPS()
	 * @see #getControlPlanePerfSpec()
	 * @generated
	 */
	EReference getControlPlanePerfSpec_ProcessingBandwidthReqPS();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ControlPlanePerfSpec#getPacketProcessingTime <em>Packet Processing Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Processing Time</em>'.
	 * @see DNImaster.ControlPlanePerfSpec#getPacketProcessingTime()
	 * @see #getControlPlanePerfSpec()
	 * @generated
	 */
	EReference getControlPlanePerfSpec_PacketProcessingTime();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkInterfacePerfSpec <em>Network Interface Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Interface Perf Spec</em>'.
	 * @see DNImaster.NetworkInterfacePerfSpec
	 * @generated
	 */
	EClass getNetworkInterfacePerfSpec();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkInterfacePerfSpec#isIsUp <em>Is Up</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Up</em>'.
	 * @see DNImaster.NetworkInterfacePerfSpec#isIsUp()
	 * @see #getNetworkInterfacePerfSpec()
	 * @generated
	 */
	EAttribute getNetworkInterfacePerfSpec_IsUp();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkInterfacePerfSpec#getPacketProcessingTime <em>Packet Processing Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Processing Time</em>'.
	 * @see DNImaster.NetworkInterfacePerfSpec#getPacketProcessingTime()
	 * @see #getNetworkInterfacePerfSpec()
	 * @generated
	 */
	EReference getNetworkInterfacePerfSpec_PacketProcessingTime();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkInterfacePerfSpec#getMTU <em>MTU</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>MTU</em>'.
	 * @see DNImaster.NetworkInterfacePerfSpec#getMTU()
	 * @see #getNetworkInterfacePerfSpec()
	 * @generated
	 */
	EAttribute getNetworkInterfacePerfSpec_MTU();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkInterfacePerfSpec#getInterfaceSpeed <em>Interface Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Speed</em>'.
	 * @see DNImaster.NetworkInterfacePerfSpec#getInterfaceSpeed()
	 * @see #getNetworkInterfacePerfSpec()
	 * @generated
	 */
	EReference getNetworkInterfacePerfSpec_InterfaceSpeed();

	/**
	 * Returns the meta object for class '{@link DNImaster.ElementWithPerformance <em>Element With Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element With Performance</em>'.
	 * @see DNImaster.ElementWithPerformance
	 * @generated
	 */
	EClass getElementWithPerformance();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ElementWithPerformance#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see DNImaster.ElementWithPerformance#getPerformance()
	 * @see #getElementWithPerformance()
	 * @generated
	 */
	EReference getElementWithPerformance_Performance();

	/**
	 * Returns the meta object for class '{@link DNImaster.PhysicalLink <em>Physical Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Physical Link</em>'.
	 * @see DNImaster.PhysicalLink
	 * @generated
	 */
	EClass getPhysicalLink();

	/**
	 * Returns the meta object for class '{@link DNImaster.VirtualLinkPerfSpec <em>Virtual Link Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Link Perf Spec</em>'.
	 * @see DNImaster.VirtualLinkPerfSpec
	 * @generated
	 */
	EClass getVirtualLinkPerfSpec();

	/**
	 * Returns the meta object for class '{@link DNImaster.PhysicalLinkPerfSpec <em>Physical Link Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Physical Link Perf Spec</em>'.
	 * @see DNImaster.PhysicalLinkPerfSpec
	 * @generated
	 */
	EClass getPhysicalLinkPerfSpec();

	/**
	 * Returns the meta object for class '{@link DNImaster.VirtualLink <em>Virtual Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Link</em>'.
	 * @see DNImaster.VirtualLink
	 * @generated
	 */
	EClass getVirtualLink();

	/**
	 * Returns the meta object for class '{@link DNImaster.VirtualNetworkInterfacePerfSpec <em>Virtual Network Interface Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Network Interface Perf Spec</em>'.
	 * @see DNImaster.VirtualNetworkInterfacePerfSpec
	 * @generated
	 */
	EClass getVirtualNetworkInterfacePerfSpec();

	/**
	 * Returns the meta object for class '{@link DNImaster.PhysicalNetworkInterfacePerfSpec <em>Physical Network Interface Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Physical Network Interface Perf Spec</em>'.
	 * @see DNImaster.PhysicalNetworkInterfacePerfSpec
	 * @generated
	 */
	EClass getPhysicalNetworkInterfacePerfSpec();

	/**
	 * Returns the meta object for class '{@link DNImaster.LinkPerfSpec <em>Link Perf Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link Perf Spec</em>'.
	 * @see DNImaster.LinkPerfSpec
	 * @generated
	 */
	EClass getLinkPerfSpec();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.LinkPerfSpec#getPropagationDelay <em>Propagation Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Propagation Delay</em>'.
	 * @see DNImaster.LinkPerfSpec#getPropagationDelay()
	 * @see #getLinkPerfSpec()
	 * @generated
	 */
	EReference getLinkPerfSpec_PropagationDelay();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.LinkPerfSpec#getMaxSupportedBandwidth <em>Max Supported Bandwidth</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Max Supported Bandwidth</em>'.
	 * @see DNImaster.LinkPerfSpec#getMaxSupportedBandwidth()
	 * @see #getLinkPerfSpec()
	 * @generated
	 */
	EReference getLinkPerfSpec_MaxSupportedBandwidth();

	/**
	 * Returns the meta object for class '{@link DNImaster.PhysicalNetworkInterface <em>Physical Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Physical Network Interface</em>'.
	 * @see DNImaster.PhysicalNetworkInterface
	 * @generated
	 */
	EClass getPhysicalNetworkInterface();

	/**
	 * Returns the meta object for class '{@link DNImaster.VirtualNetworkInterface <em>Virtual Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Network Interface</em>'.
	 * @see DNImaster.VirtualNetworkInterface
	 * @generated
	 */
	EClass getVirtualNetworkInterface();

	/**
	 * Returns the meta object for class '{@link DNImaster.EntityAddress <em>Entity Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity Address</em>'.
	 * @see DNImaster.EntityAddress
	 * @generated
	 */
	EClass getEntityAddress();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.EntityAddress#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Address</em>'.
	 * @see DNImaster.EntityAddress#getAddress()
	 * @see #getEntityAddress()
	 * @generated
	 */
	EAttribute getEntityAddress_Address();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.EntityAddress#getAddressGivenBy <em>Address Given By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Address Given By</em>'.
	 * @see DNImaster.EntityAddress#getAddressGivenBy()
	 * @see #getEntityAddress()
	 * @generated
	 */
	EReference getEntityAddress_AddressGivenBy();

	/**
	 * Returns the meta object for class '{@link DNImaster.AddressableEntity <em>Addressable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Addressable Entity</em>'.
	 * @see DNImaster.AddressableEntity
	 * @generated
	 */
	EClass getAddressableEntity();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.AddressableEntity#getAddresses <em>Addresses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Addresses</em>'.
	 * @see DNImaster.AddressableEntity#getAddresses()
	 * @see #getAddressableEntity()
	 * @generated
	 */
	EReference getAddressableEntity_Addresses();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkConfiguration <em>Network Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Configuration</em>'.
	 * @see DNImaster.NetworkConfiguration
	 * @generated
	 */
	EClass getNetworkConfiguration();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkConfiguration#getProtocolsAndStacks <em>Protocols And Stacks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Protocols And Stacks</em>'.
	 * @see DNImaster.NetworkConfiguration#getProtocolsAndStacks()
	 * @see #getNetworkConfiguration()
	 * @generated
	 */
	EReference getNetworkConfiguration_ProtocolsAndStacks();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.NetworkConfiguration#getRoutes <em>Routes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Routes</em>'.
	 * @see DNImaster.NetworkConfiguration#getRoutes()
	 * @see #getNetworkConfiguration()
	 * @generated
	 */
	EReference getNetworkConfiguration_Routes();

	/**
	 * Returns the meta object for class '{@link DNImaster.ProtocolsRepository <em>Protocols Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocols Repository</em>'.
	 * @see DNImaster.ProtocolsRepository
	 * @generated
	 */
	EClass getProtocolsRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.ProtocolsRepository#getStacks <em>Stacks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Stacks</em>'.
	 * @see DNImaster.ProtocolsRepository#getStacks()
	 * @see #getProtocolsRepository()
	 * @generated
	 */
	EReference getProtocolsRepository_Stacks();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.ProtocolsRepository#getProtocols <em>Protocols</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Protocols</em>'.
	 * @see DNImaster.ProtocolsRepository#getProtocols()
	 * @see #getProtocolsRepository()
	 * @generated
	 */
	EReference getProtocolsRepository_Protocols();

	/**
	 * Returns the meta object for class '{@link DNImaster.ProtocolStack <em>Protocol Stack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocol Stack</em>'.
	 * @see DNImaster.ProtocolStack
	 * @generated
	 */
	EClass getProtocolStack();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.ProtocolStack#getLayers <em>Layers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Layers</em>'.
	 * @see DNImaster.ProtocolStack#getLayers()
	 * @see #getProtocolStack()
	 * @generated
	 */
	EReference getProtocolStack_Layers();

	/**
	 * Returns the meta object for class '{@link DNImaster.ProtocolLayer <em>Protocol Layer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocol Layer</em>'.
	 * @see DNImaster.ProtocolLayer
	 * @generated
	 */
	EClass getProtocolLayer();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.ProtocolLayer#getProtocol <em>Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Protocol</em>'.
	 * @see DNImaster.ProtocolLayer#getProtocol()
	 * @see #getProtocolLayer()
	 * @generated
	 */
	EReference getProtocolLayer_Protocol();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.ProtocolLayer#getIsCarriedBy <em>Is Carried By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Is Carried By</em>'.
	 * @see DNImaster.ProtocolLayer#getIsCarriedBy()
	 * @see #getProtocolLayer()
	 * @generated
	 */
	EReference getProtocolLayer_IsCarriedBy();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.ProtocolLayer#getCarries <em>Carries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Carries</em>'.
	 * @see DNImaster.ProtocolLayer#getCarries()
	 * @see #getProtocolLayer()
	 * @generated
	 */
	EReference getProtocolLayer_Carries();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkProtocol <em>Network Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Protocol</em>'.
	 * @see DNImaster.NetworkProtocol
	 * @generated
	 */
	EClass getNetworkProtocol();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkProtocol#getMtu <em>Mtu</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mtu</em>'.
	 * @see DNImaster.NetworkProtocol#getMtu()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_Mtu();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkProtocol#getHeadersLength <em>Headers Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Headers Length</em>'.
	 * @see DNImaster.NetworkProtocol#getHeadersLength()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_HeadersLength();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkProtocol#getDataUnitLength <em>Data Unit Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Unit Length</em>'.
	 * @see DNImaster.NetworkProtocol#getDataUnitLength()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_DataUnitLength();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkProtocol#isConnectionless <em>Connectionless</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Connectionless</em>'.
	 * @see DNImaster.NetworkProtocol#isConnectionless()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_Connectionless();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.NetworkProtocol#isDeliveryGuaranteed <em>Delivery Guaranteed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Delivery Guaranteed</em>'.
	 * @see DNImaster.NetworkProtocol#isDeliveryGuaranteed()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_DeliveryGuaranteed();

	/**
	 * Returns the meta object for class '{@link DNImaster.RoutesRepository <em>Routes Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Routes Repository</em>'.
	 * @see DNImaster.RoutesRepository
	 * @generated
	 */
	EClass getRoutesRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.RoutesRepository#getRoutes <em>Routes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Routes</em>'.
	 * @see DNImaster.RoutesRepository#getRoutes()
	 * @see #getRoutesRepository()
	 * @generated
	 */
	EReference getRoutesRepository_Routes();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.RoutesRepository#getFlowRoutes <em>Flow Routes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Flow Routes</em>'.
	 * @see DNImaster.RoutesRepository#getFlowRoutes()
	 * @see #getRoutesRepository()
	 * @generated
	 */
	EReference getRoutesRepository_FlowRoutes();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.RoutesRepository#getDirections <em>Directions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Directions</em>'.
	 * @see DNImaster.RoutesRepository#getDirections()
	 * @see #getRoutesRepository()
	 * @generated
	 */
	EReference getRoutesRepository_Directions();

	/**
	 * Returns the meta object for class '{@link DNImaster.Direction <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Direction</em>'.
	 * @see DNImaster.Direction
	 * @generated
	 */
	EClass getDirection();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Direction#getOnNode <em>On Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>On Node</em>'.
	 * @see DNImaster.Direction#getOnNode()
	 * @see #getDirection()
	 * @generated
	 */
	EReference getDirection_OnNode();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Direction#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow</em>'.
	 * @see DNImaster.Direction#getFlow()
	 * @see #getDirection()
	 * @generated
	 */
	EReference getDirection_Flow();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Direction#getVia <em>Via</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Via</em>'.
	 * @see DNImaster.Direction#getVia()
	 * @see #getDirection()
	 * @generated
	 */
	EReference getDirection_Via();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.Direction#isIsDefault <em>Is Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Default</em>'.
	 * @see DNImaster.Direction#isIsDefault()
	 * @see #getDirection()
	 * @generated
	 */
	EAttribute getDirection_IsDefault();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.Direction#getDistance <em>Distance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Distance</em>'.
	 * @see DNImaster.Direction#getDistance()
	 * @see #getDirection()
	 * @generated
	 */
	EAttribute getDirection_Distance();

	/**
	 * Returns the meta object for class '{@link DNImaster.FlowRoute <em>Flow Route</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Route</em>'.
	 * @see DNImaster.FlowRoute
	 * @generated
	 */
	EClass getFlowRoute();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.FlowRoute#getHops <em>Hops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hops</em>'.
	 * @see DNImaster.FlowRoute#getHops()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_Hops();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.FlowRoute#getNumHops <em>Num Hops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Num Hops</em>'.
	 * @see DNImaster.FlowRoute#getNumHops()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EAttribute getFlowRoute_NumHops();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.FlowRoute#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow</em>'.
	 * @see DNImaster.FlowRoute#getFlow()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_Flow();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.FlowRoute#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start</em>'.
	 * @see DNImaster.FlowRoute#getStart()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_Start();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.FlowRoute#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>End</em>'.
	 * @see DNImaster.FlowRoute#getEnd()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_End();

	/**
	 * Returns the meta object for class '{@link DNImaster.Route <em>Route</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Route</em>'.
	 * @see DNImaster.Route
	 * @generated
	 */
	EClass getRoute();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.Route#getHops <em>Hops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hops</em>'.
	 * @see DNImaster.Route#getHops()
	 * @see #getRoute()
	 * @generated
	 */
	EReference getRoute_Hops();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.Route#getNumHops <em>Num Hops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Num Hops</em>'.
	 * @see DNImaster.Route#getNumHops()
	 * @see #getRoute()
	 * @generated
	 */
	EAttribute getRoute_NumHops();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Route#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start</em>'.
	 * @see DNImaster.Route#getStart()
	 * @see #getRoute()
	 * @generated
	 */
	EReference getRoute_Start();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Route#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>End</em>'.
	 * @see DNImaster.Route#getEnd()
	 * @see #getRoute()
	 * @generated
	 */
	EReference getRoute_End();

	/**
	 * Returns the meta object for class '{@link DNImaster.Hop <em>Hop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hop</em>'.
	 * @see DNImaster.Hop
	 * @generated
	 */
	EClass getHop();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.Hop#getNextHop <em>Next Hop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Next Hop</em>'.
	 * @see DNImaster.Hop#getNextHop()
	 * @see #getHop()
	 * @generated
	 */
	EReference getHop_NextHop();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Hop#getInterfaceref <em>Interfaceref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interfaceref</em>'.
	 * @see DNImaster.Hop#getInterfaceref()
	 * @see #getHop()
	 * @generated
	 */
	EReference getHop_Interfaceref();

	/**
	 * Returns the meta object for class '{@link DNImaster.NetworkTraffic <em>Network Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Traffic</em>'.
	 * @see DNImaster.NetworkTraffic
	 * @generated
	 */
	EClass getNetworkTraffic();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.NetworkTraffic#getFlows <em>Flows</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Flows</em>'.
	 * @see DNImaster.NetworkTraffic#getFlows()
	 * @see #getNetworkTraffic()
	 * @generated
	 */
	EReference getNetworkTraffic_Flows();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.NetworkTraffic#getSoftware <em>Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Software</em>'.
	 * @see DNImaster.NetworkTraffic#getSoftware()
	 * @see #getNetworkTraffic()
	 * @generated
	 */
	EReference getNetworkTraffic_Software();

	/**
	 * Returns the meta object for class '{@link DNImaster.Flow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow</em>'.
	 * @see DNImaster.Flow
	 * @generated
	 */
	EClass getFlow();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Flow#getDestinationSoftwareComponent <em>Destination Software Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Destination Software Component</em>'.
	 * @see DNImaster.Flow#getDestinationSoftwareComponent()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_DestinationSoftwareComponent();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.Flow#getSourceSoftwareComponent <em>Source Software Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Software Component</em>'.
	 * @see DNImaster.Flow#getSourceSoftwareComponent()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_SourceSoftwareComponent();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.Flow#getDestinationAddresses <em>Destination Addresses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Destination Addresses</em>'.
	 * @see DNImaster.Flow#getDestinationAddresses()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_DestinationAddresses();

	/**
	 * Returns the meta object for class '{@link DNImaster.ONOFFFlow <em>ONOFF Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>ONOFF Flow</em>'.
	 * @see DNImaster.ONOFFFlow
	 * @generated
	 */
	EClass getONOFFFlow();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ONOFFFlow#getONstateIAT <em>ONstate IAT</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>ONstate IAT</em>'.
	 * @see DNImaster.ONOFFFlow#getONstateIAT()
	 * @see #getONOFFFlow()
	 * @generated
	 */
	EReference getONOFFFlow_ONstateIAT();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ONOFFFlow#getONstateDuration <em>ONstate Duration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>ONstate Duration</em>'.
	 * @see DNImaster.ONOFFFlow#getONstateDuration()
	 * @see #getONOFFFlow()
	 * @generated
	 */
	EReference getONOFFFlow_ONstateDuration();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ONOFFFlow#getOFFstateDuration <em>OF Fstate Duration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>OF Fstate Duration</em>'.
	 * @see DNImaster.ONOFFFlow#getOFFstateDuration()
	 * @see #getONOFFFlow()
	 * @generated
	 */
	EReference getONOFFFlow_OFFstateDuration();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.ONOFFFlow#getPacketLength <em>Packet Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Length</em>'.
	 * @see DNImaster.ONOFFFlow#getPacketLength()
	 * @see #getONOFFFlow()
	 * @generated
	 */
	EReference getONOFFFlow_PacketLength();

	/**
	 * Returns the meta object for the attribute '{@link DNImaster.ONOFFFlow#isStartState <em>Start State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start State</em>'.
	 * @see DNImaster.ONOFFFlow#isStartState()
	 * @see #getONOFFFlow()
	 * @generated
	 */
	EAttribute getONOFFFlow_StartState();

	/**
	 * Returns the meta object for class '{@link DNImaster.GenericFlow <em>Generic Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Flow</em>'.
	 * @see DNImaster.GenericFlow
	 * @generated
	 */
	EClass getGenericFlow();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.GenericFlow#getDataSize <em>Data Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Size</em>'.
	 * @see DNImaster.GenericFlow#getDataSize()
	 * @see #getGenericFlow()
	 * @generated
	 */
	EReference getGenericFlow_DataSize();

	/**
	 * Returns the meta object for class '{@link DNImaster.SoftwareComponent <em>Software Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Software Component</em>'.
	 * @see DNImaster.SoftwareComponent
	 * @generated
	 */
	EClass getSoftwareComponent();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.SoftwareComponent#getTrafficSources <em>Traffic Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Traffic Sources</em>'.
	 * @see DNImaster.SoftwareComponent#getTrafficSources()
	 * @see #getSoftwareComponent()
	 * @generated
	 */
	EReference getSoftwareComponent_TrafficSources();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.SoftwareComponent#getDeployedOn <em>Deployed On</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Deployed On</em>'.
	 * @see DNImaster.SoftwareComponent#getDeployedOn()
	 * @see #getSoftwareComponent()
	 * @generated
	 */
	EReference getSoftwareComponent_DeployedOn();

	/**
	 * Returns the meta object for class '{@link DNImaster.TrafficSource <em>Traffic Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Traffic Source</em>'.
	 * @see DNImaster.TrafficSource
	 * @generated
	 */
	EClass getTrafficSource();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.TrafficSource#getWorkload <em>Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Workload</em>'.
	 * @see DNImaster.TrafficSource#getWorkload()
	 * @see #getTrafficSource()
	 * @generated
	 */
	EReference getTrafficSource_Workload();

	/**
	 * Returns the meta object for the container reference '{@link DNImaster.TrafficSource#getSoftwareComponent <em>Software Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Software Component</em>'.
	 * @see DNImaster.TrafficSource#getSoftwareComponent()
	 * @see #getTrafficSource()
	 * @generated
	 */
	EReference getTrafficSource_SoftwareComponent();

	/**
	 * Returns the meta object for class '{@link DNImaster.Workload <em>Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Workload</em>'.
	 * @see DNImaster.Workload
	 * @generated
	 */
	EClass getWorkload();

	/**
	 * Returns the meta object for class '{@link DNImaster.GenericWorkload <em>Generic Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Workload</em>'.
	 * @see DNImaster.GenericWorkload
	 * @generated
	 */
	EClass getGenericWorkload();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.GenericWorkload#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actions</em>'.
	 * @see DNImaster.GenericWorkload#getActions()
	 * @see #getGenericWorkload()
	 * @generated
	 */
	EReference getGenericWorkload_Actions();

	/**
	 * Returns the meta object for class '{@link DNImaster.AbstractAction <em>Abstract Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Action</em>'.
	 * @see DNImaster.AbstractAction
	 * @generated
	 */
	EClass getAbstractAction();

	/**
	 * Returns the meta object for class '{@link DNImaster.BranchAction <em>Branch Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Branch Action</em>'.
	 * @see DNImaster.BranchAction
	 * @generated
	 */
	EClass getBranchAction();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.BranchAction#getIntern <em>Intern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Intern</em>'.
	 * @see DNImaster.BranchAction#getIntern()
	 * @see #getBranchAction()
	 * @generated
	 */
	EReference getBranchAction_Intern();

	/**
	 * Returns the meta object for class '{@link DNImaster.LoopAction <em>Loop Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Action</em>'.
	 * @see DNImaster.LoopAction
	 * @generated
	 */
	EClass getLoopAction();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.LoopAction#getIntern <em>Intern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Intern</em>'.
	 * @see DNImaster.LoopAction#getIntern()
	 * @see #getLoopAction()
	 * @generated
	 */
	EReference getLoopAction_Intern();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.LoopAction#getNumIterations <em>Num Iterations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Num Iterations</em>'.
	 * @see DNImaster.LoopAction#getNumIterations()
	 * @see #getLoopAction()
	 * @generated
	 */
	EReference getLoopAction_NumIterations();

	/**
	 * Returns the meta object for class '{@link DNImaster.SequenceAction <em>Sequence Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sequence Action</em>'.
	 * @see DNImaster.SequenceAction
	 * @generated
	 */
	EClass getSequenceAction();

	/**
	 * Returns the meta object for the containment reference list '{@link DNImaster.SequenceAction#getIntern <em>Intern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Intern</em>'.
	 * @see DNImaster.SequenceAction#getIntern()
	 * @see #getSequenceAction()
	 * @generated
	 */
	EReference getSequenceAction_Intern();

	/**
	 * Returns the meta object for class '{@link DNImaster.StartAction <em>Start Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Start Action</em>'.
	 * @see DNImaster.StartAction
	 * @generated
	 */
	EClass getStartAction();

	/**
	 * Returns the meta object for class '{@link DNImaster.StopAction <em>Stop Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stop Action</em>'.
	 * @see DNImaster.StopAction
	 * @generated
	 */
	EClass getStopAction();

	/**
	 * Returns the meta object for class '{@link DNImaster.TransmitAction <em>Transmit Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Transmit Action</em>'.
	 * @see DNImaster.TransmitAction
	 * @generated
	 */
	EClass getTransmitAction();

	/**
	 * Returns the meta object for the reference '{@link DNImaster.TransmitAction#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow</em>'.
	 * @see DNImaster.TransmitAction#getFlow()
	 * @see #getTransmitAction()
	 * @generated
	 */
	EReference getTransmitAction_Flow();

	/**
	 * Returns the meta object for class '{@link DNImaster.WaitAction <em>Wait Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Wait Action</em>'.
	 * @see DNImaster.WaitAction
	 * @generated
	 */
	EClass getWaitAction();

	/**
	 * Returns the meta object for the containment reference '{@link DNImaster.WaitAction#getWaitTime <em>Wait Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Wait Time</em>'.
	 * @see DNImaster.WaitAction#getWaitTime()
	 * @see #getWaitAction()
	 * @generated
	 */
	EReference getWaitAction_WaitTime();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MasterFactory getMasterFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link DNImaster.NamedElement <em>Named Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.NamedElement
		 * @see DNImaster.impl.MasterPackageImpl#getNamedElement()
		 * @generated
		 */
		EClass NAMED_ELEMENT = eINSTANCE.getNamedElement();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NAMED_ELEMENT__NAME = eINSTANCE.getNamedElement_Name();

		/**
		 * The meta object literal for the '<em><b>Alternative Names</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NAMED_ELEMENT__ALTERNATIVE_NAMES = eINSTANCE.getNamedElement_AlternativeNames();

		/**
		 * The meta object literal for the '{@link DNImaster.Entity <em>Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.Entity
		 * @see DNImaster.impl.MasterPackageImpl#getEntity()
		 * @generated
		 */
		EClass ENTITY = eINSTANCE.getEntity();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__ID = eINSTANCE.getEntity_Id();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.NetworkInfrastructureImpl <em>Network Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.NetworkInfrastructureImpl
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkInfrastructure()
		 * @generated
		 */
		EClass NETWORK_INFRASTRUCTURE = eINSTANCE.getNetworkInfrastructure();

		/**
		 * The meta object literal for the '<em><b>Traffic</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__TRAFFIC = eINSTANCE.getNetworkInfrastructure_Traffic();

		/**
		 * The meta object literal for the '<em><b>Structure</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__STRUCTURE = eINSTANCE.getNetworkInfrastructure_Structure();

		/**
		 * The meta object literal for the '<em><b>Configuration</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__CONFIGURATION = eINSTANCE.getNetworkInfrastructure_Configuration();

		/**
		 * The meta object literal for the '<em><b>Params</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__PARAMS = eINSTANCE.getNetworkInfrastructure_Params();

		/**
		 * The meta object literal for the '<em><b>Data Center Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INFRASTRUCTURE__DATA_CENTER_NAME = eINSTANCE.getNetworkInfrastructure_DataCenterName();

		/**
		 * The meta object literal for the '<em><b>Data Center Alt Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INFRASTRUCTURE__DATA_CENTER_ALT_NAME = eINSTANCE.getNetworkInfrastructure_DataCenterAltName();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.ExperimentParamImpl <em>Experiment Param</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.ExperimentParamImpl
		 * @see DNImaster.impl.MasterPackageImpl#getExperimentParam()
		 * @generated
		 */
		EClass EXPERIMENT_PARAM = eINSTANCE.getExperimentParam();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPERIMENT_PARAM__NAME = eINSTANCE.getExperimentParam_Name();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPERIMENT_PARAM__VALUE = eINSTANCE.getExperimentParam_Value();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.NetworkStructureImpl <em>Network Structure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.NetworkStructureImpl
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkStructure()
		 * @generated
		 */
		EClass NETWORK_STRUCTURE = eINSTANCE.getNetworkStructure();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_STRUCTURE__NODES = eINSTANCE.getNetworkStructure_Nodes();

		/**
		 * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_STRUCTURE__LINKS = eINSTANCE.getNetworkStructure_Links();

		/**
		 * The meta object literal for the '{@link DNImaster.NetworkInterface <em>Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.NetworkInterface
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkInterface()
		 * @generated
		 */
		EClass NETWORK_INTERFACE = eINSTANCE.getNetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Used Protocol Stack</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE__USED_PROTOCOL_STACK = eINSTANCE.getNetworkInterface_UsedProtocolStack();

		/**
		 * The meta object literal for the '{@link DNImaster.Node <em>Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.Node
		 * @see DNImaster.impl.MasterPackageImpl#getNode()
		 * @generated
		 */
		EClass NODE = eINSTANCE.getNode();

		/**
		 * The meta object literal for the '<em><b>Software</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__SOFTWARE = eINSTANCE.getNode_Software();

		/**
		 * The meta object literal for the '<em><b>Interfaces</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__INTERFACES = eINSTANCE.getNode_Interfaces();

		/**
		 * The meta object literal for the '<em><b>Is End Node</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NODE__IS_END_NODE = eINSTANCE.getNode_IsEndNode();

		/**
		 * The meta object literal for the '<em><b>Is Intermediate Node</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NODE__IS_INTERMEDIATE_NODE = eINSTANCE.getNode_IsIntermediateNode();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.VirtualNodeImpl <em>Virtual Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.VirtualNodeImpl
		 * @see DNImaster.impl.MasterPackageImpl#getVirtualNode()
		 * @generated
		 */
		EClass VIRTUAL_NODE = eINSTANCE.getVirtualNode();

		/**
		 * The meta object literal for the '<em><b>Hosted On</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VIRTUAL_NODE__HOSTED_ON = eINSTANCE.getVirtualNode_HostedOn();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.PhysicalNodeImpl <em>Physical Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.PhysicalNodeImpl
		 * @see DNImaster.impl.MasterPackageImpl#getPhysicalNode()
		 * @generated
		 */
		EClass PHYSICAL_NODE = eINSTANCE.getPhysicalNode();

		/**
		 * The meta object literal for the '<em><b>Hosts</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PHYSICAL_NODE__HOSTS = eINSTANCE.getPhysicalNode_Hosts();

		/**
		 * The meta object literal for the '{@link DNImaster.Link <em>Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.Link
		 * @see DNImaster.impl.MasterPackageImpl#getLink()
		 * @generated
		 */
		EClass LINK = eINSTANCE.getLink();

		/**
		 * The meta object literal for the '<em><b>Connects</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__CONNECTS = eINSTANCE.getLink_Connects();

		/**
		 * The meta object literal for the '{@link DNImaster.PerformanceSpecification <em>Performance Specification</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.PerformanceSpecification
		 * @see DNImaster.impl.MasterPackageImpl#getPerformanceSpecification()
		 * @generated
		 */
		EClass PERFORMANCE_SPECIFICATION = eINSTANCE.getPerformanceSpecification();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.EndNodePerfSpecImpl <em>End Node Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.EndNodePerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getEndNodePerfSpec()
		 * @generated
		 */
		EClass END_NODE_PERF_SPEC = eINSTANCE.getEndNodePerfSpec();

		/**
		 * The meta object literal for the '<em><b>Software Layers Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END_NODE_PERF_SPEC__SOFTWARE_LAYERS_DELAY = eINSTANCE.getEndNodePerfSpec_SoftwareLayersDelay();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.IntermediateNodePerfSpecImpl <em>Intermediate Node Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.IntermediateNodePerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getIntermediateNodePerfSpec()
		 * @generated
		 */
		EClass INTERMEDIATE_NODE_PERF_SPEC = eINSTANCE.getIntermediateNodePerfSpec();

		/**
		 * The meta object literal for the '<em><b>Dataplane</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_NODE_PERF_SPEC__DATAPLANE = eINSTANCE.getIntermediateNodePerfSpec_Dataplane();

		/**
		 * The meta object literal for the '<em><b>Controlplane</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_NODE_PERF_SPEC__CONTROLPLANE = eINSTANCE.getIntermediateNodePerfSpec_Controlplane();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.DataPlanePerfSpecImpl <em>Data Plane Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.DataPlanePerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getDataPlanePerfSpec()
		 * @generated
		 */
		EClass DATA_PLANE_PERF_SPEC = eINSTANCE.getDataPlanePerfSpec();

		/**
		 * The meta object literal for the '<em><b>Forwarding Latency</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_PLANE_PERF_SPEC__FORWARDING_LATENCY = eINSTANCE.getDataPlanePerfSpec_ForwardingLatency();

		/**
		 * The meta object literal for the '<em><b>Forwarding Bandwidth PPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_PLANE_PERF_SPEC__FORWARDING_BANDWIDTH_PPS = eINSTANCE.getDataPlanePerfSpec_ForwardingBandwidthPPS();

		/**
		 * The meta object literal for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_PLANE_PERF_SPEC__FORWARDING_BANDWIDTH_BPS = eINSTANCE.getDataPlanePerfSpec_ForwardingBandwidthBPS();

		/**
		 * The meta object literal for the '<em><b>Packet Processing Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_PLANE_PERF_SPEC__PACKET_PROCESSING_TIME = eINSTANCE.getDataPlanePerfSpec_PacketProcessingTime();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.ControlPlanePerfSpecImpl <em>Control Plane Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.ControlPlanePerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getControlPlanePerfSpec()
		 * @generated
		 */
		EClass CONTROL_PLANE_PERF_SPEC = eINSTANCE.getControlPlanePerfSpec();

		/**
		 * The meta object literal for the '<em><b>Processing Latency</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTROL_PLANE_PERF_SPEC__PROCESSING_LATENCY = eINSTANCE.getControlPlanePerfSpec_ProcessingLatency();

		/**
		 * The meta object literal for the '<em><b>Processing Bandwidth Req PS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTROL_PLANE_PERF_SPEC__PROCESSING_BANDWIDTH_REQ_PS = eINSTANCE.getControlPlanePerfSpec_ProcessingBandwidthReqPS();

		/**
		 * The meta object literal for the '<em><b>Packet Processing Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTROL_PLANE_PERF_SPEC__PACKET_PROCESSING_TIME = eINSTANCE.getControlPlanePerfSpec_PacketProcessingTime();

		/**
		 * The meta object literal for the '{@link DNImaster.NetworkInterfacePerfSpec <em>Network Interface Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.NetworkInterfacePerfSpec
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkInterfacePerfSpec()
		 * @generated
		 */
		EClass NETWORK_INTERFACE_PERF_SPEC = eINSTANCE.getNetworkInterfacePerfSpec();

		/**
		 * The meta object literal for the '<em><b>Is Up</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INTERFACE_PERF_SPEC__IS_UP = eINSTANCE.getNetworkInterfacePerfSpec_IsUp();

		/**
		 * The meta object literal for the '<em><b>Packet Processing Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE_PERF_SPEC__PACKET_PROCESSING_TIME = eINSTANCE.getNetworkInterfacePerfSpec_PacketProcessingTime();

		/**
		 * The meta object literal for the '<em><b>MTU</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INTERFACE_PERF_SPEC__MTU = eINSTANCE.getNetworkInterfacePerfSpec_MTU();

		/**
		 * The meta object literal for the '<em><b>Interface Speed</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE_PERF_SPEC__INTERFACE_SPEED = eINSTANCE.getNetworkInterfacePerfSpec_InterfaceSpeed();

		/**
		 * The meta object literal for the '{@link DNImaster.ElementWithPerformance <em>Element With Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.ElementWithPerformance
		 * @see DNImaster.impl.MasterPackageImpl#getElementWithPerformance()
		 * @generated
		 */
		EClass ELEMENT_WITH_PERFORMANCE = eINSTANCE.getElementWithPerformance();

		/**
		 * The meta object literal for the '<em><b>Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ELEMENT_WITH_PERFORMANCE__PERFORMANCE = eINSTANCE.getElementWithPerformance_Performance();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.PhysicalLinkImpl <em>Physical Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.PhysicalLinkImpl
		 * @see DNImaster.impl.MasterPackageImpl#getPhysicalLink()
		 * @generated
		 */
		EClass PHYSICAL_LINK = eINSTANCE.getPhysicalLink();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.VirtualLinkPerfSpecImpl <em>Virtual Link Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.VirtualLinkPerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getVirtualLinkPerfSpec()
		 * @generated
		 */
		EClass VIRTUAL_LINK_PERF_SPEC = eINSTANCE.getVirtualLinkPerfSpec();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.PhysicalLinkPerfSpecImpl <em>Physical Link Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.PhysicalLinkPerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getPhysicalLinkPerfSpec()
		 * @generated
		 */
		EClass PHYSICAL_LINK_PERF_SPEC = eINSTANCE.getPhysicalLinkPerfSpec();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.VirtualLinkImpl <em>Virtual Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.VirtualLinkImpl
		 * @see DNImaster.impl.MasterPackageImpl#getVirtualLink()
		 * @generated
		 */
		EClass VIRTUAL_LINK = eINSTANCE.getVirtualLink();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.VirtualNetworkInterfacePerfSpecImpl <em>Virtual Network Interface Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.VirtualNetworkInterfacePerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getVirtualNetworkInterfacePerfSpec()
		 * @generated
		 */
		EClass VIRTUAL_NETWORK_INTERFACE_PERF_SPEC = eINSTANCE.getVirtualNetworkInterfacePerfSpec();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.PhysicalNetworkInterfacePerfSpecImpl <em>Physical Network Interface Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.PhysicalNetworkInterfacePerfSpecImpl
		 * @see DNImaster.impl.MasterPackageImpl#getPhysicalNetworkInterfacePerfSpec()
		 * @generated
		 */
		EClass PHYSICAL_NETWORK_INTERFACE_PERF_SPEC = eINSTANCE.getPhysicalNetworkInterfacePerfSpec();

		/**
		 * The meta object literal for the '{@link DNImaster.LinkPerfSpec <em>Link Perf Spec</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.LinkPerfSpec
		 * @see DNImaster.impl.MasterPackageImpl#getLinkPerfSpec()
		 * @generated
		 */
		EClass LINK_PERF_SPEC = eINSTANCE.getLinkPerfSpec();

		/**
		 * The meta object literal for the '<em><b>Propagation Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_PERF_SPEC__PROPAGATION_DELAY = eINSTANCE.getLinkPerfSpec_PropagationDelay();

		/**
		 * The meta object literal for the '<em><b>Max Supported Bandwidth</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_PERF_SPEC__MAX_SUPPORTED_BANDWIDTH = eINSTANCE.getLinkPerfSpec_MaxSupportedBandwidth();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.PhysicalNetworkInterfaceImpl <em>Physical Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.PhysicalNetworkInterfaceImpl
		 * @see DNImaster.impl.MasterPackageImpl#getPhysicalNetworkInterface()
		 * @generated
		 */
		EClass PHYSICAL_NETWORK_INTERFACE = eINSTANCE.getPhysicalNetworkInterface();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.VirtualNetworkInterfaceImpl <em>Virtual Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.VirtualNetworkInterfaceImpl
		 * @see DNImaster.impl.MasterPackageImpl#getVirtualNetworkInterface()
		 * @generated
		 */
		EClass VIRTUAL_NETWORK_INTERFACE = eINSTANCE.getVirtualNetworkInterface();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.EntityAddressImpl <em>Entity Address</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.EntityAddressImpl
		 * @see DNImaster.impl.MasterPackageImpl#getEntityAddress()
		 * @generated
		 */
		EClass ENTITY_ADDRESS = eINSTANCE.getEntityAddress();

		/**
		 * The meta object literal for the '<em><b>Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY_ADDRESS__ADDRESS = eINSTANCE.getEntityAddress_Address();

		/**
		 * The meta object literal for the '<em><b>Address Given By</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_ADDRESS__ADDRESS_GIVEN_BY = eINSTANCE.getEntityAddress_AddressGivenBy();

		/**
		 * The meta object literal for the '{@link DNImaster.AddressableEntity <em>Addressable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.AddressableEntity
		 * @see DNImaster.impl.MasterPackageImpl#getAddressableEntity()
		 * @generated
		 */
		EClass ADDRESSABLE_ENTITY = eINSTANCE.getAddressableEntity();

		/**
		 * The meta object literal for the '<em><b>Addresses</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADDRESSABLE_ENTITY__ADDRESSES = eINSTANCE.getAddressableEntity_Addresses();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.NetworkConfigurationImpl <em>Network Configuration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.NetworkConfigurationImpl
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkConfiguration()
		 * @generated
		 */
		EClass NETWORK_CONFIGURATION = eINSTANCE.getNetworkConfiguration();

		/**
		 * The meta object literal for the '<em><b>Protocols And Stacks</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_CONFIGURATION__PROTOCOLS_AND_STACKS = eINSTANCE.getNetworkConfiguration_ProtocolsAndStacks();

		/**
		 * The meta object literal for the '<em><b>Routes</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_CONFIGURATION__ROUTES = eINSTANCE.getNetworkConfiguration_Routes();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.ProtocolsRepositoryImpl <em>Protocols Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.ProtocolsRepositoryImpl
		 * @see DNImaster.impl.MasterPackageImpl#getProtocolsRepository()
		 * @generated
		 */
		EClass PROTOCOLS_REPOSITORY = eINSTANCE.getProtocolsRepository();

		/**
		 * The meta object literal for the '<em><b>Stacks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOLS_REPOSITORY__STACKS = eINSTANCE.getProtocolsRepository_Stacks();

		/**
		 * The meta object literal for the '<em><b>Protocols</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOLS_REPOSITORY__PROTOCOLS = eINSTANCE.getProtocolsRepository_Protocols();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.ProtocolStackImpl <em>Protocol Stack</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.ProtocolStackImpl
		 * @see DNImaster.impl.MasterPackageImpl#getProtocolStack()
		 * @generated
		 */
		EClass PROTOCOL_STACK = eINSTANCE.getProtocolStack();

		/**
		 * The meta object literal for the '<em><b>Layers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_STACK__LAYERS = eINSTANCE.getProtocolStack_Layers();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.ProtocolLayerImpl <em>Protocol Layer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.ProtocolLayerImpl
		 * @see DNImaster.impl.MasterPackageImpl#getProtocolLayer()
		 * @generated
		 */
		EClass PROTOCOL_LAYER = eINSTANCE.getProtocolLayer();

		/**
		 * The meta object literal for the '<em><b>Protocol</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_LAYER__PROTOCOL = eINSTANCE.getProtocolLayer_Protocol();

		/**
		 * The meta object literal for the '<em><b>Is Carried By</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_LAYER__IS_CARRIED_BY = eINSTANCE.getProtocolLayer_IsCarriedBy();

		/**
		 * The meta object literal for the '<em><b>Carries</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_LAYER__CARRIES = eINSTANCE.getProtocolLayer_Carries();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.NetworkProtocolImpl <em>Network Protocol</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.NetworkProtocolImpl
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkProtocol()
		 * @generated
		 */
		EClass NETWORK_PROTOCOL = eINSTANCE.getNetworkProtocol();

		/**
		 * The meta object literal for the '<em><b>Mtu</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__MTU = eINSTANCE.getNetworkProtocol_Mtu();

		/**
		 * The meta object literal for the '<em><b>Headers Length</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__HEADERS_LENGTH = eINSTANCE.getNetworkProtocol_HeadersLength();

		/**
		 * The meta object literal for the '<em><b>Data Unit Length</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__DATA_UNIT_LENGTH = eINSTANCE.getNetworkProtocol_DataUnitLength();

		/**
		 * The meta object literal for the '<em><b>Connectionless</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__CONNECTIONLESS = eINSTANCE.getNetworkProtocol_Connectionless();

		/**
		 * The meta object literal for the '<em><b>Delivery Guaranteed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__DELIVERY_GUARANTEED = eINSTANCE.getNetworkProtocol_DeliveryGuaranteed();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.RoutesRepositoryImpl <em>Routes Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.RoutesRepositoryImpl
		 * @see DNImaster.impl.MasterPackageImpl#getRoutesRepository()
		 * @generated
		 */
		EClass ROUTES_REPOSITORY = eINSTANCE.getRoutesRepository();

		/**
		 * The meta object literal for the '<em><b>Routes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTES_REPOSITORY__ROUTES = eINSTANCE.getRoutesRepository_Routes();

		/**
		 * The meta object literal for the '<em><b>Flow Routes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTES_REPOSITORY__FLOW_ROUTES = eINSTANCE.getRoutesRepository_FlowRoutes();

		/**
		 * The meta object literal for the '<em><b>Directions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTES_REPOSITORY__DIRECTIONS = eINSTANCE.getRoutesRepository_Directions();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.DirectionImpl <em>Direction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.DirectionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getDirection()
		 * @generated
		 */
		EClass DIRECTION = eINSTANCE.getDirection();

		/**
		 * The meta object literal for the '<em><b>On Node</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DIRECTION__ON_NODE = eINSTANCE.getDirection_OnNode();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DIRECTION__FLOW = eINSTANCE.getDirection_Flow();

		/**
		 * The meta object literal for the '<em><b>Via</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DIRECTION__VIA = eINSTANCE.getDirection_Via();

		/**
		 * The meta object literal for the '<em><b>Is Default</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DIRECTION__IS_DEFAULT = eINSTANCE.getDirection_IsDefault();

		/**
		 * The meta object literal for the '<em><b>Distance</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DIRECTION__DISTANCE = eINSTANCE.getDirection_Distance();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.FlowRouteImpl <em>Flow Route</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.FlowRouteImpl
		 * @see DNImaster.impl.MasterPackageImpl#getFlowRoute()
		 * @generated
		 */
		EClass FLOW_ROUTE = eINSTANCE.getFlowRoute();

		/**
		 * The meta object literal for the '<em><b>Hops</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__HOPS = eINSTANCE.getFlowRoute_Hops();

		/**
		 * The meta object literal for the '<em><b>Num Hops</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLOW_ROUTE__NUM_HOPS = eINSTANCE.getFlowRoute_NumHops();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__FLOW = eINSTANCE.getFlowRoute_Flow();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__START = eINSTANCE.getFlowRoute_Start();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__END = eINSTANCE.getFlowRoute_End();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.RouteImpl <em>Route</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.RouteImpl
		 * @see DNImaster.impl.MasterPackageImpl#getRoute()
		 * @generated
		 */
		EClass ROUTE = eINSTANCE.getRoute();

		/**
		 * The meta object literal for the '<em><b>Hops</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTE__HOPS = eINSTANCE.getRoute_Hops();

		/**
		 * The meta object literal for the '<em><b>Num Hops</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ROUTE__NUM_HOPS = eINSTANCE.getRoute_NumHops();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTE__START = eINSTANCE.getRoute_Start();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTE__END = eINSTANCE.getRoute_End();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.HopImpl <em>Hop</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.HopImpl
		 * @see DNImaster.impl.MasterPackageImpl#getHop()
		 * @generated
		 */
		EClass HOP = eINSTANCE.getHop();

		/**
		 * The meta object literal for the '<em><b>Next Hop</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOP__NEXT_HOP = eINSTANCE.getHop_NextHop();

		/**
		 * The meta object literal for the '<em><b>Interfaceref</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOP__INTERFACEREF = eINSTANCE.getHop_Interfaceref();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.NetworkTrafficImpl <em>Network Traffic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.NetworkTrafficImpl
		 * @see DNImaster.impl.MasterPackageImpl#getNetworkTraffic()
		 * @generated
		 */
		EClass NETWORK_TRAFFIC = eINSTANCE.getNetworkTraffic();

		/**
		 * The meta object literal for the '<em><b>Flows</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_TRAFFIC__FLOWS = eINSTANCE.getNetworkTraffic_Flows();

		/**
		 * The meta object literal for the '<em><b>Software</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_TRAFFIC__SOFTWARE = eINSTANCE.getNetworkTraffic_Software();

		/**
		 * The meta object literal for the '{@link DNImaster.Flow <em>Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.Flow
		 * @see DNImaster.impl.MasterPackageImpl#getFlow()
		 * @generated
		 */
		EClass FLOW = eINSTANCE.getFlow();

		/**
		 * The meta object literal for the '<em><b>Destination Software Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__DESTINATION_SOFTWARE_COMPONENT = eINSTANCE.getFlow_DestinationSoftwareComponent();

		/**
		 * The meta object literal for the '<em><b>Source Software Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__SOURCE_SOFTWARE_COMPONENT = eINSTANCE.getFlow_SourceSoftwareComponent();

		/**
		 * The meta object literal for the '<em><b>Destination Addresses</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__DESTINATION_ADDRESSES = eINSTANCE.getFlow_DestinationAddresses();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.ONOFFFlowImpl <em>ONOFF Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.ONOFFFlowImpl
		 * @see DNImaster.impl.MasterPackageImpl#getONOFFFlow()
		 * @generated
		 */
		EClass ONOFF_FLOW = eINSTANCE.getONOFFFlow();

		/**
		 * The meta object literal for the '<em><b>ONstate IAT</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ONOFF_FLOW__ONSTATE_IAT = eINSTANCE.getONOFFFlow_ONstateIAT();

		/**
		 * The meta object literal for the '<em><b>ONstate Duration</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ONOFF_FLOW__ONSTATE_DURATION = eINSTANCE.getONOFFFlow_ONstateDuration();

		/**
		 * The meta object literal for the '<em><b>OF Fstate Duration</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ONOFF_FLOW__OF_FSTATE_DURATION = eINSTANCE.getONOFFFlow_OFFstateDuration();

		/**
		 * The meta object literal for the '<em><b>Packet Length</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ONOFF_FLOW__PACKET_LENGTH = eINSTANCE.getONOFFFlow_PacketLength();

		/**
		 * The meta object literal for the '<em><b>Start State</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ONOFF_FLOW__START_STATE = eINSTANCE.getONOFFFlow_StartState();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.GenericFlowImpl <em>Generic Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.GenericFlowImpl
		 * @see DNImaster.impl.MasterPackageImpl#getGenericFlow()
		 * @generated
		 */
		EClass GENERIC_FLOW = eINSTANCE.getGenericFlow();

		/**
		 * The meta object literal for the '<em><b>Data Size</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_FLOW__DATA_SIZE = eINSTANCE.getGenericFlow_DataSize();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.SoftwareComponentImpl <em>Software Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.SoftwareComponentImpl
		 * @see DNImaster.impl.MasterPackageImpl#getSoftwareComponent()
		 * @generated
		 */
		EClass SOFTWARE_COMPONENT = eINSTANCE.getSoftwareComponent();

		/**
		 * The meta object literal for the '<em><b>Traffic Sources</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SOFTWARE_COMPONENT__TRAFFIC_SOURCES = eINSTANCE.getSoftwareComponent_TrafficSources();

		/**
		 * The meta object literal for the '<em><b>Deployed On</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SOFTWARE_COMPONENT__DEPLOYED_ON = eINSTANCE.getSoftwareComponent_DeployedOn();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.TrafficSourceImpl <em>Traffic Source</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.TrafficSourceImpl
		 * @see DNImaster.impl.MasterPackageImpl#getTrafficSource()
		 * @generated
		 */
		EClass TRAFFIC_SOURCE = eINSTANCE.getTrafficSource();

		/**
		 * The meta object literal for the '<em><b>Workload</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRAFFIC_SOURCE__WORKLOAD = eINSTANCE.getTrafficSource_Workload();

		/**
		 * The meta object literal for the '<em><b>Software Component</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRAFFIC_SOURCE__SOFTWARE_COMPONENT = eINSTANCE.getTrafficSource_SoftwareComponent();

		/**
		 * The meta object literal for the '{@link DNImaster.Workload <em>Workload</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.Workload
		 * @see DNImaster.impl.MasterPackageImpl#getWorkload()
		 * @generated
		 */
		EClass WORKLOAD = eINSTANCE.getWorkload();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.GenericWorkloadImpl <em>Generic Workload</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.GenericWorkloadImpl
		 * @see DNImaster.impl.MasterPackageImpl#getGenericWorkload()
		 * @generated
		 */
		EClass GENERIC_WORKLOAD = eINSTANCE.getGenericWorkload();

		/**
		 * The meta object literal for the '<em><b>Actions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_WORKLOAD__ACTIONS = eINSTANCE.getGenericWorkload_Actions();

		/**
		 * The meta object literal for the '{@link DNImaster.AbstractAction <em>Abstract Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.AbstractAction
		 * @see DNImaster.impl.MasterPackageImpl#getAbstractAction()
		 * @generated
		 */
		EClass ABSTRACT_ACTION = eINSTANCE.getAbstractAction();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.BranchActionImpl <em>Branch Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.BranchActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getBranchAction()
		 * @generated
		 */
		EClass BRANCH_ACTION = eINSTANCE.getBranchAction();

		/**
		 * The meta object literal for the '<em><b>Intern</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCH_ACTION__INTERN = eINSTANCE.getBranchAction_Intern();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.LoopActionImpl <em>Loop Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.LoopActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getLoopAction()
		 * @generated
		 */
		EClass LOOP_ACTION = eINSTANCE.getLoopAction();

		/**
		 * The meta object literal for the '<em><b>Intern</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_ACTION__INTERN = eINSTANCE.getLoopAction_Intern();

		/**
		 * The meta object literal for the '<em><b>Num Iterations</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_ACTION__NUM_ITERATIONS = eINSTANCE.getLoopAction_NumIterations();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.SequenceActionImpl <em>Sequence Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.SequenceActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getSequenceAction()
		 * @generated
		 */
		EClass SEQUENCE_ACTION = eINSTANCE.getSequenceAction();

		/**
		 * The meta object literal for the '<em><b>Intern</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEQUENCE_ACTION__INTERN = eINSTANCE.getSequenceAction_Intern();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.StartActionImpl <em>Start Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.StartActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getStartAction()
		 * @generated
		 */
		EClass START_ACTION = eINSTANCE.getStartAction();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.StopActionImpl <em>Stop Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.StopActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getStopAction()
		 * @generated
		 */
		EClass STOP_ACTION = eINSTANCE.getStopAction();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.TransmitActionImpl <em>Transmit Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.TransmitActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getTransmitAction()
		 * @generated
		 */
		EClass TRANSMIT_ACTION = eINSTANCE.getTransmitAction();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRANSMIT_ACTION__FLOW = eINSTANCE.getTransmitAction_Flow();

		/**
		 * The meta object literal for the '{@link DNImaster.impl.WaitActionImpl <em>Wait Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see DNImaster.impl.WaitActionImpl
		 * @see DNImaster.impl.MasterPackageImpl#getWaitAction()
		 * @generated
		 */
		EClass WAIT_ACTION = eINSTANCE.getWaitAction();

		/**
		 * The meta object literal for the '<em><b>Wait Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WAIT_ACTION__WAIT_TIME = eINSTANCE.getWaitAction_WaitTime();

	}

} //MasterPackage
